// elements.png 64 27
// LEFT_TOP_CORNER  | OFFSET: 0000 0000 | SIZE: 0010 0009
// LEFT_BTM_CORNER  | OFFSET: 0000 0011 | SIZE: 0010 0009
// CONNECTOR_TOP    | OFFSET: 0011 0000 | SIZE: 0017 0009
// CONNECTOR_BTM    | OFFSET: 0011 0011 | SIZE: 0017 0016
// RIGHT_BTM_CORNER | OFFSET: 0029 0011 | SIZE: 0010 0009
// RIGHT_TOP_CORNER | OFFSET: 0029 0001 | SIZE: 0010 0009

function GuiControl::getLeft(%this)   { return getWord(%this.getPosition(), 0); }
function GuiControl::getTop(%this)    { return getWord(%this.getPosition(), 1); }
function GuiControl::getRight(%this)  { return getWord(%this.getPosition(), 0)+getWord(%this.getExtent(), 0); }
function GuiControl::getBottom(%this) { return getWord(%this.getPosition(), 1)+getWord(%this.getExtent(), 1); }
function GuiControl::getWidth(%this) { return getWord(%this.getExtent(), 0); }
function GuiControl::getHeight(%this) { return getWord(%this.getExtent(), 1); }

if(!isObject(ScratchContainer)) new SimSet(ScratchContainer);

function Scratch::createContainerContainer(%hasTopConnector, %hasBottomConnector) {
	%newObj = new GuiSwatchCtrl(ScratchContainerBlock) {
		profile = "GuiScratchNoModalProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "136 107";
		extent = "64 73";
		minExtent = "64 73";
		visible = "1";
		color = "0 0 0 0";
		type  = "ScratchBlock";
		container = 1;
		top = (%hasTopConnector ? 1 : 0);
		bottom = (%hasBottomConnector ? 1 : 0);
		status = "UPDATE";

		new GuiSwatchCtrl(TEMP_ONE) {
				profile = "GuiScratchNoModalProfile";
				horizSizing = "width";
				vertSizing = "bottom";
				position = "0 0";
				extent = "63 29";
				minExtent = "10 29";
				visible = "1";
				color = "0 0 0 0";
				type = "ScratchBlock";
				top = 1;
				bottom = 1;

				new GuiBitmapCtrl() {
						profile = "GuiDefaultProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "0 0";
						extent = "10 9";
						minExtent = "8 2";
						visible = "1";
						bitmap = "Add-Ons/Client_Scratch/img/elements";
						wrap = "1";
						lockAspectRatio = "0";
						alignLeft = "0";
						overflowImage = "0";
						keepCached = "0";
						Ignore = "1";
						type = "topleft";
						background = "1";
				};
				new GuiBitmapCtrl() {
						profile = "GuiDefaultProfile";
						horizSizing = "right";
						vertSizing = "top";
						position = "27 13";
						extent = "17 16";
						minExtent = "8 2";
						visible = "1";
						bitmap = "Add-Ons/Client_Scratch/img/elements";
						wrap = "1";
						lockAspectRatio = "0";
						alignLeft = "0";
						overflowImage = "0";
						keepCached = "0";
						Ignore = "1";
						type = "bottomconnector";
						background = "1";
				};
				new GuiBitmapCtrl() {
						profile = "GuiDefaultProfile";
						horizSizing = "left";
						vertSizing = "top";
						position = "53 13";
						extent = "10 9";
						minExtent = "8 2";
						visible = "1";
						bitmap = "Add-Ons/Client_Scratch/img/elements";
						wrap = "1";
						lockAspectRatio = "0";
						alignLeft = "0";
						overflowImage = "0";
						keepCached = "0";
						Ignore = "1";
						type = "bottomright";
						background = "1";
				};
				new GuiBitmapCtrl() {
						profile = "GuiDefaultProfile";
						horizSizing = "left";
						vertSizing = "bottom";
						position = "53 0";
						extent = "10 9";
						minExtent = "8 2";
						visible = "1";
						bitmap = "Add-Ons/Client_Scratch/img/elements";
						wrap = "1";
						lockAspectRatio = "0";
						alignLeft = "0";
						overflowImage = "0";
						keepCached = "0";
						Ignore = "1";
						type = "topright";
						background = "1";
				};
				new GuiSwatchCtrl() {
						profile = "GuiDefaultProfile";
						horizSizing = "width";
						vertSizing = "height";
						position = "0 9";
						extent = "63 4";
						minExtent = "8 2";
						visible = "1";
						color = "255 0 0 255";
						Ignore = "1";
						background = "1";
				};
				new GuiSwatchCtrl() {
						profile = "GuiDefaultProfile";
						horizSizing = "width";
						vertSizing = "height";
						position = "10 0";
						extent = "43 22";
						minExtent = "8 2";
						visible = "1";
						color = "255 0 0 255";
						Ignore = "1";
						background = "1";
				};
				new GuiBitmapCtrl() {
						profile = "GuiDefaultProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "13 0";
						extent = "17 9";
						minExtent = "8 2";
						visible = "1";
						bitmap = "Add-Ons/Client_Scratch/img/elements";
						wrap = "1";
						lockAspectRatio = "0";
						alignLeft = "0";
						overflowImage = "0";
						keepCached = "0";
						Ignore = "1";
						type = "topconnector";
						background = "1";
				};
				new GuiBitmapCtrl() {
						profile = "GuiDefaultProfile";
						horizSizing = "right";
						vertSizing = "top";
						position = "14 22";
						extent = "10 9";
						minExtent = "8 2";
						visible = "1";
						bitmap = "Add-Ons/Client_Scratch/img/elements";
						wrap = "1";
						lockAspectRatio = "0";
						alignLeft = "0";
						overflowImage = "0";
						keepCached = "0";
						Ignore = "1";
						type = "innertop";
						background = "1";
				};
		};
		new GuiSwatchCtrl(TEMP_TWO) {
				profile = "GuiScratchNoModalProfile";
				horizSizing = "width";
				vertSizing = "top";
				position = "0 36";
				extent = "63 37";
				minExtent = "10 29";
				visible = "1";
				color = "0 0 0 0";
				top  = 1;
				type = "ScratchBlock";
				bottom = 1;

				new GuiBitmapCtrl() {
						profile = "GuiScratchNoModalProfile";
						horizSizing = "right";
						vertSizing = "top";
						position = "-7 21";
						extent = "17 16";
						minExtent = "8 2";
						visible = "1";
						bitmap = "Add-Ons/Client_Scratch/img/elements";
						wrap = "1";
						lockAspectRatio = "0";
						alignLeft = "0";
						overflowImage = "0";
						keepCached = "0";
						Ignore = "1";
						type = "bottomconnector";
						background = "1";
				};
				new GuiBitmapCtrl() {
						profile = "GuiScratchNoModalProfile";
						horizSizing = "right";
						vertSizing = "top";
						position = "0 21";
						extent = "10 9";
						minExtent = "8 2";
						visible = "1";
						bitmap = "Add-Ons/Client_Scratch/img/elements";
						wrap = "1";
						lockAspectRatio = "0";
						alignLeft = "0";
						overflowImage = "0";
						keepCached = "0";
						Ignore = "1";
						type = "bottomleft";
						background = "1";
				};
				new GuiBitmapCtrl() {
						profile = "GuiScratchNoModalProfile";
						horizSizing = "left";
						vertSizing = "top";
						position = "53 21";
						extent = "10 9";
						minExtent = "8 2";
						visible = "1";
						bitmap = "Add-Ons/Client_Scratch/img/elements";
						wrap = "1";
						lockAspectRatio = "0";
						alignLeft = "0";
						overflowImage = "0";
						keepCached = "0";
						Ignore = "1";
						type = "bottomright";
						background = "1";
				};
				new GuiBitmapCtrl() {
						profile = "GuiScratchNoModalProfile";
						horizSizing = "left";
						vertSizing = "bottom";
						position = "53 9";
						extent = "10 9";
						minExtent = "8 2";
						visible = "1";
						bitmap = "Add-Ons/Client_Scratch/img/elements";
						wrap = "1";
						lockAspectRatio = "0";
						alignLeft = "0";
						overflowImage = "0";
						keepCached = "0";
						Ignore = "1";
						type = "topright";
						background = "1";
				};
				new GuiSwatchCtrl(CenterXFiller) {
						profile = "GuiScratchNoModalProfile";
						horizSizing = "width";
						vertSizing = "height";
						position = "0 18";
						extent = "63 4";
						minExtent = "8 2";
						visible = "1";
						color = "255 0 0 255";
						Ignore = "1";
						background = "1";
				};
				new GuiSwatchCtrl(CenterYFiller) {
						profile = "GuiScratchNoModalProfile";
						horizSizing = "width";
						vertSizing = "height";
						position = "10 9";
						extent = "43 21";
						minExtent = "8 2";
						visible = "1";
						color = "255 0 0 255";
						Ignore = "1";
						background = "1";
				};
				new GuiBitmapCtrl() {
						profile = "GuiScratchNoModalProfile";
						horizSizing = "right";
						vertSizing = "top";
						position = "14 0";
						extent = "10 9";
						minExtent = "8 2";
						visible = "1";
						bitmap = "Add-Ons/Client_Scratch/img/elements";
						wrap = "1";
						lockAspectRatio = "0";
						alignLeft = "0";
						overflowImage = "0";
						keepCached = "0";
						Ignore = "1";
						type = "innerbottom";
						background = "1";
				};
		};
		new GuiSwatchCtrl(TEMP_BAR) {
				profile = "GuiScratchNoModalProfile";
				horizSizing = "right";
				vertSizing = "height";
				position = "0 13";
				extent = "14 41";
				minExtent = "10 2";
				visible = "1";
				color = "255 0 0 255";
		};
	};
	// Scan and set block settings for block 1
	%newObj.barConnector = TEMP_BAR.getId(); TEMP_BAR.setName("");
	%obj = TEMP_ONE;
	for(%i=0;%i<%obj.getCount();%i++) {
		%child = %obj.getObject(%i);
		if(%child.type $= "bottomconnector") { %obj.bottomConnector = %child; }
		if(%child.type $= "topconnector") { %tc = %obj.topConnector = %child; %newObj.topConnector = %child; }
	}
	// Scan and set block settings for block 2
	%obj = TEMP_TWO;
	for(%i=0;%i<%obj.getCount();%i++) {
		%child = %obj.getObject(%i);
		switch$(%child.type) {
			case "bottomconnector": %bc = %obj.bottomConnector = %child; %newObj.bottomConnector = %child;
			case "topconnector": %obj.topConnector = %child;
			case "bottomleft": %bl = %child;
			case "bottomright": %br = %child;
		}
	}
	// Connector preferences
	%xf = CenterXFiller.getId(); %xf.setName("");
	%yf = CenterYFiller.getId(); %yf.setName("");
	if(!%hasBottomConnector) {
		%obj.bottomConnector = "";
		%newObj.bottomConnector = "";
		%bc.delete();
		%bl.resize(0, getWord(%obj.getExtent(), 1)-getWord(%bl.getExtent(), 1), getWord(%bl.getExtent(), 0), getWord(%bl.getExtent(), 1));
		%br.resize(getWord(%obj.getExtent(), 0)-getWord(%br.getExtent(), 0), getWord(%obj.getExtent(), 1)-getWord(%br.getExtent(), 1), getWord(%br.getExtent(), 0), getWord(%br.getExtent(), 1));
		%xf.resize(0, 18, getWord(%obj.getExtent(), 0), getWord(%obj.getExtent(), 1)-27);
		%yf.resize(10, 9, getWord(%obj.getExtent(), 0)-20, getWord(%obj.getExtent(), 1));
	}
	if(!%hasTopConnector) %tc.delete();
	%newObj.container0 = TEMP_ONE.getId();
	%newObj.container1 = TEMP_TWO.getId();
	TEMP_ONE.setName("");
	TEMP_TWO.setName("");
	%control        = new GuiMouseEventCtrl(ScratchBlockMouseEvent) { horizSizing = "width"; vertSizing = "height"; position = "0 0"; extent = "63 29"; ignore = 1; };
	%newObj.control = %control;
	%newObj.add(%control);
	ScratchContainer.add(%newObj);
	Scratch::setColor(%newObj, "0.647059 0.647059 0.647059 1");
	return %newObj;
}
function Scratch::createContainer(%hasTopConnector, %hasBottomConnector) {
	%newObj = new GuiSwatchCtrl("ScratchContainerBlock") {
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "87 311";
		extent = "174 27";
		minExtent = "10 29";
		visible = "1";
		color = "0 0 0 0";
		type = "ScratchBlock";
		status = "UPDATE";
		new GuiBitmapCtrl(topleft) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "10 9";
			minExtent = "8 2";
			visible = "1";
			bitmap = "Add-Ons/Client_Scratch/img/elements";
			wrap = "1";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			keepCached = "0";
			type = "topleft";
			ignore      = 1;
			background  = 1;
		};
		new GuiBitmapCtrl(bottomleft) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "0 11";
			extent = "10 9";
			minExtent = "8 2";
			visible = "1";
			bitmap = "Add-Ons/Client_Scratch/img/elements";
			wrap = "1";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			keepCached = "0";
			type = "bottomleft";
			ignore      = 1;
			background  = 1;
		};
		new GuiBitmapCtrl(bottomright) {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = "164 11";
			extent = "10 9";
			minExtent = "8 2";
			visible = "1";
			bitmap = "Add-Ons/Client_Scratch/img/elements";
			wrap = "1";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			keepCached = "0";
			type = "bottomright";
			ignore      = 1;
			background  = 1;
		};
		new GuiBitmapCtrl(topright) {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "164 0";
			extent = "10 9";
			minExtent = "8 2";
			visible = "1";
			bitmap = "Add-Ons/Client_Scratch/img/elements";
			wrap = "1";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			keepCached = "0";
			type = "topright";
			ignore      = 1;
			background  = 1;
		};
		new GuiSwatchCtrl(centerXfiller) {
			profile = "GuiDefaultProfile";
			horizSizing = "width";
			vertSizing = "height";
			position = "0 9";
			extent = "174 2";
			minExtent = "8 2";
			visible = "1";
			color = "255 255 255 255";
			ignore      = 1;
			background  = 1;
		};
		new GuiSwatchCtrl(centerYfiller) {
			profile = "GuiDefaultProfile";
			horizSizing = "width";
			vertSizing = "height";
			position = "10 0";
			extent = "154 20";
			minExtent = "8 2";
			visible = "1";
			color = "255 255 255 255";
			ignore      = 1;
			background  = 1;
		};
		new GuiBitmapCtrl(topconnector) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "13 0";
			extent = "17 9";
			minExtent = "8 2";
			visible = "1";
			bitmap = "Add-Ons/Client_Scratch/img/elements";
			wrap = "1";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			keepCached = "0";
			type = "topconnector";
			ignore      = 1;
			background  = 1;
		};
		new GuiBitmapCtrl(bottomconnector) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "13 11";
			extent = "17 16";
			minExtent = "8 2";
			visible = "1";
			bitmap = "Add-Ons/Client_Scratch/img/elements";
			wrap = "1";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			keepCached = "0";
			type = "bottomconnector";
			ignore      = 1;
			background  = 1;
		};
	};
	%tl = topleft.getID();			%tl.setName(""); %tl.setValue((64/2)+0000, (27/2)+0000);
	%bl = bottomleft.getID();		%bl.setName(""); %bl.setValue((64/2)+0000, (27/2)+0011);
	%tr = topright.getID();			%tr.setName(""); %tr.setValue((64/2)+0029, (27/2)+0001);
	%br = bottomright.getID();		%br.setName(""); %br.setValue((64/2)+0029, (27/2)+0011);
	%tc = topconnector.getID();		%tc.setName(""); %tc.setValue((64/2)+0011, (27/2)+0000);
	%bc = bottomconnector.getID();		%bc.setName(""); %bc.setValue((64/2)+0011, (27/2)+0011);
	%xf = centerXfiller.getID();		%xf.setName(""); // left to right
	%yf = centerYfiller.getID();		%yf.setName(""); // up to down
	%control                = new GuiMouseEventCtrl(ScratchBlockMouseEvent) { horizSizing = "width"; vertSizing = "height"; position = "0 0"; extent = "174 20"; ignore = 1; };
	%newObj.top             = (%hasTopConnector ? "1" : "0");
	%newObj.bottom          = (%hasBottomConnector ? "1" : "0");
	%newObj.bottomConnector = (%hasBottomConnector ? %bc : 0);
	%newObj.topConnector    = (%hasTopConnector ? %tc : 0);
	%newObj.control         = %control;
	%newObj.add(%control);
	// %hasTopConnector, %hasBottomConnector
	if(!%hasBottomConnector) {
		%bc.delete();
		%bl.resize(0, getWord(%newObj.getExtent(), 1)-getWord(%bl.getExtent(), 1), getWord(%bl.getExtent(), 0), getWord(%bl.getExtent(), 1));
		%br.resize(getWord(%newObj.getExtent(), 0)-getWord(%br.getExtent(), 0), getWord(%newObj.getExtent(), 1)-getWord(%br.getExtent(), 1), getWord(%br.getExtent(), 0), getWord(%br.getExtent(), 1));
		%xf.resize(0, 9, getWord(%newObj.getExtent(), 0), getWord(%newObj.getExtent(), 1)-18);
		%yf.resize(10, 0, getWord(%newObj.getExtent(), 0)-20, getWord(%newObj.getExtent(), 1));
		%control.resize(0, 0, getWord(%newObj.getExtent(), 0), getWord(%newObj.getExtent(), 1));
	}
	if(!%hasTopConnector) %tc.delete();
	ScratchContainer.add(%newObj);
	Scratch::setColor(%newObj, "0.647059 0.647059 0.647059 1");
	return %newObj;
}

function Scratch::blinkError(%this, %stage, %original) {
	if(%original $= "") %original = %this;
	if(!isObject(%this)) return;
	if(isObject(%this.innerConnection_Parent)) {
		%inner = %this.innerConnection_Parent.getGroup();
		while(isObject(%inner)) {
			%this  = %inner;
			if(!isObject(%this.innerConnection_Parent)) break;
			%inner = %this.innerConnection_Parent.getGroup();
		}
	}
	if(isObject(%top = %this.topConnection)) {
		while(isObject(%top)) {
			%this  = %top;
			%top   = %this.topConnection;
		}
	}
	// Get size of this block
	if(isObject(%btm = %this.bottomConnection)) {
		%maxX = %this.getWidth();
		%maxY = %this.getHeight();
		while(isObject(%btm)) {
			if(%btm.getWidth() > %maxX) %maxX = %btm.getWidth();
			%maxY += %btm.getHeight();
			%btm   = %btm.bottomConnection;
		}
	}
	if(!isObject(%obj = $CACHE::Scratch::ErrorObject[%this.getGroup()])) {
		%obj = $CACHE::Scratch::ErrorObject[%this.getGroup()] = new GuiSwatchCtrl() {
			profile   = "GuiScratchNoModalProfile";
			minExtent = "1 1";
			color     = "255 0 0 255";
		};
		Scratch_Content.add(%obj);
	}
	switch(%stage) {
		case 0: %obj.setVisible(1); Scratch::setGlow(%original, 50);
		case 1: %obj.setVisible(0); Scratch::setGlow(%original, 00);
		case 2: %obj.setVisible(1); Scratch::setGlow(%original, 50);
		case 3: %obj.setVisible(0); Scratch::setGlow(%original, 00);
		case 4: %obj.setVisible(1); Scratch::setGlow(%original, 50);
		case 5: %obj.setVisible(0); Scratch::setGlow(%original, 00); Scratch_Content.pushToBack(%obj); %obj.schedule(1, delete); return;
	}
	%x = Scratch_Content.getGroup().getLeft()+1;
	%y = Scratch_Content.getGroup().getTop()+1;
	%obj.resize(%this.getLeft()-3, %this.getTop()-3, %maxX+6, %maxY);
	Scratch_Content.bringToFront(%obj);
	cancel($CACHE::Scratch::ErrorSchedule[%this.getGroup()]);
	$CACHE::Scratch::ErrorSchedule[%this.getGroup()] = schedule(500, 0, eval, "Scratch::blinkError(" @ %this @ "," @ %stage++ @ ",\"" @ %original @ "\");");
}

function Scratch::createPlaceholder() {
	%newObj = new GuiSwatchCtrl() {
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "29 24";
		minExtent = "29 24";
		visible = "1";
		color = "0 0 0 0";
		type = "ScratchArgPlaceHolder";
		new GuiBitmapCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "11 9";
			minExtent = "8 2";
			visible = "1";
			bitmap = "Add-Ons/Client_Scratch/img/elements";
			wrap = "1";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			keepCached = "0";
			Ignore = "1";
			type = "topleft";
			background  = 1;
		};
		new GuiBitmapCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "0 15";
			extent = "11 9";
			minExtent = "8 2";
			visible = "1";
			bitmap = "Add-Ons/Client_Scratch/img/elements";
			wrap = "1";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			keepCached = "0";
			Ignore = "1";
			type = "bottomleft";
			background  = 1;
		};
		new GuiBitmapCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = "18 15";
			extent = "11 9";
			minExtent = "8 2";
			visible = "1";
			bitmap = "Add-Ons/Client_Scratch/img/elements";
			wrap = "1";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			keepCached = "0";
			Ignore = "1";
			type = "bottomright";
			background  = 1;
		};
		new GuiBitmapCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "18 0";
			extent = "11 9";
			minExtent = "8 2";
			visible = "1";
			bitmap = "Add-Ons/Client_Scratch/img/elements";
			wrap = "1";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			keepCached = "0";
			Ignore = "1";
			type = "topright";
			background  = 1;
		};
		new GuiSwatchCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "width";
			vertSizing = "height";
			position = "1 9";
			extent = "27 6";
			minExtent = "8 2";
			visible = "1";
			color = "255 255 255 255";
			Ignore = "1";
			background  = 1;
		};
		new GuiSwatchCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "width";
			vertSizing = "height";
			position = "10 0";
			extent = "8 24";
			minExtent = "8 2";
			visible = "1";
			color = "255 255 255 255";
			Ignore = "1";
			background  = 1;
		};
	};
	return %newObj;
}

function Scratch::setBlockOffsets(%this, %type) {
	if(!isObject(%this)) return;
	if(%this.container) {
		Scratch::setBlockOffsets(%this.container0);
		Scratch::setBlockOffsets(%this.container1);
		return;
	}
	if(%this.type $= "ScratchBlock") {
		%type["topleft"]         = "0000 0001";
		%type["bottomleft"]      = "0000 0011";
		%type["topright"]        = "0029 0001";
		%type["bottomright"]     = "0029 0011";
		%type["topconnector"]    = "0011 0001";
		%type["bottomconnector"] = "0011 0012";
		%type["innertop"]        = "0074 0011";
		%type["innerbottom"]     = "0074 0001";
	} else if(%this.type $= "ScratchArgPlaceholder") {
		%type["topleft"]         = "0040 0001";
		%type["bottomleft"]      = "0040 0011";
		%type["topright"]        = "0052 0001";
		%type["bottomright"]     = "0052 0011";
	}
	for(%i=0;%i<%this.getCount();%i++) {
		%obj = %this.getObject(%i);
		if(%obj.getClassName() !$= "GuiBitmapCtrl" || %obj.type $= "") continue;
		if(!%obj.background) continue;
		%off = %type[%obj.type];
		%obj.setValue((84/2)+atoi(getWord(%off, 0)), (27/2)+atoi(getWord(%off, 1)));
	}
}

function Scratch::setColor(%this, %color, %doNotMakeDefault) {
	if(!isObject(%this)) return;
	if(!%doNotMakeDefault) {
		%this.scratchColor_RGB = mFloor(getWord(%color,0)*255) SPC mFloor(getWord(%color,1)*255) SPC mFloor(getWord(%color,2)*255) SPC mFloor(getWord(%color,3)*255);
		%this.scratchColor_HSV = %color;
	}
	if(%this.container) {
		%this.barConnector.color = mFloor(getWord(%color,0)*255) SPC mFloor(getWord(%color,1)*255) SPC mFloor(getWord(%color,2)*255) SPC mFloor(getWord(%color,3)*255);
		Scratch::setColor(%this.container0, %color);
		Scratch::setColor(%this.container1, %color);
		return;
	}
	for(%i=0;%i<%this.getCount();%i++) {
		%obj = %this.getObject(%i);
		if(%obj.getClassName() $= "GuiSwatchCtrl") {
			%obj.color = mFloor(getWord(%color,0)*255) SPC mFloor(getWord(%color,1)*255) SPC mFloor(getWord(%color,2)*255) SPC mFloor(getWord(%color,3)*255);
			continue;
		} else if(%obj.getClassName() $= "GuiBitmapCtrl") %obj.setColor(%color);
	}
}

function Scratch::setGlow(%this, %amt) {
	if(!isObject(%this)) return;
	%amt = mClamp(%amt, 0, 100);
	%add = mFloor((%amt/100)*255);
	%col = mClamp(%add+getWord(%this.scratchColor_RGB, 0), 0, 255)/255 SPC mClamp(%add+getWord(%this.scratchColor_RGB, 1), 0, 255)/255 SPC mClamp(%add+getWord(%this.scratchColor_RGB, 2), 1, 255)/255 SPC "1";
	Scratch::setColor(%this, %col, 1);
}

function Scratch::createPremadeBlock(%type, %args, %dep, %duplicated) {
	// %hybrid: "<typeid>(TypeID of block that is the hybrid) <string>(args)"
	%ifIndent = 20;
	switch(%type) {
		case 0: // FUNCTION BLOCK
			%blockType  = "";
			%container  = Scratch::createContainer(0, 1);
			Scratch::setColor(%container, "0.984314 0.572549 0.168627 1");
			%argToolTip = "Declare a function named \"%1\" with the arguments\"%@\".";
			%argArgStr  = "string function \tany_noFormatting\tstring (\tdelims_noFormatting\tstring ) {";
			%argBuffer  = "string <color:FFE762>function<color:ffffff>\tinput Func_Name\tdelim[\\,,2]";
			%addAfterC  = "2"; // TYPEID : Add after creation -- Adds delimiters after creation (and makes them undeleteable)
			%hybrid     = "21";
			%argValids  = "string only_at[0~1~abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\\_] notempty\tblock[_3_] canbeempty";
		case 1: // CALL FUNC BLOCK
			if(!getWord(%args, 0)) {
				%blockType = "INPUTBLOCK";
				%container = Scratch::createContainer(0, 0);
			} else {
				%blockType = "";
				%container = Scratch::createContainer(1, 1);
			}
			%hybrid     = "1 " @ (%blockType $= "INPUTBLOCK" ? "1" : "0");
			Scratch::setColor(%container, "0.984314 0.572549 0.168627 1");
			%argToolTip = "Call a function named \"%1\" with the arguments \"%@\".";
			%argArgStr  = "any_noFormatting\tstring (\tdelims\tstring )";
			%argBuffer  = "string <color:ffffff>call\tinput funcName\tdelim[\\,,0]";
			%addAfterC  = "0";
			%argValids  = "string only_at[0~1~abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\\_] notempty\tany";
		case 2: // SET VAR BLOCK
			switch$(%args) {
				case "0": 
					%argToolTip = "Increment %1 by 1.";
					%argBuffer  = "blockInput argName\tstring[def,def,20] <color:AFBFD2>++";
					%argArgStr  = "any\tstring ++";
				case "1":
					%argToolTip = "Decrement %1 by 1.";
					%argBuffer  = "blockInput argName\tstring[def,def,20] <color:AFBFD2>- -";
					%argArgStr  = "any\tstring --";
				case "2":
					%argToolTip = "Set %1 to %2.";
					%argBuffer  = "blockInput argName\tstring[def,def,20] <color:AFBFD2>=\tanyInput varValue";
					%argArgStr  = "any\tstring  = \tany";
				case "3":
					%argToolTip = "Increment %1 by %2.";
					%argBuffer  = "blockInput argName\tstring[def,def,20] <color:AFBFD2>+=\tanyInput varValue";
					%argArgStr  = "any\tstring  += \tany";
				case "4":
					%argToolTip = "Decrement %1 by %2.";
					%argBuffer  = "blockInput argName\tstring[def,def,20] <color:AFBFD2>-=\tanyInput varValue";
					%argArgStr  = "any\tstring  -= \tany";
				case "5":
					%argToolTip = "Multiply %1 by %2.";
					%argBuffer  = "blockInput argName\tstring[def,def,20] <color:AFBFD2>*=\tanyInput varValue";
					%argArgStr  = "any\tstring  *= \tany";
				case "6":
					%argToolTip = "Divide %1 by %2.";
					%argBuffer  = "blockInput argName\tstring[def,def,20] <color:AFBFD2>/=\tanyInput varValue";
					%argArgStr  = "any\tstring  /= \tany";
				case "7":
					%argToolTip = "Modulate %1 by %2.";
					%argBuffer  = "blockInput argName\tstring[def,def,20] <color:AFBFD2>%=\tanyInput varValue";
					%argArgStr  = "any\tstring  %= \tany";
				default:
					error("ERROR: Scratch::createPremadeBlock() - Invalid variable set type '" @ getWord(%args, 0) @ "'.");
					return 0;
			}
			%argValids = "notempty\tany";
			%hybrid    = "27" SPC %args;
			%blockType = "";
			%container = Scratch::createContainer(1, 1);
			Scratch::setColor(%container, "0.309804 0.403922 0.505882 1");
		case 3: // LOCAL VARIABLE BLOCK
			%blockType  = "INPUTBLOCK";
			%container  = Scratch::createContainer(0, 0);
			%argToolTip = "A local variable named \"%1\". This does not persist between functions.";
			%argArgStr  = "string %\tany_noFormatting";
			%argBuffer  = "string[7,def,12,def,1] <color:FF77A8>%\tanyInput valueName";
			%argValids  = "string only_at[0~1~abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\\_] only[abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\\_0123456789]";
			if(%args $= "array") {
				%argToolTip = "A local variable named \"%1\" in the array \"%2\". This does not persist between functions.";
				%argArgStr  = "string %\tany_noFormatting\tstring [\tany\tstring ]";
				%argBuffer  = "string[7,def,12,def,1] <color:FF77A8>%\tanyInput valueName\tstring <color:FF77A8>in array\tanyInput valueArray";
				%argValids  = "string only_at[0~1~abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\\_] only[abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\\_0123456789]\tany";
			}
			Scratch::setColor(%container, "0.898039 0.231373 0.266667 1");
		case 4: // GLOBAL VARIABLE BLOCK
			%blockType  = "INPUTBLOCK";
			%container  = Scratch::createContainer(0, 0);
			%argToolTip = "A global variable named \"%1\". This persists between functions.";
			%argArgStr  = "string $\tany_noFormatting";
			%argBuffer  = "string[7,def,12,def,1] <color:FF77A8>$\tanyInput valueName";
			%argValids  = "string only_at[0~1~abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\\_] only[abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\\_0123456789]";
			if(%args $= "array") {
				%argToolTip = "A global variable named \"%1\" in the array \"%2\". This persists between functions.";
				%argArgStr  = "string $\tany_noFormatting\tstring [\tany\tstring ]";
				%argBuffer  = "string[7,def,12,def,1] <color:FF77A8>$\tanyInput valueName\tstring <color:FF77A8>in array\tanyInput valueArray";
				%argValids  = "string only_at[0~1~abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\\_] only[abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\\_0123456789]\tany";
			}
			Scratch::setColor(%container, "0.898039 0.231373 0.266667 1");
		case 5: // STRING CONCANTENATION
			%blockType  = "INPUTBLOCK";
			%container  = Scratch::createContainer(0, 0);
			Scratch::setColor(%container, "0.619608 0.156863 0.207843 1");
			%argToolTip = "Combine string \"%1\" and \"%@\"";
			%argArgStr  = "any\tstring  @ \tdelims";
			%argBuffer  = "anyInput varName\tstring[def,def,12,def] <color:3F2832>@\tdelim[@,0]";
			%addAfterC  = "0";
			%argValids  = "notempty any\tnotempty any";
		case 6: // ARITHMETIC OPERATION
			switch$(getWord(%args, 0)) { // Catch blank %args
				case "0": %op = "+"; %argToolTip = "Add %1 to %1.";
				case "1": %op = "-"; %argToolTip = "Subtract %1 by %1.";
				case "2": %op = "*"; %argToolTip = "Multiply %1 by %1.";
				case "3": %op = "/"; %argToolTip = "Divide %1 by %1.";
				case "4": %op = "%"; %argToolTip = "Modulate %1 by %1.";
				default:
					error("ERROR: Scratch::createPremadeBlock() - Invalid arithmetic operator type '" @ getWord(%args, 0) @ "'.");
					return 0;
			}
			%blockType = "INPUTBLOCK";
			%container = Scratch::createContainer(0, 0);
			%container.operator = %op;
			Scratch::setColor(%container, "0.494118 0.145098 0.32549 1");
			%argArgStr = "string (\tany\tstring  " @ %op @ " \tany\tstring )";
			%argBuffer = "anyInput statementOne\tstring <color:3F2832>" @ %op @ "\tanyInput statementTwo";
			%argValids = "notempty any\tnotempty any";
		case 7: // RETURN BLOCK
			%blockType  = "";
			%container  = Scratch::createContainer(1, 0);
			Scratch::setColor(%container, "0.984314 0.572549 0.168627 1");
			%argToolTip = "Stop the function and return \"%1\".";
			%argArgStr  = "string return \tany";
			%argBuffer  = "string <color:FFE762>return<color:ffffff>\tanyInput value";
			%argValids  = "notempty any";
		case 8: // ARGUMENT DELIMITER
			return 0;
		case 9: // STRING CONCANTENATION (SPC)
			%blockType  = "INPUTBLOCK";
			%container  = Scratch::createContainer(0, 0);
			Scratch::setColor(%container, "0.619608 0.156863 0.207843 1");
			%argToolTip = "Combine string \"%1\" and \"%@\" and seperate them by a space.";
			%argArgStr  = "any\tstring  SPC \tdelims";
			%argBuffer  = "anyInput varName\tstring[def,def,27,def] <color:3F2832>SPC\tdelim[SPC,0]";
			%addAfterC  = "0";
			%argValids  = "notempty any\tnotempty any";
		case 10: // STRING CONCANTENATION (TAB)
			%blockType  = "INPUTBLOCK";
			%container  = Scratch::createContainer(0, 0);
			Scratch::setColor(%container, "0.619608 0.156863 0.207843 1");
			%argToolTip = "Combine string \"%1\" and \"%@\" and seperate them by a TAB.";
			%argArgStr  = "any\tstring  TAB \tdelims";
			%argBuffer  = "anyInput varName\tstring[def,def,27,def] <color:3F2832>TAB\tdelim[TAB,0]";
			%addAfterC  = "0";
			%argValids  = "notempty any\tnotempty any";
		case 11: // STRING CONCANTENATION (NL)
			%blockType  = "INPUTBLOCK";
			%container  = Scratch::createContainer(0, 0);
			Scratch::setColor(%container, "0.619608 0.156863 0.207843 1");
			%argToolTip = "Combine string \"%1\" and \"%@\" and seperate them by a new line.";
			%argArgStr  = "any\tstring  NL \tdelims";
			%argBuffer  = "anyInput varName\tstring[def,def,27,def] <color:3F2832>NL\tdelim[NL,0]";
			%addAfterC  = "0";
			%argValids  = "notempty any\tnotempty any";
		case 12: // IF BLOCK
			%blockType  = "";
			%container  = Scratch::createContainerContainer(1, 1);
			//%container  = Scratch::createContainer(1, 1);
			Scratch::setColor(%container, "0.721569 0.435294 0.313725 1");
			%argToolTip = "If \"%1\" evaluates to 'true', then the code below this block will execute.";
			%argBuffer  = "string <color:FFFFFF>if<color:ffffff>\tanyInput expression";
			%bc         = %container.bottomConnector;
			%argArgStr  = "string if(\tany\tstring ) {";
			%bc.resize(%bc.getLeft()+%ifIndent, %bc.getTop(), %bc.getWidth(), %bc.getHeight());
			%argValids  = "block[_16_3_4_35_30_31_] notempty";
		case 13: // IF BLOCK END
			%blockType  = "";
			%container  = Scratch::createContainer(1, 1);
			Scratch::setColor(%container, "0.721569 0.435294 0.313725 1");
			%argToolTip = "Ends an IF statement.";
			%argBuffer  = "string <color:FFFFFF>end if<color:ffffff>";
			%tc         = %container.topConnector;
			%argArgStr  = "string }";
			%tc.resize(%tc.getLeft()+%ifIndent, %tc.getTop(), %tc.getWidth(), %tc.getHeight());
		case 14: // ELSE IF BLOCK
			%blockType  = "";
			%container  = Scratch::createContainer(1, 1);
			Scratch::setColor(%container, "0.721569 0.435294 0.313725 1");
			%argToolTip = "If \"%1\" evaluates to 'true', then the code below this block will execute, provided that the initial IF statement evaluates to 'false'.";
			%argArgStr  = "string } else if(\tany\tstring ) {";
			%argBuffer  = "string <color:FFFFFF>else if<color:ffffff>\tanyInput expression";
			%bc         = %container.bottomConnector;
			%bc.resize(%bc.getLeft()+%ifIndent, %bc.getTop(), %bc.getWidth(), %bc.getHeight());
			%tc         = %container.topConnector;
			%tc.resize(%tc.getLeft()+%ifIndent, %tc.getTop(), %tc.getWidth(), %tc.getHeight());
		case 15: // ELSE BLOCK
			%blockType  = "";
			%container  = Scratch::createContainer(1, 1);
			Scratch::setColor(%container, "0.721569 0.435294 0.313725 1");
			%argToolTip = "If the initial IF statement evaluates to 'false' and all subsequent ELSE IF statements evaluate to 'false', then the code below this block will execute.";
			%argArgStr  = "string } else {";
			%argBuffer  = "string <color:FFFFFF>else";
			%bc         = %container.bottomConnector;
			%bc.resize(%bc.getLeft()+%ifIndent, %bc.getTop(), %bc.getWidth(), %bc.getHeight());
			%tc         = %container.topConnector;
			%tc.resize(%tc.getLeft()+%ifIndent, %tc.getTop(), %tc.getWidth(), %tc.getHeight());
		case 16: // LOGICAL COMPARISON BLOCK
			%normal = 1;
			switch$(getWord(%args, 0)) { // Catch blank %args
				case "0": %op = "==";  %argToolTip = "Returns 'true' if \"%1\" equals \"%2\", numerically.";
				case "1": %op = "!=";  %argToolTip = "Returns 'true' if \"%1\" does not equal \"%2\", numerically.";
				case "2": %op = "$=";  %argToolTip = "Returns 'true' if \"%1\" equals \"%2\".";
				case "3": %op = "!$="; %argToolTip = "Returns 'true' if \"%1\" does not equal \"%2\".";
				case "4": %op = ">=";  %argToolTip = "Returns 'true' if \"%1\" is greater than or equal to \"%2\".";
				case "5": %op = "<=";  %argToolTip = "Returns 'true' if \"%1\" is less than or equal to \"%2\".";
				case "6": %op = ">";   %argToolTip = "Returns 'true' if \"%1\" is greater than \"%2\".";
				case "7": %op = "<";   %argToolTip = "Returns 'true' if \"%1\" is less than \"%2\".";
				case "8":
					%argToolTip = "Returns 'true' if \"%1\" is 'false'.";
					%argArgStr  = "string !(\tany\tstring )";
					%argBuffer  = "string <color:FFFFFF>!\tanyInput expressionOne";
					%normal     = 0;
				default:
					error("ERROR: Scratch::createPremadeBlock() - Invalid logical comparison type '" @ getWord(%args, 0) @ "'.");
					return 0;
			}
			%blockType = "INPUTBLOCK";
			// function = 255 231 98
			%container = Scratch::createContainer(0, 0);
			Scratch::setColor(%container, "0.388235 0.776471 0.301961 1");
			if(%normal) {
				%argArgStr = "string (\tany\tstring  " @ %op @ " \tany\tstring )";
				%argBuffer = "anyInput expressionOne\tstring[def,def,20]  <color:FFFFFF>" @ %op @ "\tanyInput expressionTwo";
			}
			%argValids  = "notempty any\tnotempty any";
		case 17: // NEW OBJECT BLOCK
			%blockType = "INPUTBLOCK";
			%container = Scratch::createContainer(0, 0);
			%hybrid     = "18";
			Scratch::setColor(%container, "0.721569 0.435294 0.313725 1");
			%argToolTip = "Create an object with the ClassName \"%1\" named \"%2\". Returns the ID of the newly created object.";
			%argArgStr  = "string new \tany_noFormatting\tstring (\tany\tstring )";
			%argBuffer  = "string[def,def,30] <color:FFFFFF>new<color:ffffff>\tinput className\tanyInput objName";
		case 18: // NEW OBJECT BLOCK (NORMAL BLOCK)
			%hybrid     = "17";
			%blockType  = "";
			%container  = Scratch::createContainerContainer(1, 1);
			Scratch::setColor(%container, "0.721569 0.435294 0.313725 1");
			%argToolTip = "Create an object with the ClassName \"%1\" named \"%2\".";
			%argArgStr  = "string new \tany_noFormatting\tstring (\tany\tstring ) {";
			%argBuffer  = "string[def,def,30] <color:FFFFFF>new<color:ffffff>\tinput className\tanyInput objName";
			%bc         = %container.bottomConnector;
			%bc.resize(%bc.getLeft()+%ifIndent, %bc.getTop(), %bc.getWidth(), %bc.getHeight());
		case 19: // NEW OBJECT END
			return;
		case 20: // PACKAGE
			// function = 255 231 98
			%container  = Scratch::createContainer(0, 1);
			Scratch::setColor(%container, "0 0 0 1");
			%argToolTip = "A package named \"%1\". Packages allow you to declare functions that already exist, so that you can execute your own code when it is called, and then have the original function's code be called.";
			%argBuffer  = "string[def,def,58] <color:FFFFFF>package\tinput name";
			%argArgStr  = "string package \tany_noFormatting\tstring  {";
			%bc         = %container.bottomConnector;
			%bc.resize(%bc.getLeft()+%ifIndent, %bc.getTop(), %bc.getWidth(), %bc.getHeight());
			%argValids  = "string notempty";
		case 21: // PACKAGED FUNCTION
			%blockType  = "";
			%container  = Scratch::createContainerContainer(1, 1);
			Scratch::setColor(%container, "0.984314 0.572549 0.168627 1");
			%argToolTip = "A packaged function, named \"%1\" with the arguments \"%2\".";
			%argArgStr  = "string function \tany_noFormatting\tstring (\tany_noFormatting\tstring ) {";
			%argBuffer  = "string <color:FFE762>packaged function<color:ffffff>\tinput Func_Name\tanyInput Func_Args";
			%bc         = %container.bottomConnector;
			%hybrid     = "0";
			%bc.resize(%bc.getLeft()+%ifIndent, %bc.getTop(), %bc.getWidth(), %bc.getHeight());
		case 22: // PACKAGED FUNCTION END
			%container  = Scratch::createContainer(1, 1);
			Scratch::setColor(%container, "0.984314 0.572549 0.168627 1");
			%argToolTip = "Signifies the end of a packaged function declaration.";
			%argBuffer  = "string <color:FFE762>end packaged function";
			%argArgStr  = "string }";
			%tc         = %container.topConnector;
			%tc.resize(%tc.getLeft()+%ifIndent, %tc.getTop(), %tc.getWidth(), %tc.getHeight());
		case 23: // FOR BLOCK
			%blockType  = "";
			%container  = Scratch::createContainerContainer(1, 1);
			Scratch::setColor(%container, "0.721569 0.435294 0.313725 1");
			%argToolTip = "A for loop with the initial step being \"%1\", the expression being \"%2\", and the step being \"%3\".";
			%argBuffer  = "string <color:FFFFFF>for<color:ffffff>\tanyInput a\tanyInput b\tanyInput c";
			%argArgStr  = "string for(\tany_noFormatting\tstring ;\tany_noFormatting\tstring ;\tany_noFormatting\tstring ) {";
			%bc         = %container.bottomConnector;
			%bc.resize(%bc.getLeft()+%ifIndent, %bc.getTop(), %bc.getWidth(), %bc.getHeight());
		case 24: // REMOVED
			return;
		case 25: // WHILE BLOCK
			%blockType  = "";
			%container  = Scratch::createContainerContainer(1, 1);
			Scratch::setColor(%container, "0.721569 0.435294 0.313725 1");
			%argToolTip = "A loop that will loop indefinitely until \"%1\" is 'false'.";
			%argBuffer  = "string <color:FFFFFF>while<color:ffffff>\tanyInput expression";
			%bc         = %container.bottomConnector;
			%argArgStr  = "string while(\tany\tstring ) {";
			%bc.resize(%bc.getLeft()+%ifIndent, %bc.getTop(), %bc.getWidth(), %bc.getHeight());
		case 26: // REMOVED
			return;
		case 27: // SET VARIABLE INPUT
			%blockType = "INPUTBLOCK";
			// function = 255 231 98
			switch$(%args) {
				case "0": 
					%argToolTip = "Increment \"%1\" by 1.";
					%argBuffer  = "anyInput a\tstring[def,def,20] <color:FFFFFF>++<color:ffffff>";
					%argArgStr  = "any\tstring ++";
				case "1":
					%argToolTip = "Decrement \"%1\" by 1.";
					%argBuffer  = "anyInput a\tstring[def,def,20] <color:FFFFFF>- -<color:ffffff>";
					%argArgStr  = "any\tstring --";
				case "2":
					%argToolTip = "Set \"%1\" to \"%2\".";
					%argBuffer  = "anyInput a\tstring <color:FFFFFF>=<color:ffffff>\tanyInput b";
					%argArgStr  = "any\tstring  = \tany";
				case "3":
					%argToolTip = "Increment \"%1\" by \"%2\".";
					%argBuffer  = "anyInput a\tstring[def,def,20] <color:FFFFFF>+=<color:ffffff>\tanyInput b";
					%argArgStr  = "any\tstring  += \tany";
				case "4":
					%argToolTip = "Decrement \"%1\" by \"%2\".";
					%argBuffer  = "anyInput a\tstring[def,def,20] <color:FFFFFF>-=<color:ffffff>\tanyInput b";
					%argArgStr  = "any\tstring  -= \tany";
				case "5":
					%argToolTip = "Multiply \"%1\" by \"%2\".";
					%argBuffer  = "anyInput a\tstring[def,def,20] <color:FFFFFF>*=<color:ffffff>\tanyInput b";
					%argArgStr  = "any\tstring  *= \tany";
				case "6":
					%argToolTip = "Divide \"%1\" by \"%2\".";
					%argBuffer  = "anyInput a\tstring[def,def,20] <color:FFFFFF>/=<color:ffffff>\tanyInput b";
					%argArgStr  = "any\tstring  /= \tany";
				case "7":
					%argToolTip = "Modulate \"%1\" by \"%2\".";
					%argBuffer  = "anyInput a\tstring[def,def,20] <color:FFFFFF>%=<color:ffffff>\tanyInput b";
					%argArgStr  = "any\tstring  %= \tany";
				default:
					error("ERROR: Scratch::createPremadeBlock() - Invalid variable set type '" @ getWord(%args, 0) @ "'.");
					return 0;
			}
			%hybrid    = "2" SPC %args;
			%container = Scratch::createContainer(0, 0);
			Scratch::setColor(%container, "0.309804 0.403922 0.505882 1");
			%argValids  = "block[_3_4_]";
		case 28: // CALL OBJECT METHOD
			if(!getWord(%args, 0)) {
				%blockType = "INPUTBLOCK";
				%container = Scratch::createContainer(0, 0);
			} else {
				%blockType = "";
				%container = Scratch::createContainer(1, 1);
			}
			%hybrid     = "28" SPC (%blockType $= "INPUTBLOCK" ? "1" : "0");
			Scratch::setColor(%container, "0.984314 0.572549 0.168627 1");
			%argToolTip = "Call a method named \"%2\" on \"%1\" with the arguments \"%3\".";
			%argArgStr  = "any_noFormatting\tstring .\tany_noFormatting\tstring (\tany\tstring )";
			%argBuffer  = "string <color:ffffff>call\tanyInput objName\tstring <color:ffffff>.\tinput funcName\tanyInput args";
		case 29: // OBJECT VARIABLE
			%blockType  = "INPUTBLOCK";
			%container  = Scratch::createContainer(0, 0);
			Scratch::setColor(%container, "0.898039 0.231373 0.266667 1");
			%argToolTip = "Reference the variable named \"%2\" that is attached to \"%1\".";
			%argArgStr  = "any_noFormatting\tstring .\tany_noFormatting";
			%argBuffer  = "anyInput valueName\tstring <color:FF77A8>.\tanyInput value";
			%argValids  = "block[_16_3_4_]\tblock[_16_3_4_]";
		case 30: // OR BLOCK
			%blockType  = "INPUTBLOCK";
			%container  = Scratch::createContainer(0, 0);
			Scratch::setColor(%container, "0.619608 0.156863 0.207843 1");
			%argToolTip = "Returns 'true' if either \"%1\" or \"%2\" equate to 'true'.";
			%argArgStr  = "any\tstring  || \tany";
			%argBuffer  = "anyInput a\tstring[def,def,18] <color:3F2832>or\tanyInput b";
			%argValids  = "any\tany";
		case 31: // AND BLOCK
			%blockType  = "INPUTBLOCK";
			%container  = Scratch::createContainer(0, 0);
			Scratch::setColor(%container, "0.619608 0.156863 0.207843 1");
			%argToolTip = "Returns 'true' if both \"%1\" and \"%2\" equate to 'true'.";
			%argArgStr  = "any\tstring  && \tany";
			%argBuffer  = "anyInput a\tstring[def,def,20] <color:3F2832>and\tanyInput b";
			%argValids  = "any\tany";
		case 32: // PRE-MADE CALL BLOCK
			%funcName = getWord(%args, 1);
			%argCount = mClamp(getWord(%args, 2), 0, 20);
			if(%funcName $= "") return 0;
			if(!getWord(%args, 0)) {
				%blockType = "INPUTBLOCK";
				%container = Scratch::createContainer(0, 0);
			} else {
				%blockType = "";
				%container = Scratch::createContainer(1, 1);
			}
			%hybrid     = "32" SPC (%blockType $= "INPUTBLOCK" ? "1" : "0") SPC removeWord(%args, 0);
			Scratch::setColor(%container, "0.984314 0.572549 0.168627 1");
			%argToolTip = "Call a function named \"" @ %funcName @ "\" with the arguments \"";
			for(%i=0;%i<%argCount;%i++) %argToolTip = %argToolTip @ "%" @ %i+1 @ " ";
			%argToolTip = trim(%argToolTip) @ "\".";
			%argArgStr  = "string " @ %funcName @ "(";
			for(%i=0;%i<%argCount;%i++) %argArgStr = %argArgStr @ "\tany\tstring , ";
			if(%argCount != 0) %argArgStr = removeField(%argArgStr, getFieldCount(%argArgStr)-1);
			%argArgStr  = %argArgStr @ "\tstring )";
			%argBuffer  = "string <color:ffffff>" @ %funcName @ " ";
			for(%i=0;%i<%argCount;%i++) %argBuffer = %argBuffer @ "\tanyInput";
		case 33: // PRE-MADE SCRIPT BLOCK
			// Field 0 : %argBufzfer  (What is displayed on the block)
			// Field 1 : %argArgStr  (What is exported)
			// Field 2 : %argToolTip (Obvious)
			// Field 3 : [Word 0 : TopConnector] [Word 1 : BottomConnector]
			// Field 4 : %blockType  (0 = Normal, 1 = Input, 2 = Container Container)
			// Field 5 : End token   (Exorter End token)
			// Field 6 : Color
			%argBuffer  = getRecord(%args, 0);
			%argArgStr  = getRecord(%args, 1);
			%argToolTip = getRecord(%args, 2);
			%topConnect = getWord(getRecord(%args, 3), 0);
			%btmConnect = getWord(getRecord(%args, 3), 1);
			%blockType  = (getRecord(%args, 4) == 1 ? "INPUTBLOCK" : "");
			if(%blockType == 2) %container = Scratch::createContainerContainer(%topConnect, %btmConnect);
			else %container = Scratch::createContainer(%topConnect, %btmConnect);
			%container.endToken = getField(%args, 5);
			Scratch::setColor(%container, getRecord(%args, 6) SPC "1");
		case 34:
			%uniqueId = %args;
			%this     = ScratchCustomBlockGroup;
			for(%i=0;%i<%this.size();%i++) {
				if(getField(%this.at(%i), 0) !$= %uniqueId) continue;
				%data     = %this.at(%i);
				%intName  = getRecord(%data, 1);
				%color    = getRecord(%data, 2);
				%type     = getRecord(%data, 3);
				%top      = getRecord(%data, 4);
				%bottom   = getRecord(%data, 5);
				%buffer   = getRecord(%data, 6);
				%export   = getRecord(%data, 7);
				%tooltip  = getRecord(%data, 8);
				%endToken = getRecord(%data, 9);
				%string   = %buffer NL %export NL %tooltip NL %top SPC %bottom NL %type NL %endToken NL %color;
				%newObj   = Scratch::createPremadeBlock(33, %string, %dep, %duplicated);
				%newObj.uniqueIdx  = %i;
				%newObj.uniqueID   = %uniqueID;
				%newObj.uniqueName = getField(%this.at(%i), 1);
				%newObj.isCustom   = 1;
				return %newObj;
			}
			return 0;
		case 35: // TERNARY OPERATION
			%blockType  = "INPUTBLOCK";
			%container  = Scratch::createContainer(0, 0);
			Scratch::setColor(%container, "0.984314 0.572549 0.168627 1");
			%argToolTip = "If \"%1\" is true, then return \"%2\". Otherwise, return \"%3\".";
			%argArgStr  = "string (\tany\tstring  ? \tany\tstring  : \tany\tstring )";
			%argBuffer  = "string <color:FFE762>if\tanyInput expr\tstring <color:FFE762>return\tanyInput b\tstring <color:FFE762>else return\tanyInput c";
			%argValids  = "notempty any";
		case 36: // NEW OBJECT variable
			%argToolTip = "Set a variable with the name \"%1\" to \"%2\" in this object.\nThis must go into a new object block.";
			%argBuffer  = "input varname\tstring[def,def,20] <color:AFBFD2>=\tanyInput val";
			%argArgStr  = "any_noFormatting\tstring  = \tany";
			%argValids  = "notempty\tany";
			%blockType  =  "";
			%container  = Scratch::createContainer(1, 1);
			Scratch::setColor(%container, "0.309804 0.403922 0.505882 1");
		default:
			echo("\c2ERROR: Scratch::createPremadeBlock() - Invalid block type '" @ %type @ "'.");
			warn("   00 : Declare Function Block");
			warn("   01 : Call Function Block");
			warn("   02 : Set var block");
			warn("   03 : Local variable block");
			warn("   04 : Global variable block");
			warn("   05 : String concantenation block");
			warn("   06 : Arithmetic operation block");
			warn("   07 : Return block");
			warn("   08 : [removed]");
			warn("   09 : String concantenation (SPC)");
			warn("   10 : String concantenation (TAB)");
			warn("   11 : String concantenation (NL)");
			warn("   12 : If block");
			warn("   13 : If end block");
			warn("   14 : Else if block");
			warn("   15 : Else block");
			warn("   16 : Logical Comparison block");
			warn("   17 : New object block (INPUTBLOCK)");
			warn("   18 : New object block (NORMALBLOCK)");
			warn("   19 : [removed]");
			warn("   20 : Package block");
			warn("   21 : Packaged function block");
			warn("   22 : Packaged function end block");
			warn("   23 : For block");
			warn("   24 : [removed]");
			warn("   25 : While block");
			warn("   26 : [removed]");
			warn("   27 : Set variable [INPUT]");
			warn("   28 : Call object method block");
			warn("   29 : Object variable block");
			warn("   30 : Or block");
			warn("   31 : And block");
			warn("   32 : Pre-Defined Call Block");
			warn("   33 : Pre-Defined Script");
			warn("   34 : ");
			warn("   35 : Ternary Operation");
			warn("   36 : New object variable");
			backTrace();
			return;
	}
	if(!isObject(%container)) return;
	%container.hybridInfo        = %hybrid;
	%container.toolTipHelp       = %argToolTip;
	%container.blockReturnFormat = %argArgStr;
	%container.blockCreationArgs = %args;
	%container.blockLayoutType   = %type;
	%container.blockType         = %blockType;
	for(%i=0;%i<getFieldCount(%argBuffer);%i++) {
		%type     = getWord(getField(%argBuffer, %i), 0);
		%args     = removeWord(getField(%argBuffer, %i), 0);
		%typeArgs = "";
		if(strIPos(%type, "[") != -1) {
			%typeArgs = getSubStr(%type, strIPos(%type, "[")+1, strLen(%type));
			%typeArgs = getSubStr(%typeArgs, 0, strLen(%typeArgs)-1);
			%typeArgs = strReplace(%typeArgs, "\\,", "[[COMMA]]");
			%typeArgs = strReplace(strReplace(%typeArgs, ",", "\t"), "_", " ");
			%typeArgs = strReplace(%typeArgs, "[[COMMA]]", ",");
			for(%j=0;%j<getFieldCount(%typeArgs);%j++) if(getField(%typeArgs, %j) $= "def") %typeArgs = setField(%typeArgs, %j, "");
			%type     = getSubStr(%type, 0, strIPos(%type, "["));
		}
		switch$(%type) {
			case "delim":
				// [char,addtype(0=ANYINPUT|1=TEXTINPUT|2=BLOCKINPUT),x,y]
				if(%addedDelim) {
					warn("WARNING: Scratch::createPremadeBlock() - Delimiter Adder button is already appended onto this block");
					continue;
				}
				if(trim(getField(%typeArgs, 0)) $= "" || trim(getField(%typeArgs, 1)) $= "") {
					warn("WARNING: Scratch::createPremadeBlock() - Delimiter Adder button definition has invalid type args (Requires two type args -- got \"" @ strReplace(%typeArgs, "\t", ",") @ "\")");
					continue;
				}
				%addedDelim = 1;
				%newObj = new GuiBitmapButtonCtrl() {
					position   = (getField(%typeArgs, 1) !$= "" ? getField(%typeArgs, 1) : 9) SPC (getField(%typeArgs, 2) !$= "" ? getField(%typeArgs, 2) : 4);
					extent     = "10 10";
					bitmap     = "Add-Ons/Client_Scratch/img/delimiter";
					command    = "Scratch::addDelimiter(\"" @ %container @ "\", \"" @ mClamp(getField(%typeArgs, 1), 0, 2)  @ "\");";
					altCommand = "Scratch::removeDelimiter(\"" @ %container @ "\");";
				};
				%container.add(%newObj);
				%container.delimAddObj   = %newObj;
				%container.delimiterChar = " " @ getField(%typeArgs, 0);
			case "string":
				// [x,y,w,h,static]
				%newObj = new GuiMLTextCtrl() {
					profile  = "GuiScratchIgnoreTextProfile";
					position = (getField(%typeArgs, 0) !$= "" ? getField(%typeArgs, 0) : 9) SPC (getField(%typeArgs, 1) !$= "" ? getField(%typeArgs, 1) : 4);
					extent   = (getField(%typeArgs, 2) !$= "" ? getField(%typeArgs, 2) : 7*strLen(stripMLControlChars(%args))) SPC (getField(%typeArgs, 3) !$= "" ? getField(%typeArgs, 3) : "19");
					argIndex = %totalArgCount++;
					static   = (getField(%typeArgs, 4) !$= "" ? getField(%typeArgs, 4) : "0");
				};
				%container.add(%newObj);
				%newObj.setText("<font:Franklin Gothic Demi:19>" @ %args);
				%container.allArgObjects[-1+%container.totalArgCount++] = %newObj;
			case "input":
				%argContainer = Scratch::createPlaceholder();
				Scratch::setColor(%argContainer, "1 1 1 1");
				%argContainer.argName    = %args;
				%argContainer.blockIdx   = (-1+(%container.blockArgCount+1));
				%argContainer.argIndex   = %totalArgCount++;
				%argContainer.argType    = "TEXTINPUT";
				%argContainer.important  = 1; // Sort this in front of the mouse event ctrl
				%argContainer.validChecks = getField(%argValids, %container.blockArgCount);
				%newObj = new GuiTextEditCtrl() {
					profile    = "GuiScratchArgTextEdit";
					position   = "1 4";
					extent     = "27 18";
					ignore     = 1;
				};
				%argContainer.textEdit = %newObj;
				%newObj.command        = "Scratch::setTextBoxWidth(" @ %newObj @ ", " @ %argContainer @ ");";
				%argContainer.add(%newObj);
				%container.add(%argContainer);
				Scratch::setBlockOffsets(%argContainer);
				%container.blockArgObject[-1+%container.blockArgCount++] = %argContainer;
				%container.allArgObjects[-1+%container.totalArgCount++]  = %argContainer;
			case "blockInput":
				%argContainer          = Scratch::createPlaceholder();
				%argContainer.blockIdx = (-1+(%container.blockArgCount+1));
				%argContainer.argIndex = %totalArgCount++;
				%argContainer.argName  = %args;
				%color                 = %container.scratchColor_HSV;
				%color                 = getWord(%color, 0)/2 SPC getWord(%color, 1)/2 SPC getWord(%color, 2)/2 SPC "1";
				Scratch::setColor(%argContainer, %color);
				%argContainer.validChecks = getField(%argValids, %container.blockArgCount);
				%argContainer.argType     = "BLOCKINPUT";
				%container.add(%argContainer);
				Scratch::setBlockOffsets(%argContainer);
				%container.blockArgObject[-1+%container.blockArgCount++] = %argContainer;
				%container.allArgObjects[-1+%container.totalArgCount++]  = %argContainer;
			case "anyInput":
				%argContainer          = Scratch::createPlaceholder();
				%argContainer.blockIdx = (-1+(%container.blockArgCount+1));
				%argContainer.argIndex = %totalArgCount++;
				%argContainer.argName  = %args;
				Scratch::setColor(%argContainer, "1 1 1 1");
				%argContainer.argType  = "ANYINPUT";
				%newObj = new GuiTextEditCtrl() {
					profile   = "GuiScratchArgTextEdit";
					position  = "1 4";
					extent    = "27 18";
					ignore    = 1;
				};
				%argContainer.textEdit    = %newObj;
				%argContainer.validChecks = getField(%argValids, %container.blockArgCount);
				%newObj.command           = "Scratch::setTextBoxWidth(" @ %newObj @ ", " @ %argContainer @ ");";
				%argContainer.add(%newObj);
				%container.add(%argContainer);
				Scratch::setBlockOffsets(%argContainer);
				%container.blockArgObject[-1+%container.blockArgCount++] = %argContainer;
				%container.allArgObjects[-1+%container.totalArgCount++]  = %argContainer;
		}
	}
	if(isObject(%obj = %container.delimAddObj)) {
		%obj.argIndex = %totalArgCount++;
		%container.allArgObjects[-1+%container.totalArgCount++] = %obj;
		if(!%duplicated) {
			for(%i=0;%i<getWordCount(%addAfterC);%i++) {
				Scratch::addDelimiter(%container, getWord(%addAfterC, %i), 1);
				%container.blockArgObject[%container.blockArgCount-1].validChecks = getField(%argValids, %container.blockArgCount-1 );
			}
		}
	}
	%container.realBlockArgCount = %container.blockArgCount;
	Scratch::update(%container, 3);
	return %container;
}

function Scratch::setTextBoxWidth(%textBox, %container) {
	if(!$Pref::Scratch::DisableAutoComplete) {
		%text = %textBox.getValue();
		if(%text !$= "") {
			%newChar = %text;
			if(strLen(%newChar) >= 2) %preChar = getSubStr(%newChar, strLen(%newChar)-2, 1);
			%newChar = getSubStr(%newChar, strLen(%newChar)-1, 1);
		}
		%block = %container.getGroup();
		%index = %container.blockIdx;
		%bType = %block.blockLayoutType;
		switch(%bType) {
			case 3: // .local var
				if(%index == 1 && %block.blockCreationArgs $= "array" && %newChar $= "") {
					%innerP = %block.innerConnection_Parent;
					%block.hybridInfo = %block.blockLayoutType;
					%newObj = Scratch::convertBlock(%block);
					if(isObject(%innerP)) Scratch::attachBlock(%newObj, %innerP, "inside");
					return;
				}
				if(%block.blockCreationArgs $= "" && (%newChar $= "]" && strIPos(%text, "[") != -1)) {
					%innerP    = %block.innerConnection_Parent;
					%topMost   = Scratch::getHighestTopConnection(Scratch::getHighestInnerConnection(%block));
					%arrayText = getSubStr(%text, strIPos(%text, "[")+1, strLen(%text));
					%arrayText = getSubStr(%arrayText, 0, strLen(%arrayText)-1);
					%textBox.setValue(getSubStr(%text, 0, strIPos(%text, "[")));
					%block.hybridInfo = %block.blockLayoutType SPC "array";
					%newObj = Scratch::convertBlock(%block);
					%argObj = Scratch::convertTextInputToBlock(%newObj, %arrayText);
					if(isObject(%innerP)) Scratch::attachBlock(%newObj, %innerP, "inside");
					Scratch::setValue(%newObj, 1, %argObj);
					Scratch::update(%topMost, 2);
					return;
				}
			case 4: // .global var
				if(%index == 1 && %block.blockCreationArgs $= "array" && %newChar $= "") {
					%innerP = %block.innerConnection_Parent;
					%block.hybridInfo = %block.blockLayoutType;
					%newObj = Scratch::convertBlock(%block);
					if(isObject(%innerP)) Scratch::attachBlock(%newObj, %innerP, "inside");
					return;
				}
				if(%block.blockCreationArgs $= "" && (%newChar $= "]" && strIPos(%text, "[") != -1)) {
					%innerP    = %block.innerConnection_Parent;
					%topMost   = Scratch::getHighestTopConnection(Scratch::getHighestInnerConnection(%block));
					%arrayText = getSubStr(%text, strIPos(%text, "[")+1, strLen(%text));
					%arrayText = getSubStr(%arrayText, 0, strLen(%arrayText)-1);
					%textBox.setValue(getSubStr(%text, 0, strIPos(%text, "[")));
					%block.hybridInfo = %block.blockLayoutType SPC "array";
					%newObj = Scratch::convertBlock(%block);
					%argObj = Scratch::convertTextInputToBlock(%newObj, %arrayText);
					if(isObject(%innerP)) Scratch::attachBlock(%newObj, %innerP, "inside");
					Scratch::setValue(%newObj, 1, %argObj);
					if(isObject(%argObj)) %argObj.getGroup().pushToBack(%argObj);
					return;
				}
		}
	}
	%width = mClamp((%textBox.profile.fontSize/2)*strLen(%textBox.getValue()), getWord(%container.minExtent, 0), 100000000);
	%textBox.resize(%textBox.getLeft(), %textBox.getTop(), %width+4, getWord(%textBox.getExtent(), 1));
	%container.resize(%container.getLeft(), %container.getTop(), %width+6, getWord(%container.getExtent(), 1));
	%container.getGroup().resize(%container.getGroup().getLeft(), %container.getGroup().getTop(), 29, getWord(%container.getGroup().getExtent(), 1));
	Scratch::renderBlock(%container.getGroup());
}

function Scratch::convertTextInputToBlock(%this, %text) {
	if(!isObject(%this)) return 0;
	for(%i=0;%i<strLen(%text);%i++) {
		%chr = getSubStr(%text, %i, 1);
		switch$(%chr) {
			case "%":
				%lastObj = Scratch::createPremadeBlock(3);
				%buffer  = "";
				if(%parent $= "") %parent = %lastObj;
				%object[-1+%objCount++]   = %lastObj;
				Scratch_Content.add(%lastObj);
				for(%j=%i+1;%j<strLen(%text);%j++) {
					%chr_child = getSubStr(%text, %j, 1);
					if(getSafeVariableName(%chr_child) !$= %chr_child) break;
					%buffer    = %buffer @ %chr_child;
				}
				Scratch::setValue(%lastObj, 0, %buffer);
			case "$":
				%lastObj = Scratch::createPremadeBlock(4);
				%buffer  = "";
				if(%parent $= "") %parent = %lastObj;
				%object[-1+%objCount++]   = %lastObj;
				Scratch_Content.add(%lastObj);
				for(%j=%i+1;%j<strLen(%text);%j++) {
					%chr_child = getSubStr(%text, %j, 1);
					if(getSafeVariableName(%chr_child) !$= %chr_child) break;
					%buffer    = %buffer @ %chr_child;
				}
				Scratch::setValue(%lastObj, 0, %buffer);
		}
	}
	return (%parent $= "" ? %text : %parent);
}

function Scratch::setValue(%block, %idx, %value, %canAddArguments) {
	if(!isObject(%block)) {
		error("ERROR: Scratch::setValue() - Cannot find block with ID " @ %block @ ".");
		return 0;
	}
	
	if(%idx >= %block.blockArgCount || %idx < 0) {
		if(%canAddArguments) {
			while(%idx >= %block.blockArgCount) {
				if(getWordCount(%block.delimiterObjectTable) > 20) {
					error("ERROR: Scratch::setValue() - Index " @ %idx @ " is out of range; index = " @ %idx @ ", size = " @ %block.blockArgCount);
					return 0;
				}
				%block.delimAddObj.performClick();
			}
		} else {
			error("ERROR: Scratch::setValue() - Index " @ %idx @ " is out of range; index = " @ %idx @ ", size = " @ %block.blockArgCount);
			return 0;
		}
	}
	
	%argObj = %block.blockArgObject[%idx];
	
	if(isObject(%value)) {
		Scratch::attachBlock(%value, %argObj, "inside");
		return 1;
	}
	
	if(!isObject(%txtEd = %argObj.textEdit)) {
		error("ERROR: Scratch::setValue() - Failed to set value of argument box # " @ %idx @ " on block " @ %block @ ": Argument box # " @ %idx @ " is a block-only box.");
		return 0;
	}
	
	%txtEd.setValue(%value);
	Scratch::setTextBoxWidth(%txtEd, %argObj);
	return 1;
}

function Scratch::getBlockType(%this) {
	return (%this.argType !$= "" ? "ARG_PLACEHOLDER" : "BLOCK");
}

function Scratch::removeDelimiter(%this) {
	if(!isObject(%this)) return;
	if(!isObject(%addObj = %this.delimAddObj)) return;
	%table = %this.delimiterObjectTable;
	for(%i=0;%i<=getWordCount(%table);%i++) {
		%object = getWord(%table, %i);
		if(%i == getWordCount(%table)) return;
		if(!isObject(%object)) continue;
		if(%object.cantDelete) continue;
		break;
	}
	for(%i=0;%i<%this.totalArgCount;%i++) {
		%arg = %this.allArgObjects[%i];
		if(%arg !$= %object) {
			if(!%clean) continue;
			%this.allArgObjects[%i-1] = %this.allArgObjects[%i];
			continue;
		}
		%clean = 1;
	}
	if(!%clean) {
		error("ERROR: Scratch::removeDelimiter() - Cleanup error (Cant find " @ %object @ " in " @ %this @ "'s allArgObjects array)");
		return;
	}
	%addObj.argIndex = %this.totalArgCount-1;
	%this.allArgObjects[%this.totalArgCount-1] = "";
	%this.totalArgCount--;
	%clean = 0;
	if(%object.argType !$= "TEXTINPUT") {
		for(%i=0;%i<%this.blockArgCount;%i++) {
			%arg = %this.blockArgObject[%i];
			if(%arg !$= %object) {
				if(!%clean) continue;
				%this.blockArgObject[%i-1] = %this.blockArgObject[%i];
				continue;
			}
			%clean = 1;
		}
		%this.blockArgCount--;
	}
	if(isObject(%object.innerConnection_Child)) Scratch::detachBlock(%object.innerConnection_Child, "inside");
	%object.delete();
	%this.delimiterObjectTable = removeWord(%this.delimiterObjectTable, %i);
	Scratch::update(%this, 3);
}

function Scratch::addDelimiter(%this, %type, %cannotDelete) {
	if(!isObject(%this)) return;
	if(!isObject(%addObj = %this.delimAddObj)) return;
	if(getWordCount(%this.delimiterObjectTable) > 20) {
		messageBoxOk("ERROR - Scratch Editor", "You cannot have more than 20 argument delimiters on one block. If your script depends on more than 20 argument delimiters, please find a different way to structure your script.");
		return;
	}
	%argContainer = Scratch::createPlaceholder();
	Scratch::setColor(%argContainer, "0.95 0.95 0.95 1");
	%argContainer.cantDelete = (%cannotDelete ? "1" : "0");
	%argContainer.isDelim    = 1;
	%argContainer.argIndex   = %addObj.argIndex;
	switch(%type) {
		case 0: %argContainer.argType = "ANYINPUT";   %addText = 1; %this.blockArgObject[-1+%this.blockArgCount++] = %argContainer;
		case 1: %argContainer.argType = "TEXTINPUT";  %addText = 1;
		case 2: %argContainer.argType = "BLOCKINPUT"; %addText = 0; %this.blockArgObject[-1+%this.blockArgCount++] = %argContainer;
	}
	if(%addText) {
		%argContainer.important = 1; // Sort this in front of the mouse event ctrl
		%newObj = new GuiTextEditCtrl() {
			profile  = "GuiScratchArgTextEdit";
			position = "1 4";
			extent   = "27 18";
			ignore   = 1;
		};
		%argContainer.textEdit = %newObj;
		%newObj.command = "Scratch::setTextBoxWidth(" @ %newObj @ ", " @ %argContainer @ ");";
		%argContainer.add(%newObj);
	}
	%this.add(%argContainer);
	Scratch::setBlockOffsets(%argContainer);
	%this.allArgObjects[%this.totalArgCount-1]     = %argContainer;
	%this.allArgObjects[-1+%this.totalArgCount++]  = %addObj;
	%this.delimiterObjectTable = trim(%argContainer SPC %this.delimiterObjectTable);
	%addObj.argIndex++;
	Scratch::update(%this, 3);
}

function Scratch::duplicateBlock(%this) {
	if(!isObject(%this)) return;
	%obj = Scratch::createPremadeBlock(%this.blockLayoutType, %this.blockCreationArgs, "", 1);
	Scratch_Content.add(%obj);
	// Create delimiters
	for(%i=0;%i<getWordCount(%this.delimiterObjectTable);%i++) {
		%child = getWord(%this.delimiterObjectTable, %i);
		switch$(%child.argType) {
			case "ANYINPUT":   %type = 0;
			case "TEXTINPUT":  %type = 1;
			case "BLOCKINPUT": %type = 2;
			default: continue;
		}
		Scratch::addDelimiter(%obj, %type);
	}
	for(%i=0;%i<%this.blockArgCount;%i++) {
		%child = %this.blockArgObject[%i];
		if(!isObject(%child_child = %child.innerConnection_Child)) {
			if(isObject(%txtEd = %child.textEdit)) {
				%obj.blockArgObject[%i].textEdit.setValue(%txtEd.getValue());
				Scratch::setTextBoxWidth(%obj.blockArgObject[%i].textEdit, %obj.blockArgObject[%i]);
			}
			continue;
		}
		%newObj = Scratch::duplicateBlock(%child_child);
		Scratch::attachBlock(%newObj, %obj.blockArgObject[%i], "inside");
		Scratch::update(%newObj, 3);
	}
	if(isObject(%btm = %this.bottomConnection)) {
		%newObj = Scratch::duplicateBlock(%btm);
		Scratch::attachBlock(%newObj, %obj, "bottom");
		Scratch::update(%newObj, 3);
	}
	%obj.resize(%this.getLeft()+15, %this.getTop()+15, %obj.getWidth(), %obj.getHeight());
	Scratch::renderBlock(%obj);
	return %obj;
}

function Scratch::deleteBlock(%this) {
	if(!isObject(%this)) return;
	for(%i=0;%i<%this.blockArgCount;%i++) {
		%child = %this.blockArgObject[%i];
		if(!isObject(%obj = %child.innerConnection_Child)) continue;
		Scratch::deleteBlock(%obj);
	}
	if(isObject(%this.innerConnection_Parent)) {
		Scratch::detachBlock(%this, "inside");
	}
	if(isObject(%this.inside_topConnection)) {
		Scratch::deleteBlock(%this.inside_topConnection);
	}
	if(isObject(%this.bottomConnection)) {
		Scratch::deleteBlock(%this.bottomConnection);
	}
	%this.schedule(1, delete);
}

function Scratch::convertBlock(%this) {
	if(!isObject(%this)) return;
	if((%hInfo = %this.hybridInfo) $= "") return;
	%newObj = Scratch::createPremadeBlock(getWord(%hInfo, 0), removeWord(%hInfo, 0), "", 1);
	Scratch_Content.add(%newObj);
	Scratch::update(Scratch::getHighestTopConnection(%this), 3);
	for(%i=0;%i<getWordCount(%this.delimiterObjectTable);%i++) {
		%child = getWord(%this.delimiterObjectTable, %i);
		switch$(%child.argType) {
			case "ANYINPUT":   %type = 0;
			case "TEXTINPUT":  %type = 1;
			case "BLOCKINPUT": %type = 2;
			default: continue;
		}
		Scratch::addDelimiter(%newObj, %type);
	}
	for(%i=0;%i<%this.blockArgCount;%i++) {
		%child = %this.blockArgObject[%i];
		if(!isObject(%obj = %child.innerConnection_Child)) {
			if(isObject(%txtEd = %child.textEdit)) {
				if(isObject(%newTxtEd = %newObj.blockArgObject[%i].textEdit)) {
					%newTxtEd.setValue(%txtEd.getValue());
					Scratch::setTextBoxWidth(%newTxtEd, %newObj.blockArgObject[%i]);
				}
			}
			continue;
		}
		Scratch::detachBlock(%obj, "inside");
		if(!isObject(%newChild = %newObj.blockArgObject[%i])) continue;
		Scratch::attachBlock(%obj, %newChild, "inside");
	}
	if(isObject(%top = %this.topConnection)) {
		Scratch::detachBlock(%top, "bottom");
		if(!Scratch::attachBlock(%top, %newObj, "top")) {
			%newObj.resize(%this.getLeft(), %this.getTop(), %newObj.getWidth(), %newObj.getHeight());
		}
	} else %newObj.resize(%this.getLeft(), %this.getTop(), %newObj.getWidth(), %newObj.getHeight());
	if(isObject(%btm = %this.bottomConnection)) {
		Scratch::detachBlock(%btm, "top");
		Scratch::attachBlock(%btm, %newObj, "bottom");
	}
	if(isObject(%top) && isObject(%btm) && !%newObj.bottom && !%newObj.top) {
		Scratch::attachBlock(%btm, %top, "bottom");
	}
	Scratch::renderBlock(%newObj);
	Scratch::renderBlock(%newObj);
	for(%i=0;%i<%newObj.blockArgCount;%i++) {
		%child = %newObj.blockArgObject[%i];
		if(!isObject(%child_child = %child.innerConnection_Child)) continue;
		Scratch::renderBlock(%child_child);
		Scratch::renderBlock(%child_child);
	}
	Scratch::deleteBlock(%this);
	return %newObj;
}

function Scratch_performBlockAction(%this, %action) {
	if(!isObject(%this)) return;
	switch(%action) {
		case -1: return;
		case 0:  Scratch::deleteBlock(%this);
		case 1:  Scratch::duplicateBlock(%this);
		case 2:  Scratch::convertBlock(%this);
	}
}