// Support_NewScroll
// Adds a new, more dynamic scroll to the game
// By Clay Hanson [15144]
package NewScrollPackage {
	function GuiControl::delete(%this) {
		if(%this.newScroll && isObject(%this.inputCtrl)) %this.inputCtrl.delete();
		Parent::delete(%this);
	}
};
activatePackage(NewScrollPackage);


// Profiles
if(!isObject(GuiNewScrollProfile)) new GuiControlProfile(GuiNewScrollProfile : GuiDefaultProfile) {
	border      = 1;
	borderColor = "0 0 0 255";
	fillColor   = "255 255 255 255";
	opaque      = 1;
};

if(!isObject(GuiNewScrollNoModalProfile)) new GuiControlProfile(GuiNewScrollNoModalProfile : GuiNewScrollProfile) {
	modal = 0;
};

if(!isObject(GuiNewScrollBarBGProfile)) new GuiControlProfile(GuiNewScrollBarBGProfile : GuiDefaultProfile) {
	border      = 1;
	borderColor = "0 0 0 255";
	fillColor   = "202 202 202 255";
	opaque      = 1;
};

if(!isObject(NewScrollActionMap)) { new ActionMap(NewScrollActionMap); NewScrollActionMap.pop(); NewScrollActionMap.bind(mouse, "zaxis", "newScroll_handleMouseWheel"); }

// Script
function new_GuiNewScrollCtrl(%objectName) {
	%newObj = new GuiControl() {
		profile     = "GuiNewScrollBarBGProfile";
		horizSizing = "right";
		vertSizing  = "bottom";
		position    = "0 0";
		extent      = "96 96";
		minExtent   = "96 96";
		visible     = "1";
		hScrollBar  = "alwaysOn"; // Bottom bar
		vScrollBar  = "alwaysOn"; // Right bar
		childMargin = "0 0";
		newScroll   = 1;
		scrollSpeed = 60;
		scrollAmtX  = 0;
		scrollAmtY  = 0;
		
		new GuiMouseEventCtrl(NewScrollMouseHandler) {
			horizSizing = "width";
			vertSizing = "height";
			position = "0 0";
			extent = "81 81";
			minExtent = "1 1";
			visible = "1";
		};
		new GuiControl() {
			profile = "GuiNewScrollNoModalProfile";
			horizSizing = "width";
			vertSizing = "height";
			position = "0 0";
			extent = "81 81";
			minExtent = "1 1";
			visible = "1";
		};
		new GuiControl() {
			profile = "GuiNewScrollBarBGProfile";
			horizSizing = "width";
			vertSizing = "top";
			position = "15 80";
			extent = "51 16";
			minExtent = "8 2";
			visible = "1";
			
			new GuiSwatchCtrl() {
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "28 16";
				minExtent = "10 16";
				visible = "0";
				color = "130 130 130 220";
				
				new GuiMouseEventCtrl(newScroll_BottomScrollHandler) {
					profile = "GuiDefaultProfile";
					horizSizing = "width";
					vertSizing = "height";
					position = "0 0";
					extent = "28 16";
					minExtent = "8 2";
					visible = "1";
					lockMouse = "0";
				};
			};
		};
		new GuiControl() {
			profile = "GuiNewScrollBarBGProfile";
			horizSizing = "left";
			vertSizing = "height";
			position = "80 15";
			extent = "16 51";
			minExtent = "8 2";
			visible = "1";
			
			new GuiSwatchCtrl() {
				profile = "GuiDefaultProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "0 0";
				extent = "16 28";
				minExtent = "16 10";
				visible = "0";
				color = "130 130 130 220";
				
				new GuiMouseEventCtrl(newScroll_RightScrollHandler) {
					profile = "GuiDefaultProfile";
					horizSizing = "width";
					vertSizing = "height";
					position = "0 0";
					extent = "16 28";
					minExtent = "8 2";
					visible = "1";
					lockMouse = "0";
				};
			};
		};
		new GuiBitmapButtonCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "top";
			position = "0 80";
			extent = "16 16";
			minExtent = "8 2";
			visible = "1";
			text = " ";
			groupNum = "-1";
			buttonType = "PushButton";
			bitmap = "./newScroll_LeftBtn";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			mKeepCached = "0";
			mColor = "255 255 255 255";
		};
		new GuiBitmapButtonCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "80 0";
			extent = "16 16";
			minExtent = "8 2";
			visible = "1";
			text = " ";
			groupNum = "-1";
			buttonType = "PushButton";
			bitmap = "./newScroll_UpBtn";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			mKeepCached = "0";
			mColor = "255 255 255 255";
		};
		new GuiBitmapButtonCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = "65 80";
			extent = "16 16";
			minExtent = "8 2";
			visible = "1";
			text = " ";
			groupNum = "-1";
			buttonType = "PushButton";
			bitmap = "./newScroll_RightBtn";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			mKeepCached = "0";
			mColor = "255 255 255 255";
		};
		new GuiBitmapButtonCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = "80 65";
			extent = "16 16";
			minExtent = "8 2";
			visible = "1";
			text = " ";
			groupNum = "-1";
			buttonType = "PushButton";
			bitmap = "./newScroll_DownBtn";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			mKeepCached = "0";
			mColor = "255 255 255 255";
		};
	};
	// getObject() index of objects:
	// 1 : content
	// 2 : BottomScrollBG
	//     0 : bottomScroller
	//         0 : newScroll_BottomScrollHandler
	// 3 : RightScrollBG
	//     0 : RightScroller
	//         0 : newScroll_RightScrollHandler
	// 4 : leftbtn
	// 5 : upbtn
	// 6 : rightbtn
	// 7 : downbtn

	// Set scroll button commands
	%newObj.getObject(5).command = %newObj.getId() @ ".newScroll_scroll(0, -1);";  // Up
	%newObj.getObject(7).command = %newObj.getId() @ ".newScroll_scroll(0, 1);"; // Down
	%newObj.getObject(4).command = %newObj.getId() @ ".newScroll_scroll(-1, 0);";  // Left
	%newObj.getObject(6).command = %newObj.getId() @ ".newScroll_scroll(1, 0);"; // Right

	// Set the object name
	%newObj.setName(getSafeVariableName(%objectName));

	// Return this new object
	return %newObj;
}

function GuiControl::newScroll_getMaxScrollPosition(%this) {
	if(!%this.newScroll) return;
	
	// Get objects
	%scrollBGBtm   = %this.getObject(2);
	%scrollBGRight = %this.getObject(3);
	%scrollBtm     = %this.getObject(2).getObject(0);
	%scrollRight   = %this.getObject(3).getObject(0);
	
	// How far down the scroll bar can go before the bottom of the scroll bar hits the bottom or the right
	%maxScrollX = mAbs(getWord(%scrollBGBtm.getExtent(), 0)-getWord(%scrollBtm.getExtent(), 0));
	%maxScrollY = mAbs(getWord(%scrollBGRight.getExtent(), 1)-getWord(%scrollRight.getExtent(), 1));
	%maxScrollX = (%scrollBtm.isVisible() ? %maxScrollX : 1);
	%maxScrollY = (%scrollRight.isVisible() ? %maxScrollY : 1);

	return %maxScrollX SPC %maxScrollY;
}

function GuiControl::newScroll_setScrollPosition(%this, %x, %y) {
	// Cleanup the variables first
	%x = mClamp(%x, 0, getWord(%this.newScroll_getMaxScrollAmt(), 0));
	%y = mClamp(%y, 0, getWord(%this.newScroll_getMaxScrollAmt(), 1));
	 
	// Right (up-down; %y) first
	%group  = %this.getObject(3).getObject(0);
	%yPos   = (%y/getWord(%this.newScroll_getMaxScrollAmt(), 1))*getWord(%this.newScroll_getMaxScrollPosition(), 1);
//	%yPos  -= getWord(%group.getGroup().newScroll_getAbsolutePosition(), 1);
	%yPos   = mClamp(%yPos, 0, getWord(%this.newScroll_getMaxScrollPosition(), 1));
	%group.resize(0, %yPos, getWord(%group.getExtent(), 0), getWord(%group.getExtent(), 1));

	// Bottom (left-right; %x) next
	%group  = %this.getObject(2).getObject(0);
	%yPos   = (%x/getWord(%this.newScroll_getMaxScrollAmt(), 0))*getWord(%this.newScroll_getMaxScrollPosition(), 0);
//	%yPos  -= getWord(%group.getGroup().newScroll_getAbsolutePosition(), 1);
	%yPos   = mClamp(%yPos, 0, getWord(%this.newScroll_getMaxScrollPosition(), 1));
	%group.resize(0, %yPos, getWord(%group.getExtent(), 0), getWord(%group.getExtent(), 1));

	%this.scrollAmtX = %x;
	%this.scrollAmtY = %y;

	%this.newScroll_calcScrollPosition();
}

function GuiControl::newScroll_calcScrollPosition(%this) {
	if(!%this.newScroll) return;
	
	// Get objects
	%content       = %this.getObject(1);
	%scrollBGBtm   = %this.getObject(2);
	%scrollBGRight = %this.getObject(3);
	%scrollBtm     = %this.getObject(2).getObject(0);
	%scrollRight   = %this.getObject(3).getObject(0);
	
	// How far down the scroll bar can go before the bottom of the scroll bar hits the bottom or the right
	%maxScrollX = mAbs(getWord(%scrollBGBtm.getExtent(), 0)-getWord(%scrollBtm.getExtent(), 0));
	%maxScrollY = mAbs(getWord(%scrollBGRight.getExtent(), 1)-getWord(%scrollRight.getExtent(), 1));
	%maxScrollX = (%scrollBtm.isVisible() ? %maxScrollX : 0);
	%maxScrollY = (%scrollRight.isVisible() ? %maxScrollY : 0);
	
	// Calculate the position
	%positionX  = mFloor((getWord(%scrollBtm.getPosition(), 0)/%maxScrollX)*getWord(%this.newScroll_getMaxScrollAmt(), 0))+1;
	%positionY  = mFloor((getWord(%scrollRight.getPosition(), 1)/%maxScrollY)*getWord(%this.newScroll_getMaxScrollAmt(), 1))+1;

	// Set the position
	if(%content.getCount() == 0) return;
	%object = %content.getObject(0);
	%object.resize(-%positionX, -%positionY, getWord(%object.getExtent(), 0), getWord(%object.getExtent(), 1));
}

function GuiControl::newScroll_getAbsolutePosition(%this) {
	while(true) {
		if(%debug++ >= 100) break;
		%absPos = vectorAdd(%absPos, %this.getPosition());
		%group  = %this.getGroup();
		if(%group.getName() $= "GuiEditorContent") break;
		if(%group.getName() $= "GuiGroup") break;
		if(%group.getName() $= "Canvas") break;
		%this  = %group;
	}
	return %absPos;
}

function GuiControl::newScroll_getAbsoluteGroup(%this) {
	while(true) {
		if(%debug++ >= 100) break;
		%group = %this.getGroup();
		if(%group.getName() $= "GuiEditorContent") break;
		if(%group.getName() $= "GuiGroup") break;
		if(%group.getName() $= "Canvas") break;
		%this  = %group;
	}
	return %this;
}

function GuiControl::newScroll_getMaxScrollAmt(%this) {
	if(!%this.newScroll) return "0 0";

	// Get the content object
	%content = %this.getObject(1);

	// If there aren't any objects in the scroll content, then just return zero
	if(%content.getCount() == 0) return "0 0";
	
	// Set the variables
	%objW = getWord(%content.getObject(0).getExtent(), 0);
	%objH = getWord(%content.getObject(0).getExtent(), 1);
	%cntW = getWord(%content.getExtent(), 0);
	%cntH = getWord(%content.getExtent(), 1);
	
	// Clean the variables
	%objW = (%objW <= %cntW ? 0 : %objW);
	%objH = (%objH <= %cntH ? 0 : %objH);
	
	// Return the variables
	return mAbs(%objW-%w) SPC mAbs(%objH-%h);
}

function GuiControl::newScroll_scroll(%this, %x, %y) {
	if(!%this.newScroll) return;

	// Speed of the scroll
	%speed   = %this.scrollSpeed;
	
	// Calculate the new scroll amounts
	%newXAmt = %this.scrollAmtX+(%speed*%x);
	%newYAmt = %this.scrollAmtY+(%speed*%y);

	// Set the new amounts
	%this.newScroll_setScrollPosition(%newXAmt, %newYAmt);
}

function GuiControl::newScroll_render(%this) {
	if(!%this.newScroll) return;
	
	// Set the variables
	%maxScrollW = getWord(%this.newScroll_getMaxScrollAmt(), 0);
	%maxScrollH = getWord(%this.newScroll_getMaxScrollAmt(), 1);
	%scrollAmtX = %this.scrollAmtX;
	%scrollAmtY = %this.scrollAmtY;
	
	// Get objects
	%content      = %this.getObject(1);
	%scroll_btm   = %this.getObject(2).getObject(0);
	%scroll_right = %this.getObject(3).getObject(0);

	// Calculate the bottom scroll bar
	if(%maxScrollW > 0) {
		if(!%scroll_btm.isVisible()) %scroll_btm.setVisible(1);
		%scrollWidth = getWord(%scroll_btm.getGroup().getExtent(), 0)-(%maxScrollW-getWord(%content.getExtent(), 0));
		%xPos        = getWord(%scroll_btm.getPosition(), 0);
		%yPos        = getWord(%scroll_btm.getPosition(), 1);
		if(getWord(%scroll_btm.getPosition(), 0)+%scrollWidth >= getWord(%scroll_btm.getGroup().getExtent(), 0)) {
			%xPos = getWord(%scroll_btm.getGroup().getExtent(), 0)-%scrollWidth;
		}
		%scroll_btm.resize(%xPos,
				   %yPos,
				   %scrollWidth,
				   16);
	} else if(%scroll_btm.isVisible()) { %scroll_btm.setVisible(0); %scroll_btm.resize(0, 0, 28, 16); }

	// Calculate the right scroll bar
	if(%maxScrollH > 0) {
		if(!%scroll_right.isVisible()) %scroll_right.setVisible(1);
		%scrollHeight = getWord(%scroll_right.getGroup().getExtent(), 1)-(%maxScrollH-getWord(%content.getExtent(), 1));
		%xPos        = getWord(%scroll_right.getPosition(), 0);
		%yPos        = getWord(%scroll_right.getPosition(), 1);
		if(getWord(%scroll_btm.getPosition(), 1)+%scrollHeight >= getWord(%scroll_right.getGroup().getExtent(), 1)) {
			%yPos = getWord(%scroll_right.getGroup().getExtent(), 1)-%scrollHeight;
		}
		%scroll_right.resize(getWord(%scroll_right.getPosition(), 0),
				     getWord(%scroll_right.getPosition(), 1),
				     16,
				     %scrollHeight);
	} else if(%scroll_right.isVisible()) { %scroll_right.setVisible(0); %scroll_right.resize(0, 0, 16, 28); }
}

// Mouse & input event handlers

function newScroll_handleMouseWheel(%val) {
	%lastObj = NewScrollActionMap.lastObj;
	%master  = %lastObj.getGroup().getGroup();
	if(%val >= 0) {
		// Up
		%master.newScroll_scroll(0, -1);
	} else {
		// Down
		%master.newScroll_scroll(0, 1);
	}
}

function NewScrollMouseHandler::onMouseEnter(%this) {
	NewScrollActionMap.lastObj = %this.getGroup().getObject(3).getObject(0);
	NewScrollActionMap.push();
}

function NewScrollMouseHandler::onMouseLeave(%this) {
	NewScrollActionMap.pop();
}

function newScroll_RightScrollHandler::isValid(%this) {
	%absPosOfLast = %this.getGroup().getGroup().newScroll_getAbsolutePosition();
	%objLeft      = getWord(%absPosOfLast, 0);
	%objTop       = getWord(%absPosOfLast, 1);
	%objRight     = getWord(%absPosOfLast, 0)+getWord(%this.getGroup().getGroup().getExtent(), 0);
	%objBottom    = getWord(%absPosOfLast, 1)+getWord(%this.getGroup().getGroup().getExtent(), 1);
	%cursorPos    = Canvas.getCursorPos();
	%cPosX        = getWord(%cursorPos, 0);
	%cPosY        = getWord(%cursorPos, 1);
	if(%cPosX >= %objLeft && %cPosX <= %objRight && %cPosY >= %objTop && %cPosY <= %objBottom && !%this.isDragging) {
		return 1;
	}
	return 0;
}

function newScroll_RightScrollHandler::onMouseLeave(%this, %modifier, %mousePoint, %mouseClickCount) {
}

function newScroll_RightScrollHandler::onMouseEnter(%this, %modifier, %mousePoint, %mouseClickCount) {
}

function newScroll_RightScrollHandler::onMouseDown(%this, %modifier, %mousePoint, %mouseClickCount) {
	%this.mouseYOffset = mAbs(getWord(%mousePoint, 1)-getWord(%this.newScroll_getAbsolutePosition(), 1));
	%this.dragLoop();
}

function newScroll_RightScrollHandler::onMouseUp(%this, %modifier, %mousePoint, %mouseClickCount) {
	cancel(%this.dragLoop);
}

function newScroll_RightScrollHandler::dragLoop(%this) {
	if(!%this.isValid()) return;
	%group  = %this.getGroup();
	%master = %this.getGroup().getGroup().getGroup();
	%yPos   = mAbs(getWord(Canvas.getCursorPos(), 1)-%this.mouseYOffset);
	%yPos  -= getWord(%group.getGroup().newScroll_getAbsolutePosition(), 1);
	%yPos   = mClamp(%yPos, 0, getWord(%master.newScroll_getMaxScrollPosition(), 1));
	%group.resize(0, %yPos, getWord(%group.getExtent(), 0), getWord(%group.getExtent(), 1));
	%master.newScroll_calcScrollPosition();
	cancel(%this.dragLoop);
	%this.dragLoop = %this.schedule(1, dragLoop);
}

function newScroll_BottomScrollHandler::isValid(%this) {
	%absPosOfLast = %this.getGroup().getGroup().newScroll_getAbsolutePosition();
	%objLeft      = getWord(%absPosOfLast, 0);
	%objTop       = getWord(%absPosOfLast, 1);
	%objRight     = getWord(%absPosOfLast, 0)+getWord(%this.getGroup().getGroup().getExtent(), 0);
	%objBottom    = getWord(%absPosOfLast, 1)+getWord(%this.getGroup().getGroup().getExtent(), 1);
	%cursorPos    = Canvas.getCursorPos();
	%cPosX        = getWord(%cursorPos, 0);
	%cPosY        = getWord(%cursorPos, 1);
	if(%cPosX >= %objLeft && %cPosX <= %objRight && %cPosY >= %objTop && %cPosY <= %objBottom && !%this.isDragging) {
		return 1;
	}
	return 0;
}

function newScroll_BottomScrollHandler::onMouseDown(%this, %modifier, %mousePoint, %mouseClickCount) {
	%this.mouseXOffset = mAbs(getWord(%mousePoint, 0)-getWord(%this.newScroll_getAbsolutePosition(), 0));
	%this.dragLoop();
}

function newScroll_BottomScrollHandler::onMouseUp(%this, %modifier, %mousePoint, %mouseClickCount) {
	cancel(%this.dragLoop);
}

function newScroll_BottomScrollHandler::dragLoop(%this) {
	if(!%this.isValid()) return;
	%group  = %this.getGroup();
	%master = %this.getGroup().getGroup().getGroup();
	%xPos   = mAbs(getWord(Canvas.getCursorPos(), 0)-%this.mouseXOffset);
	%xPos  -= getWord(%group.getGroup().newScroll_getAbsolutePosition(), 0);
	%xPos   = mClamp(%xPos, 0, getWord(%master.newScroll_getMaxScrollPosition(), 0));
	%group.resize(%xPos, 0, getWord(%group.getExtent(), 0), getWord(%group.getExtent(), 1));
	%master.newScroll_calcScrollPosition();
	cancel(%this.dragLoop);
	%this.dragLoop = %this.schedule(1, dragLoop);
}