package ScratchClientInitPackage {
	function MM_UpdateDemoDisplay() {
		Scratch::loadAddons();
		Parent::MM_UpdateDemoDisplay();
		deactivatePackage(ScratchClientInitPackage);
	}
};
activatePackage(ScratchClientInitPackage);

if($Scratch::Debug $= "")      $Scratch::Debug = 0;
if($Scratch::RenderType $= "") $Scratch::RenderType = 1;
if($Scratch::BuildType $= "")  $Scratch::BuildType = (getNumKeyID() == 15144 ? "DEBUG" : "Release");

if(!isObject(ScratchPlrCreator_PanelProfile)) new GuiControlProfile(ScratchPlrCreator_PanelProfile : GuiDefaultProfile) {
	border      = 1;
	borderColor = "0 0 0 255";
	fillColor   = "255 255 255 255";
	opaque      = 1;
};

if(!isObject(ScratchPlrCreator_ScrollProfile)) new GuiControlProfile(ScratchPlrCreator_ScrollProfile : GuiScrollProfile) {
	border      = 0;
};

if(!isObject(ScratchPlrCreator_NumberOnlyTextEditProfile)) new GuiControlProfile(ScratchPlrCreator_NumberOnlyTextEditProfile : GuiTextEditProfile) {
	numbersOnly = 1;
};

if(!isObject(GuiScratchArgTextEdit)) new GuiControlProfile(GuiScratchArgTextEdit : GuiTextEditProfile) {
	border      = 0;
	fillColor   = "0 0 0 0";
	fillColorHL = "100 100 100 255";
	fillColorNA = "0 0 0 0";
	fontType    = "Consolas Bold";
	fontSize    = 16;
	textOffset  = "0 0";
};

if(!isObject(ScratchSpawnMenuSearchProfile)) new GuiControlProfile(ScratchSpawnMenuSearchProfile : GuiTextEditProfile) {
	fontColor   = "100 100 100 255";
};

if(!isObject(GuiScratchIgnoreTextProfile)) new GuiControlProfile(GuiScratchIgnoreTextProfile : GuiMLTextProfile) {
	modal = 0;
};

if(!isObject(GuiScratchNoModalProfile)) new GuiControlProfile(GuiScratchNoModalProfile : GuiDefaultProfile) {
	modal = 0;
};

if(!isObject(ScratchTextListProfile)) new GuiControlProfile(ScratchTextListProfile : GuiTextListProfile) {
	fontType = "Consolas";
	fontSize = 14;
};

if(!isObject(ScratchFileSelectorTextListProfile)) new GuiControlProfile(ScratchFileSelectorTextListProfile : GuiTextListProfile) {
	fontType = "Consolas";
	fontSize = 12;
};


if(!isObject(ScratchScrollProfile)) new GuiControlProfile(ScratchScrollProfile : GuiScrollProfile) {
	fillColor = "200 200 200 210";
};

if(!isObject(ScratchNewScrollProfile)) new GuiControlProfile(ScratchNewScrollProfile : GuiDefaultProfile) {
	border      = 1;
	borderColor = "0 0 0 255";
	fillColor   = "200 200 200 210";
	opaque      = 1;
	modal       = 0;
};

if(!isObject(ScratchContentProfile)) new GuiControlProfile(ScratchContentProfile : GuiScrollProfile) {
	fillColor = "221 222 222 255";
};

if(!isObject(ScratchSpawnButtonProfile)) new GuiControlProfile(ScratchSpawnButtonProfile : GuiBitmapBorderProfile) {
	bitmap = "Add-Ons/Client_Scratch/img/spawnBtn";
};

if(!isObject(ScratchBlockOutlineProfile)) new GuiControlProfile(ScratchBlockOutlineProfile : GuiBitmapBorderProfile) {
	bitmap = "Add-Ons/Client_Scratch/img/outline";
};

if(!isObject(ScratchHintBlockProfile)) new GuiControlProfile(ScratchHintBlockProfile : GuiDefaultProfile) {
	border      = 1;
	borderColor = "209 157 0 255";
	fillColor   = "255 190 0 255";
	opaque      = 1;
};

if(!isObject(ScratchExportButtonProfile)) new GuiControlProfile(ScratchExportButtonProfile : GuiButtonProfile) {
	fontType = "Arial Bold";
	fontSize = 22;
	doFontOutline = 1;
	fontColor = "0 255 0 255";
	fontOutlineColor = "0 220 0 255";
};
ScratchExportButtonProfile.fontOutlineColor = "0 0 0 255";
ScratchExportButtonProfile.fontColor = "255 255 255 255";

function scratch() {
	Canvas.pushDialog(ScratchGui);
}

function wordPos(%str, %word) {
	for(%i=0;%i<getWordCount(%str);%i++) if(getWord(%str, %i) $= %word) return %i;
	return -1;
}

function isWordInString(%str, %word) {
	if(getWord(%str, 0) $= %word) return 1;
	if(getWord(%str, getWordCount(%str)-1) $= %word) return 1;
	if(strIPos(%str, " " @ %word @ " ") != -1) return 1;
	return 0;
}

function strPos_Last(%str, %find, %offset) {
	if(%offset $= "") %offset = 0;
	%found = strPos(%str, %find, %offset);
	while(%found != -1) {
		if(strPos(%str, %find, %found+1) == -1) return %found;
		%found = strPos(%str, %find, %found+1);
	}
	return -1;
}

function strFindFirst(%str, %find, %offset) {
	if(%offset $= "") %offset = 0;
	%ret = 999999;
	for(%i=0;%i<strLen(%find);%i++) {
		%chr = getSubStr(%find, %i, 1);
		if(strPos(%str, %chr, %offset) < %ret && strPos(%str, %chr, %offset) != -1) %ret = strPos(%str, %chr, %offset);
	}
	return (%ret == 999999 ? "-1" : %ret);
}

function striFindFirst(%str, %find, %offset) {
	return strFindFirst(strLwr(%str), strLwr(%find), %offset);
}

function strFindFirst_NotOf(%str, %find, %offset) {
	if(%offset $= "") %offset = 0;
	%str = getSubStr(%str, %offset, strLen(%str));
	for(%i=0;%i<strLen(%find);%i++) %str = strReplace(%str, getSubStr(%find, %i, 1), "\x01");
	%ret = 999999;
	for(%i=0;%i<=strLen(%str);%i++) {
		if(%i == strLen(%str)) return -1;
		%chr = getSubStr(%str, %i, 1);
		if(%chr $= "\x01") continue;
		return %i+%offset;
	}
}

function striFindFirst_NotOf(%str, %find, %offset) {
	return strFindFirst_NotOf(strLwr(%str), strLwr(%find), %offset);
}

function striPos_Last(%str, %find, %offset) {
	return strPos_Last(strLwr(%str), strLwr(%find), %offset);
}

if(!isObject(ScratchPopUpMenuProfile)) new GuiControlProfile(ScratchPopUpMenuProfile : GuiPopUpMenuProfile) {
	fontType = "Consolas";
	fontSize = "14";
};

if(!isObject(ScratchFileSelector)) exec("./gui/ScratchFileSelector.gui");

if(!isObject(ScratchGui)) exec("./gui/ScratchGui.gui");

if(!isObject(ScratchPlayerGui)) exec("./gui/ScratchPlayerGui.gui");

function initScratch() {
	%files = "Support_Array.cs Support_NewScroll/Support_NewScroll.cs fileSelector.cs workSpaces.cs Logic.cs Block.cs Gui.cs renderer.cs connections.cs codeconvert.cs codeParser.cs saveLoad.cs funcHelp.cs sounds.cs tooltip.cs rightClickMenu.cs options.cs easeOfAccess.cs debugger.cs projectManager.cs spawnMenu.cs CollabMenu.cs net/client.cs net/server.cs collabConnect.cs highlight.cs blockSyntaxChecker.cs CustomBlocks.cs tutorial.cs";
	for(%i=0;%i<getWordCount(%files);%i++) {
		%file = "Add-Ons/Client_Scratch/" @ getWord(%files, %i);
		if($CACHE::SCRATCH::DEBUG::EXECCRC[getSafeVariableName(%file)] !$= getFileModifiedTime(%file)) {
			$CACHE::SCRATCH::DEBUG::EXECCRC[getSafeVariableName(%file)] = getFileModifiedTime(%file);
			exec(%file);
		}
	}
	// Another loop as to not cause a buffer overflow with the above string
	%files = "plrCreator/abilityManager.cs plrCreator/animManager.cs plrCreator/script.cs";
	for(%i=0;%i<getWordCount(%files);%i++) {
		%file = "Add-Ons/Client_Scratch/" @ getWord(%files, %i);
		if($CACHE::SCRATCH::DEBUG::EXECCRC[getSafeVariableName(%file)] !$= getFileModifiedTime(%file)) {
			$CACHE::SCRATCH::DEBUG::EXECCRC[getSafeVariableName(%file)] = getFileModifiedTime(%file);
			exec(%file);
		}
	}
	%path = "base/client/ui/cache/";
	%cach = "Add-Ons/Client_Scratch/fonts/*.gft";
	// Install fonts
	for(%file=findFirstFile(%cach);%file !$= "";%file=findNextFile(%cach)) {
		if(!isFile(%path @ fileName(%file))) fileCopy(%file, %path @ fileName(%file));
	}
	// Init various things
	initScratchWorkspaceMenu();
	// Place the buttons on the options menu
	%obj = new GuiBitmapButtonCtrl(ScratchOpenButton) {
		profile = "BlockButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "494 3";
		extent = "110 19";
		minExtent = "8 2";
		visible = "1";
		command = "Canvas.pushDialog(ScratchGui);Canvas.popDIalog(OptionsDlg);";
		text = "Scratch Editor";
		groupNum = "-1";
		buttonType = "PushButton";
		bitmap = "base/client/ui/button1";
		lockAspectRatio = "0";
		alignLeft = "0";
		overflowImage = "0";
		mKeepCached = "0";
		mColor = "255 255 255 255";
	};
	OptionsDlg.getObject(0).add(%obj);
}
initScratch();

function Scratch::toggleDLL() {
	if($Scratch::RenderBoost) {
		cancel($CACHE::Scratch::RenderSystem::TreeRenderSchedule);
		detachModule("ScratchRenderBoost.dll");
		Scratch_DLLText.setText("DLL is currently <color:CC0000>NOT ACTIVE");
		Scratch::renderTree();
	} else {
		attachModule("ScratchRenderBoost.dll");
		if($Scratch::RenderBoost) Scratch_DLLText.setText("DLL is currently <color:00CC00>ACTIVE");
		else Scratch_DLLText.setText("DLL is currently <color:CC0000>NOT DETECTED");
	}
}

// DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF
// DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF
// DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF
// DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF || DEBUG STUFF

if($Scratch::BuildType !$= "DEBUG") return;

function tohex(%num) {
	%tbl = "0123456789ABCDEF";
	return getSubStr(%tbl, %num / 16, 1) @ getSubStr(%tbl, %num % 16, 1);
}
function rgbToHex(%r, %g, %b) {
	if(getWordCount(%r) == 3) {
		%b = getWord(%r, 2);
		%g = getWord(%r, 1);
		%r = getWord(%r, 0);
	}
	return toHex(%r) @ toHex(%g) @ toHex(%b);
}

function cleanScratch() {
	// clean scratch GUI for saving
	Scratch_ProjectManager_SpawnMenuContent.deleteall();
	%array = ScratchCode;
	%array.empty();
	ScratchContainer.deleteAll();
	Scratch_ProjectManager_Workspaces.deleteAll();
	Scratch_DebugWindow.resize(0, 0, 602, 443);
	Scratch_DebugWindow.setVisible(0);
	Scratch_ToolTip.resize(0, 0, 8, 8);
	Scratch_ToolTip.getObject(0).getObject(0).setText(" ");
	Scratch_ToolTip.setVisible(0);
	Scratch_MainWindow.resize(0, 0, 640, 480);
	Scratch_RightClickMenu.resize(0, 0, 1, 1);
	Scratch_RightClickMenu.setVisible(0);
	Scratch::projMan_setTab(0);
	Scratch::projMan_setScrollSize(0);
	Scratch::spawnMenu_sortItems();
	Scratch::CollabMenu_showAdmin(0);
	Scratch_SelectElement.setVisible(0);
	Scratch_DLLButton.setVisible(0);
	Scratch_DLLText.setVisible(0);
	if(isObject(Scratch_NewScroll)) {
		Scratch_DefaultContentScroll.add(Scratch_Content);
		Scratch_NewScroll.delete();
		Scratch_Content.setProfile(GuiDefaultProfile);
	}
	if(isObject(Scratch_ToolTip_Indicator)) Scratch_ToolTip_Indicator.delete();
}

function debug_server() {
	if(!$INITDEBUG) {
		Canvas.setContent(ScratchGui);
		Scratch::startListenServer("28000");
		$INITDEBUG = 1;
	} else {
		if(!$CACHE::Scratch::Net_Server::Hosting) Scratch::startListenServer("28000");
		exec("add-ons/client_scratch/client.cs");
	}
}

function debug_client() {
	if(!$INITDEBUG) {
		Canvas.setContent(ScratchGui);
		Scratch::connectToServer("127.0.0.1", "28000");
		$INITDEBUG = 1;
	} else {
		if(!ScratchClientTCP.connected) Scratch::connectToServer("127.0.0.1", "28000");
		exec("add-ons/client_scratch/client.cs");
	}
}

function debug_dll() {
	if(!$INITDEBUG) {
		Canvas.setContent(ScratchGui);
		$INITDEBUG = 1;
		Scratch_Content.add(Scratch::createPremadeBlock(0));
		ScratchContainer.getObject(0).renderBlock();
		ConsoleEntry.setValue("ScratchContainer.getObject(0).renderBlock();");
	} else {
		exec("add-ons/client_scratch/client.cs");
		ScratchContainer.getObject(0).renderBlock();
		ConsoleEntry.setValue("ScratchContainer.getObject(0).renderBlock();");
	}
}

function debug_dlltree() {
	if(!$INITDEBUG) {
		Canvas.setContent(ScratchGui);
		$INITDEBUG = 1;
		Scratch_Content.add(Scratch::createPremadeBlock(0));
		cancel($CACHE::Scratch::RenderSystem::TreeRenderSchedule);
		Scratch::update(ScratchContainer.getObject(0), 2);
		Scratch_renderTree();
	} else {
		exec("add-ons/client_scratch/client.cs");
		Scratch::update(ScratchContainer.getObject(0), 2);
		Scratch_renderTree();
	}
}

function debug() {
	if(!$INITDEBUG) {
		$INITDEBUG = 1;
		$Scratch::Debug = 0;
		$Scratch::RenderType = 1;
		Canvas.setContent(ScratchGui);
		Scratch::renderTree();
	} else {
		exec("add-ons/client_scratch/client.cs");
	}
}

function spawnAllBlocks() {
	%x = 2;
	%y = 2;
	for(%i=0;%i<32;%i++) {
		%it = "0";
		switch(%i) {
			case 01: %it = "0 1";
			case 02: %it = "0 1 2 3 4 5 6 7";
			case 06: %it = "0 1 2 3 4";
			case 16: %it = "0 1 2 3 4 5 6 7 8";
			case 28: %it = "0 1";
			case 32: %it = "0 1";
		}
		%largestHeight = 0;
		for(%j=0;%j<getWordCount(%it);%j++) {
			%newObj = Scratch::createPremadeBlock(%i, getWord(%it, %j));
			if(!isObject(%newObj)) break;
			Scratch_Content.add(%newObj);
			Scratch::renderBlock(%newObj);
			Scratch::renderBlock(%newObj);
			if(%newObj.container) {
				Scratch::renderContainer(%newObj);
				Scratch::renderContainer(%newObj);
			}
			%newObj.resize(%x, %y, %newObj.getWidth(), %newObj.getHeight());
			if(%newObj.getHeight() > %largestHeight) %largestHeight = %newObj.getHeight();
			%x += %newObj.getWidth()+1;
			if(%x >= Scratch_Content.getWidth()) {
				%y += %largestHeight+1;
				%x  = 0;
				%largestHeight = 0;
			}
		}
	}
}