function Struct_funcCall(%str, %doNotClean) {
	//  "Namespace\nFunctionName\nArgs (Delimited by tabs)"
	if(strIPos(%str, "(") == -1 || strIPos(%str, ")") == -1) return "";
	if(strIPos(%str, ".") != -1 && strIPos(%str, ".") < strIPos(%str, "(")) {
		%nameSpace = getSubStr(%str, 0, strIPos(%str, "."));
		%funcName  = getSubStr(%str, strIPos(%str, ".")+1, strLen(%str));
		%funcName  = getSubStr(%funcName, 0, strIPos(%funcName, "("));
	} else if(strIPos(%str, "::") != -1 && strIPos(%str, "::") < strIPos(%str, "(")) {
		%nameSpace = getSubStr(%str, 0, strIPos(%str, "::"));
		%funcName  = getSubStr(%str, strIPos(%str, "::")+2, strLen(%str));
		%funcName  = getSubStr(%funcName, 0, strIPos(%funcName, "("));
	} else %funcName  = getSubStr(%str, 0, strIPos(%str, "("));
	%argTable  = getSubStr(%str, strIPos(%str, "(")+1, strLen(%str));
	%argTable  = getSubStr(%argTable, 0, strIPos_Last(%argTable, ")"));
	%argTable  = strReplace(%argTable, "\\\"", "[[QUOTE]]");
	%inQuotes  = 0;
	for(%i=0;%i<strLen(%argTable);%i++) {
		%chr = getSubStr(%argTable, %i, 1);
		if(%chr $= "\"") {
			if(%inQuotes) {
				// End quote
				%inQuotes = 0;
				%clean[-1+%cleanCount++] = %buffer;
			} else { %buffer = ""; %inQuotes = 1; continue; }
		}
		if(%inQuotes) %buffer = %buffer @ %chr;
	}
	for(%i=0;%i<%cleanCount;%i++) {
		%clean    = %clean[%i];
		%clean    = strReplace(%clean, ",", "[[COMMA]]");
		%clean    = strReplace(%clean, " ", "[[SPC]]");
		%argTable = strReplace(%argTable, %clean[%i], %clean);
	}
	%argTable  = strReplace(%argTable, ",", "\t");
	for(%i=0;%i<getFieldCount(%argTable);%i++) {
		%args = trim(%args TAB trim(getField(%argTable, %i)));
	}
	%args = strReplace(%args, "[[COMMA]]", ",");
	%args = strReplace(%args, "[[QUOTE]]", "\\\"");
	if(!%doNotClean) {
		%funcName  = trim(%funcName);
		%nameSpace = trim(%nameSpace);
		if(getSafeVariableName(%funcName) !$= %funcName) return "";
	}
	return %nameSpace NL %funcName NL %args;
}

function Scratch::findCodeBlockStart(%stream, %line, %file, %LC, %doNotError) {
	if(!isObject(%stream)) return "";
	while(strIPos(%line, "{") == -1 && !%stream.isEOF()) %line = %line @ trim(%stream.readLine());
	if(strIPos(%line, "{") == -1 && %stream.isEOF()) {
		if(!%doNotError) {
			echo("\c2ERROR   | Scratch::readFileToBlock | " @ %file SPC "Line: " @ %LC @ " - Could not find '{'");
			echo("\c2ERROR   | Scratch::readFileToBlock | \c1>> The line that elicited the error:");
			echo("\c2ERROR   | Scratch::readFileToBlock | " @ %line);
			backTrace();
			%stream.close();
			%stream.delete();
		}
		return "";
	}
	return %line;
}

function Scratch::findAnyStatementEnd(%stream, %line, %file, %LC, %doNotError) {
	if(!isObject(%stream)) return "";
	while((strIPos(%line, "}") == -1 && getSubStr(%line, strLen(%line)-1, 1) !$= ";" && strIPos(%line, "};") == -1) && !%stream.isEOF()) %line = %line @ trim(%stream.readLine());
	if((strIPos(%line, "}") == -1 && getSubStr(%line, strLen(%line)-1, 1) !$= ";" && strIPos(%line, "};") == -1) == -1 && %stream.isEOF()) {
		if(!%doNotError) {
			echo("\c2ERROR   | Scratch::readFileToBlock | " @ %file SPC "Line: " @ %LC @ " - Could not find '}'");
			echo("\c2ERROR   | Scratch::readFileToBlock | \c1>> The line that elicited the error:");
			echo("\c2ERROR   | Scratch::readFileToBlock | " @ %line);
			backTrace();
			%stream.close();
			%stream.delete();
		}
		return "";
	}
	return %line;
}

function Scratch::findCodeBlockEnd(%stream, %line, %file, %LC, %doNotError) {
	if(!isObject(%stream)) return "";
	while(strIPos(%line, "}") == -1 && !%stream.isEOF()) %line = %line @ trim(%stream.readLine());
	if(strIPos(%line, "}") == -1 && %stream.isEOF()) {
		if(!%doNotError) {
			echo("\c2ERROR   | Scratch::readFileToBlock | " @ %file SPC "Line: " @ %LC @ " - Could not find '}'");
			echo("\c2ERROR   | Scratch::readFileToBlock | \c1>> The line that elicited the error:");
			echo("\c2ERROR   | Scratch::readFileToBlock | " @ %line);
			backTrace();
			%stream.close();
			%stream.delete();
		}
		return "";
	}
	return %line;
}

function Scratch::findObjectEnd(%stream, %line, %file, %LC, %doNotError) {
	if(!isObject(%stream)) return "";
	while(strIPos(%line, "};") == -1 && !%stream.isEOF()) %line = %line @ trim(%stream.readLine());
	if(strIPos(%line, "};") == -1 && %stream.isEOF()) {
		if(!%doNotError) {
			echo("\c2ERROR   | Scratch::readFileToBlock | " @ %file SPC "Line: " @ %LC @ " - Could not find '}'");
			echo("\c2ERROR   | Scratch::readFileToBlock | \c1>> The line that elicited the error:");
			echo("\c2ERROR   | Scratch::readFileToBlock | " @ %line);
			backTrace();
			%stream.close();
			%stream.delete();
		}
		return "";
	}
	return %line;
}

function Scratch::findStatementEnd(%stream, %line, %file, %LC, %doNotError) {
	while(getSubStr(%line, strLen(%line)-1, 1) !$= ";" && !%stream.isEOF()) %line = %line @ trim(%stream.readLine());
	if(getSubStr(%line, strLen(%line)-1, 1) !$= ";" && %stream.isEOF()) {
		if(!%doNotError) {
			echo("\c2ERROR   | Scratch::readFileToBlock | " @ %file SPC "Line: " @ %LC @ " - Could not find ';'");
			echo("\c2ERROR   | Scratch::readFileToBlock | \c1>> The line that elicited the error:");
			echo("\c2ERROR   | Scratch::readFileToBlock | " @ %line);
			backTrace();
			%stream.close();
			%stream.delete();
		}
		return "";
	}
	return %line;
}

function Scratch::parseParenthesees(%str, %inside) {
	if((%info = Struct_funcCall(%str, 1)) $= "") return;
	%tag  = getRecord(%info, 0) @ getRecord(%info, 1);
	%args = getRecord(%info, 2);
	switch$(getWord(%tag, 0)) {
		case "!":     %type = "16 8";
		case "for":   %type = "23";
		case "if":    %type = "13";
		case "while": %type = "25";
		case "}":     %type = (%tag $= "} else if" ? "14" : "-1");
		case "new":   %type = (%inside ? "17" : "18");
		default:      %type = "1" SPC (%inside ? 0 : 1);
	}
	if(!isObject(%newObj = Scratch::createPremadeBlock(getWord(%type, 0), removeWord(%type, 0)))) return;
	%currArg = 0;
	for(%i=0;%i<getFieldCount(%args);%i++) {
		%arg  = getField(%args, %i);
		%bArg = %newObj.blockArgObject[%i];
		if(!isObject(%bArg)) break;
		
		Scratch::parseParenthesees(%str, 1);
	}
	Scratch_Content.add(%newObj);
}

function Scratch::parseArgs_debug(%str) {
	%instSet = new ScriptObject() { class = "ArrayObject"; };
	Scratch::parseArgs(%instSet, %str, 0);
	%instSet.dumpData();
	%instSet.delete();
}

function Scratch::parseArgs(%instSet, %args, %offset) {
	%offset = (%offset $= "" ? "0" : %offset);
	for(%i=0;%i<%offset;%i++) %indentSet = %indentSet @ "-";
	%start  = %instSet.size();
	for(%i=0;%i<getFieldCount(%args);%i++) {
		%arg = getField(%args, %i);
		if(%arg $= "true" || %arg $= "false") {
			%instSet.push_back(Scratch::indent(strLen(%indentSet)) @ "INS_TEXT " @ (%arg $= "true" ? "1" : "0"));
			continue;
		}
		if(%i >= 1) {
			// argument delimitation
			%instSet.push_back(Scratch::indent(strLen(%indentSet)) @ "INPUT_BLOCK 8");
			%instSet.push_back(" " @ %instSet.at(%instSet.size()-2));
			%instSet.erase(%instSet.size()-3);
			%indentSet = "1" @ %indentSet;
		}
		%concat = 0;
		for(%j=0;%j<strLen(%arg);%j++) {
			%chr = getSubStr(%arg, %j, 1);
			if(%chr $= " ") continue;
			if($Scratch::BuildType $= "DEBUG") echo("   | " @ %j @ ": \"" @ %chr @ "\"");
			if(%indentSet !$= "") {
				if(getSubStr(%indentSet, 0, 1) !$= "-") {
					if(getSubStr(%indentSet, 0, 1) $= "0") {
						%indentSet = getSubStr(%indentSet, 1, strLen(%indentSet));
					} else {
						%indentSet = (atoi(getSubStr(%indentSet, 0, 1))-1) @ getSubStr(%indentSet, 1, strLen(%indentSet));
					}
				}
			}
			if(%chr $= "\"" && strIPos(%arg, "\"", %j+1) != -1) {
				// text
				%text = getSubStr(%arg, %j+1, strLen(%arg));
				%text = getSubStr(%text, 0, strIPos(%text, "\""));
				if($Scratch::BuildType $= "DEBUG") echo("   | | TEXT (\"" @ %text @ "\")");
				%j   += strLen(%text)+2;
				%instSet.push_back(Scratch::indent(strLen(%indentSet)) @ "INS_TEXT " @ %text);
			} else if(%chr $= "%" || %chr $= "$") {
				// variable
				%varName = "";
				%varType = (%chr $= "%" ? 3 : 4);
				for(%k=%j+1;%k<strLen(%arg);%k++) {
					%chr_child = getSubStr(%arg, %k, 1);
					if(getSubStr(%arg, %k, 2) $= "::") { %k++; %varName = %varName @ "::"; continue; }
					if(getSafeVariableName(%chr_child) !$= %chr_child) break;
					%varName = %varName @ %chr_child;
				}
				if($Scratch::BuildType $= "DEBUG") echo("   | | VARIABLE (" @ (%varType == 3 ? "%" : "$") @ %varName @ ")");
				%j += strLen(%varName);
				%instSet.push_back(Scratch::indent(strLen(%indentSet)) @ "INPUT_BLOCK" SPC %varType SPC %varName);
			} else if(%chr $= "@") {
				// string concantenation
				if($Scratch::BuildType $= "DEBUG") echo("   | | CONCANTENATION (" @ %instSet.at(%instSet.size()-2) @ ")");
				if(!%concat) {
					%concat = 1;
					%instSet.push_back(Scratch::indent(strLen(%indentSet)) @ "INPUT_BLOCK 5");
					%instSet.push_back(" " @ %instSet.at(%instSet.size()-2));
					%instSet.erase(%instSet.size()-3);
					%indentSet = "2" @ %indentSet;
				} else {
					%instSet.push_back(Scratch::indent(strLen(%indentSet)) @ "ADD_DELIM");
				}
			} else if(stripChars(%chr, "0123456789-") $= "" && ((%chr $= "-" && stripChars(getSubStr(%arg, %j+1, 1), "0123456789") $= "") || %chr !$= "-")) {
				// int / float
				if($Scratch::BuildType $= "DEBUG") echo("   | | NUMBER");
				%nmb = "";
				for(%k=%j;%k<strLen(%arg);%k++) {
					%chr_child = getSubStr(%arg, %k, 1);
					if(trim(stripChars(%chr_child, "0123456789." @ (%nmb $= "" ? "-" : ""))) !$= "") break;
					%nmb = %nmb @ %chr_child;
				}
				%j += strLen(%nmb)-1;
				%instSet.push_back(Scratch::indent(strLen(%indentSet)) @ "INS_TEXT " @ %nmb);
			} else if(%chr $= "!" && getSubStr(%arg, %j, 3) !$= "!$=" && getSubStr(%arg, %j, 2) !$= "!=") {
				// Negation operation
				if($Scratch::BuildType $= "DEBUG") echo("   | NEGATION OPERATION");
				%instSet.push_back(Scratch::indent(strLen(%indentSet)) @ "INPUT_BLOCK 16[8]");
				%indentSet = "2" @ %indentSet;
			} else if(strIPos("*/-+%", %chr) != -1 && getSubStr(%arg, %j+1, 1) !$= "=" && ((%chr $= "+" && getSubStr(%arg, %j+1, 1) !$= "+") || %chr !$= "+")) {
				// math
				if($Scratch::BuildType $= "DEBUG") echo("   | | MATH");
				switch$(%chr) {
					case "+": %type = 0;
					case "-": %type = 1;
					case "*": %type = 2;
					case "/": %type = 3;
					case "%": %type = 4;
					default: error("ERROR   | Scratch::parseArgs | Invalid arithmetic operator -- this is NOT supposed to happen"); continue;
				}
				%instSet.push_back(Scratch::indent(strLen(%indentSet)) @ "INPUT_BLOCK 6[" @ %type @ "]");
				%instSet.push_back(" " @ %instSet.at(%instSet.size()-2));
				%instSet.erase(%instSet.size()-3);
			} else if(strIPos("|&", %chr) != -1 && strIPos("|&", getSubStr(%arg, %j+1, 1)) != -1) {
				if($Scratch::BuildType $= "DEBUG") echo("   | | OR / AND");
				%op   = getSubStr(%arg, %j, 2);
				%type = (%op $= "||" ? "30" : "31");
				%instSet.push_back(Scratch::indent(strLen(%indentSet)) @ "INPUT_BLOCK " @ %type);
				%instSet.push_back(" " @ %instSet.at(%instSet.size()-2));
				%instSet.erase(%instSet.size()-3);
				%j++;
			} else if((%op = getSubStr(%arg, %j, 2)) $= "==" || %op $= "!=" || %op $= "$=" || getSubStr(%arg, %j, 3) $= "!$=" || %op $= ">=" || %op $= "<=" || %chr $= ">" || %chr $= "<") {
				// logical comparison
				if($Scratch::BuildType $= "DEBUG") echo("   | | LOGICAL COMPARISON");
				%op = "";
				for(%k=%j;%k<strLen(%arg);%k++) {
					%chr_child = getSubStr(%arg, %k, 1);
					if(stripChars(%chr_child, "=$!<>") !$= "") break;
					%op = %op @ %chr_child;
				}
				%j += strLen(%op);
				switch$(%op) {
					case "==":  %type = 0;
					case "!=":  %type = 1;
					case "$=":  %type = 2;
					case "!$=": %type = 3;
					case ">=":  %type = 4;
					case "<=":  %type = 5;
					case ">":   %type = 6;
					case "<":   %type = 7;
					default: warn("WARNING | Scratch::parseArgs | Invalid logical operation"); continue;
				}
				%instSet.push_back(Scratch::indent(strLen(%indentSet)) @ "INPUT_BLOCK 16[" @ %type @ "]");
				%instSet.push_back(" " @ %instSet.at(%instSet.size()-2));
				%instSet.erase(%instSet.size()-3);
				%indentSet = "2" @ %indentSet;
			} else if(strIPos("-+=", %chr) != -1) {
				// set variable
				if($Scratch::BuildType $= "DEBUG") echo("   | | SET VARIABLE");
				%op = "";
				for(%k=%j;%k<strLen(%arg);%k++) {
					%chr_child = getSubStr(%arg, %k, 1);
					if(stripChars(%chr_child, "-+=") !$= "") break;
					%op = %op @ %chr_child;
				}
				%j += strLen(%op);
				switch$(%op) {
					case "++":  %type = 0; %amt = 1;
					case "--":  %type = 1; %amt = 1;
					case "=":   %type = 2; %amt = 2;
					case "+=":  %type = 3; %amt = 2;
					case "-=":  %type = 4; %amt = 2;
					default: warn("WARNING | Scratch::parseArgs | Invalid set operation"); continue;
				}
				%instSet.push_back(Scratch::indent(strLen(%indentSet)) @ "INPUT_BLOCK 27[" @ %type @ "]");
				%instSet.push_back(" " @ %instSet.at(%instSet.size()-2));
				%instSet.erase(%instSet.size()-3);
				%indentSet = %amt @ %indentSet;
			} else if(%chr $= ".") {
				// object variable
				if($Scratch::BuildType $= "DEBUG") echo("   | OBJECT VARIABLE");
				%varName = "";
				for(%k=%j+1;%k<strLen(%arg);%k++) {
					%chr_child = getSubStr(%arg, %k, 1);
					if(getSafeVariableName(%chr_child) !$= %chr_child) break;
					%varName = %varName @ %chr_child;
				}
				%j += strLen(%varName);
				%instSet.push_back(Scratch::indent(strLen(%indentSet)) @ "INPUT_BLOCK 29");
				%instSet.push_back(" " @ %instSet.at(%instSet.size()-2));
				%instSet.erase(%instSet.size()-3);
				%instSet.push_back(Scratch::indent(strLen(%indentSet)) @  " INS_TEXT " @ %varName);
				%indentSet = "2" @ %indentSet;
			} else {
				%buffer = "";
				%count  = 0;
				for(%k=%j;%k<strLen(%args);%k++) {
					%chr_child = getSubStr(%args, %k, 1);
					%chr_child = strReplace(%chr_child, "\t", ",");
					if(%count == 0 && %chr_child $= ")") break;
					else if(%chr_child $= ")") %count--;
					if(%chr_child $= "(") %count++;
					%buffer = %buffer @ %chr_child;
				}
				if((%info = Struct_funcCall(%buffer)) !$= "") {
					if($Scratch::BuildType $= "DEBUG") echo("   | FUNCTION CALL(?)");
					%j        += strLen(%buffer);
					%nameSpace = getRecord(%info, 0);
					%funcName  = getRecord(%info, 1);
					%args      = getRecord(%info, 2);
					if(%nameSpace $= "") {
						%instSet.push_back(Scratch::indent(strLen(%indentSet)) @ "INPUT_BLOCK 1[0]" SPC %funcName);
					} else {
						%instSet.push_back(Scratch::indent(strLen(%indentSet)) @ "INPUT_BLOCK 28[0] -1" SPC %funcName);
						Scratch::parseArgs(%instSet, %nameSpace, %offset+1);
					}
					%instSet.push_back(Scratch::indent(strLen(%indentSet)) @ "{");
					Scratch::parseArgs(%instSet, %args, %offset+1);
					%instSet.push_back(Scratch::indent(strLen(%indentSet)) @ "}");
				}
			}
		}
	}
}
function Scratch::indent(%size) {
	for(%i=0;%i<mClamp(%size, 0, 100);%i++) %ret = %ret SPC "";
	return %ret;
}
function Scratch::readFileToBlock(%file) {
	// This function might be a bit messy
	if(!isFile(%file)) {
		error("ERROR   | Scratch::readFileToBlock | \"" @ %file @ "\" does not exist.");
		return 0;
	}
	if(fileExt(%file) !$= ".cs") {
		error("ERROR   | Scratch::readFileToBlock | File extension must be .cs");
		return 0;
	}
	%instSet   = new ScriptObject() { class = "ArrayObject"; };
	%inPackage = 0;
	%endBuffer = "";
	%LC = -1;
	%SO = new FileObject();
	%SO.openForRead(%file);
	while(!%SO.isEOF()) {
		%LC  += 1;
		%dbg  = 0;
		if(!%keepLine) {
			if(!isObject(%SO)) break;
			%line = trim(%SO.readLine());
			if(strIPos(%line, "//") != -1) {
				%line = trim(getSubStr(%line, 0, strIPos(%line, "//")));
			}
			%line = trim(%line);
		} else %keepLine = 0;
		if(%line $= "") continue;
		if($Scratch::BuildType $= "DEBUG") echo("\c4> PARSE \"" @ %line @ "\"");
		while(%line !$= "") {
			if(%dbg++ >= 500) { warn("Broke while loop!"); %error = 1; break; }
			if(%error) break;
			%error = 1;
			switch$(firstWord(%line)) {
				case "package":
					if(%inPackage) {
						echo("\c2ERROR   | Scratch::readFileToBlock | " @ %file SPC "Line: " @ %LC @ " - Tried to define a package within a package");
						echo("\c2ERROR   | Scratch::readFileToBlock | \c1>> The line that elicited the error:");
						echo("\c2ERROR   | Scratch::readFileToBlock | " @ %line);
						backTrace();
						%SO.close();
						%SO.delete();
						%instSet.delete();
						return 0;
					}
					if(strIPos(%line, "{") == -1) if((%line = Scratch::findCodeBlockStart(%SO, %line, %file, %LC)) $= "") { %instSet.delete(); return 0; }
					%statement = getSubStr(%line, 0, strIPos(%line, "{"));
					%inPackage = 1;
					%instSet.push_back("NEW 20" SPC %statement);
					%instSet.push_back("{");
					%endBuffer = trim(%endBuffer TAB "}; }"); // PACKAGED FUNCTION END
					%statement = getSubStr(%line, 0, strIPos(%line, "{")+1);
				case "function":
					if(strIPos(%line, "{") == -1) if((%line = Scratch::findCodeBlockStart(%SO, %line, %file, %LC)) $= "") { %instSet.delete(); return 0; }
					%statement = getSubStr(%line, 0, strIPos(%line, "{"));
					%info      = Struct_funcCall(removeWord(%statement, 0));
					%statement = getSubStr(%line, 0, strIPos(%line, "{")+1);
					%nameSpace = getRecord(%info, 0);
					%funcName  = getRecord(%info, 1);
					%args      = getRecord(%info, 2);
					if(%inPackage) {
						%instSet.push_back("ADD 21" SPC (%nameSpace $= "" ? "" : %nameSpace @ "::") @ %funcName); // PACKAGED FUNCTION
						%instSet.push_back("{");
						%endBuffer = trim(%endBuffer TAB "} ADD 22__}__RES"); // PACKAGED FUNCTION END
					} else {
						%instSet.push_back("NEW 0" SPC (%nameSpace $= "" ? "" : %nameSpace @ "::") @ %funcName); // FUNCTION BLOCK
						%instSet.push_back("{");
						%endBuffer = trim(%endBuffer TAB "} }__RES"); // NULL -- Signifies a new code block tree
					}
					if($Scratch::BuildType $= "DEBUG") echo("\c2 PARSING \"" @ %args @ "\"");
					Scratch::parseArgs(%instSet, %args);
					if($Scratch::BuildType $= "DEBUG") echo("\c4   > FUNC_DECL: " @ %nameSpace @ "::" @ %funcName @ "(" @ %args @ ");");
				case "return":
					if(striPos(%line, ";") == -1) {
						if((%statement = Scratch::findStatementEnd(%SO, %line, %file, %LC)) $= "") { %instSet.delete(); return 0; }
					} else %statement = getSubStr(%line, 0, striPos(%line, ";")+1);
					%instSet.push_back("ADD 7");
					%tempData = Struct_funcCall("test(" @ getSubStr(removeWord(%line, 0), 0, strLen(removeWord(%line, 0))-1) @ ");");
					%instSet.push_back("{");
					Scratch::parseArgs(%instSet, getRecord(%tempData, 2));
					%instSet.push_back("}");
				case "return;":
					%statement = "return;";
					%instSet.push_back("ADD 7");
				case "new":
					%bracket = 1;
					if(strIPos(%line, "{") == -1) {
						if((%temp = Scratch::findCodeBlockStart(%SO, %line, %file, %LC, 1)) $= "") {
							%statement = getSubStr(%line, 0, strPos(%line, ";")+1);
							%funcStyle = getSubStr(%statement, strIPos(%statement, " ")+1, strLen(%statement));
							if((%info = Struct_funcCall(%funcStyle)) $= "") { %instSet.empty(); return 0; }
							%instSet.push_back("ADD 17[1]"); // NEW BLOCK
							%instSet.push_back("{");
							Scratch::parseArgs(%instSet, getRecord(%info, 2));
							%instSet.push_back("}");
						} else %bracket = 0;
					} else %bracket = 0;
					if(!%bracket) {
						%statement = getSubStr(%line, 0, strPos(%line, ";")+1);
						%funcStyle = getSubStr(%statement, strIPos(%statement, " ")+1, strLen(%statement));
						if((%info = Struct_funcCall(%funcStyle)) $= "") { %instSet.empty(); return 0; }
						%instSet.push_back("ADD 18"); // NEW BLOCK
						%instSet.push_back("{");
						Scratch::parseArgs(%instSet, getRecord(%info, 2));
						%endBuffer = trim(%endBuffer TAB "; ADD -1" TAB "} }__RES");
					}
				case "datablock":
					%bracket = 1;
					if(strIPos(%line, "{") == -1) {
						if((%temp = Scratch::findCodeBlockStart(%SO, %line, %file, %LC, 1)) $= "") {
							%statement = getSubStr(%line, 0, strPos(%line, ";")+1);
							%funcStyle = getSubStr(%statement, strIPos(%statement, " ")+1, strLen(%statement));
							if((%info = Struct_funcCall(%funcStyle)) $= "") { %instSet.empty(); return 0; }
							%instSet.push_back("ADD 17[1]"); // NEW BLOCK
							%instSet.push_back("{");
							Scratch::parseArgs(%instSet, getRecord(%info, 2));
							%instSet.push_back("}");
						} else %bracket = 0;
					} else %bracket = 0;
					if(!%bracket) {
						%statement = getSubStr(%line, 0, strPos(%line, "{")+1);
						%funcStyle = getSubStr(%statement, strIPos(%statement, " ")+1, strLen(%statement));
						if((%info = Struct_funcCall(%funcStyle)) $= "") { %instSet.empty(); return 0; }
						%instSet.push_back("ADD 18"); // NEW BLOCK
						%instSet.push_back("{");
						Scratch::parseArgs(%instSet, getRecord(%info, 2));
						%endBuffer = trim(%endBuffer TAB "; ADD -1" TAB "} }__RES");
					}
				default:
					if(%endBuffer !$= "") {
						%expectedEnd  = firstWord(getField(%endBuffer, getFieldCount(%endBuffer)-1));
						if($Scratch::BuildType $= "DEBUG") echo("\c4   > CHECKING EXPECT END: \"" @ getSubStr(%line, 0, strLen(%expectedEnd)) @ "\" $= \"" @ %expectedEnd @ "\"");
						if(getSubStr(%line, 0, strLen(%expectedEnd)) $= %expectedEnd) {
							%error     = 0;
							%line      = trim(getSubStr(%line, strLen(%expectedEnd), strLen(%line)));
							%toSet     = removeWord(getField(%endBuffer, getFieldCount(%endBuffer)-1), 0);
							%toSet     = strReplace(%toSet, "__", "\t");
							for(%k=0;%k<getFieldCount(%toSet);%k++) %instSet.push_back(getField(%toSet, %k));
							%endBuffer = removeField(%endBuffer, getFieldCount(%endBuffer)-1);
							if($Scratch::BuildType $= "DEBUG") echo("\c3      + COMPARISON RETURNED TRUE, EXPECTATION ENDED");
							%keepLine = 1;
							continue;
						}
					}
					if((%info = Struct_funcCall(%line)) !$= "" && strIPos("_if_while_for_", "_" @ getRecord(%info, 1) @ "_") != -1 && strIPos(%line, "{") == -1) {
						%endToken = ";";
						if(getSubStr(%line, strLen(%line)-2, 2) $= "};") %endToken = "};";
						else if(getSubStr(%line, strLen(%line)-1, 1) $= "}") %endToken = "}";
						else if(getSubStr(%line, strLen(%line)-1, 1) $= ";") %endToken = ";";
						else {
							if((%temp = Scratch::findAnyStatementEnd(%SO, %line, %file, %LC, 1)) !$= "") {
								if(getSubStr(%temp, strLen(%temp)-2, 2) $= "};") %endToken = "};";
								else if(getSubStr(%temp, strLen(%temp)-1, 1) $= "}") %endToken = "}";
								%line = %temp;
							}
						}
						// Bracket comes first, so we'll expect that at the end.
						%statement = getSubStr(%line, 0, strIPos_Last(%line, ")")) @ ")";
						%line      = trim(getSubStr(%line, strLen(%statement), strLen(%line)));
						if(%endToken $= ";") { %line = %line @ " }"; %endToken = "}"; }
						echo("NEW LINE: |" @ %line @ "|, STATEMENT: \"" @ %statement @ "\", TEMP:|" @ %temp @ "|");
						if(strIPos(%statement, "else") == 0) {
							%statement = trim(getSubStr(%statement, 4, strLen(%statement)));
							if(strIPos(%statement, "if") == 0) %statement = "else" @ %statement;
							else %statement = "else() " @ %statement;
						}
						echo("SINGLE LINE SPECIAL: ENDTOKEN:\"" @ %endToken @ "\" LINE:\"" @ %line @ "\"");
						%special = getRecord(%info, 1);
						switch$(%special) {
							case "if":    
								%instSet.push_back("ADD 12"); // IF BLOCK
								%instSet.push_back("{");
								Scratch::parseArgs(%instSet, getRecord(%info, 2));
								%endBuffer = trim(%endBuffer TAB %endToken @ " }__RES");
							case "else":
								%instSet.setAt(%instSet.size()-1, "ADD 15"); // ELSE BLOCK
								%instSet.push_back("{");
								%endBuffer = trim(%endBuffer TAB %endToken @ " ADD 13__}__RES"); // IF END
							case "elseif":
								echo("handle elif here");
							case "for":   
								%instSet.push_back("ADD 23"); // FOR BLOCK
								%instSet.push_back("{");
								Scratch::parseArgs(%instSet, getRecord(%info, 2));
								%endBuffer = trim(%endBuffer TAB %endToken @ " ADD 24__}__RES"); // FOR END
							case "while": 
								%instSet.push_back("ADD 25"); // WHILE BLOCK
								%instSet.push_back("{");
								Scratch::parseArgs(%instSet, getRecord(%info, 2));
								%endBuffer = trim(%endBuffer TAB %endToken @ " ADD 26__}__RES"); // WHILE END
							default:
								echo("\c2ERROR   | Scratch::readFileToBlock | " @ %file SPC "Line: " @ %LC @ " - Unknown single line special definition");
								echo("\c2ERROR   | Scratch::readFileToBlock | \c1>> The line that elicited the error:");
								echo("\c2ERROR   | Scratch::readFileToBlock | " @ %statement);
								backTrace();
								%SO.close();
								%SO.delete();
								%instSet.delete();
								return 0;
						}
						%error    = 0;
						continue;
					}
					if(strIPos(%line, "{") != -1) {
						if(strIPos(%statement, "else") == 0) {
							%statement = trim(getSubStr(%statement, 4, strLen(%statement)));
							if(strIPos(%statement, "if") == 0) %statement = "else" @ %statement;
							else %statement = "else() " @ %statement;
						}
						if((%info = Struct_funcCall(%line)) !$= "") {
							%special = getRecord(%info, 1);
							switch$(%special) {
								case "if":    
									%instSet.push_back("ADD 12"); // IF BLOCK
									%instSet.push_back("{");
									Scratch::parseArgs(%instSet, getRecord(%info, 2));
									%endBuffer = trim(%endBuffer TAB "} }__RES");
								case "else":
									%instSet.setAt(%instSet.size()-1, "ADD 15"); // ELSE BLOCK
									%instSet.push_back("{");
									%endBuffer = trim(%endBuffer TAB "} ADD 13__}__RES"); // IF END
								case "elseif":
									echo("handle elif here");
								case "for":   
									%instSet.push_back("ADD 23"); // FOR BLOCK
									%instSet.push_back("{");
									Scratch::parseArgs(%instSet, getRecord(%info, 2));
									%endBuffer = trim(%endBuffer TAB "} ADD 24__}__RES"); // FOR END
								case "while": 
									%instSet.push_back("ADD 25"); // WHILE BLOCK
									%instSet.push_back("{");
									Scratch::parseArgs(%instSet, getRecord(%info, 2));
									%endBuffer = trim(%endBuffer TAB "} ADD 26__}__RES"); // WHILE END
								default:
									echo("\c2ERROR   | Scratch::readFileToBlock | " @ %file SPC "Line: " @ %LC @ " - Unknown special definition");
									echo("\c2ERROR   | Scratch::readFileToBlock | \c1>> The line that elicited the error:");
									echo("\c2ERROR   | Scratch::readFileToBlock | " @ %statement);
									backTrace();
									%SO.close();
									%SO.delete();
									%instSet.delete();
									return 0;
							}
							%error = 0;
							%line = trim(getSubStr(%line, strLen(%statement), strLen(%line)));
							continue;
						}
					}
					if(striPos(%line, ";") == -1) {
						if((%statement = Scratch::findStatementEnd(%SO, %line, %file, %LC)) $= "") { %instSet.delete(); return 0; }
					} else %statement = getSubStr(%line, 0, striPos(%line, ";")+1);
					if((%info = Struct_funcCall(%statement)) !$= "") {
						%nameSpace = getRecord(%info, 0);
						%funcName  = getRecord(%info, 1);
						%args      = getRecord(%info, 2);
						if($Scratch::BuildType $= "DEBUG") echo("\c4   > FUNC_CALL: NAMESPACE=\"" @ %nameSpace @ "\",FUNCNAME=\"" @ %funcName @ "\",ARGS=\"" @ %args @ "\"");
						for(%i=0;%i<getFieldCount(%args);%i++) {
							%arg = getField(%args, 0);
							if($Scratch::BuildType $= "DEBUG") echo("\c3      + (ARG " @ %i @ ": \"" @ %arg @ "\")");
						}
						if(%nameSpace $= "") %instSet.push_back("ADD 1[1]" SPC %funcName); // CALL FUNC BLOCK (NON-INPUT)
						else {
							%instSet.push_back("ADD 28[1] -1" SPC %funcName); // CALL METHOD FUNC BLOCK (NON-INPUT)
							Scratch::parseArgs(%instSet, %nameSpace);
						}
						%instSet.push_back("{");
						Scratch::parseArgs(%instSet, %args);
						%instSet.push_back("}");
					} else if((getSubStr(%statement, 0, 1) $= "%" || getSubStr(%statement, 0, 1) $= "$") && (strIPos(%statement, "=") != -1 || strIPos(%statement, "++") != -1 || strIPos(%statement, "--") != -1)) {
						// Set variable
						%info     = trim(%statement);
						%type     = (getSubStr(%info, 0, 1) $= "%" ? "3" : "4"); // 3 = local, 4 = global
						%varName  = trim(getSubStr(%info, 1, striFindFirst(%info, " +-*/%=", 1)-1));
						%info     = trim(getSubStr(%info, strLen(%varName)+1, strLen(%info)));
						%operator = getSubStr(%info, 0, (getSubStr(%info, 0, 1) $= "=" ? 1 : 2));
						%info     = trim(getSubStr(%info, strLen(%operator), strLen(%info)));
						%value    = getSubStr(%info, 0, strLen(%info)-1);
						if($Scratch::BuildType $= "DEBUG") echo(%operator);
						switch$(%operator) {
							case "++": %setType = 0;
							case "--": %setType = 1;
							case "+=": %setType = 2;
							case "-=": %setType = 3;
							case "*=": %setType = 4;
							case "/=": %setType = 5;
							case "%=": %setType = 6;
							case "=":  %setType = 7;
							default: warn("WARNING | Scratch::readFileToBlock | SET_VAR - Invalid operator"); continue;
						}
						%instSet.push_back("ADD 2[" @ %setType @ "] -1 -1"); // SET VAR BLOCK
						%instSet.push_back("INPUT_BLOCK" SPC %type SPC %varName); // SET VAR BLOCK
						%instSet.push_back("{");
						if(%setType > 1) Scratch::parseArgs(%instSet, %value);
						%instSet.push_back("}");
					} else {
						echo("\c2ERROR   | Scratch::readFileToBlock | " @ %file SPC "Line: " @ %LC @ " - Unknown statement definition");
						echo("\c2ERROR   | Scratch::readFileToBlock | \c1>> The line that elicited the error:");
						echo("\c2ERROR   | Scratch::readFileToBlock | " @ %statement);
						backTrace();
						%SO.close();
						%SO.delete();
						%instSet.delete();
						return 0;
					}
			}
			%error = 0;
			%line = trim(getSubStr(%line, strLen(%statement), strLen(%line)));
		}
		if(%error) {
			error("ERROR   | Scratch::readFileToBlock | " @ %file SPC "Line: " @ %LC @ " - Uncaught exception");
			%SO.close();
			%SO.delete();
			%instSet.delete();
			return 0;
		}
	}
	%SO.close();
	%SO.delete();
	// Format the instruction set (add indentation)
	%lastAct    = "NEW";
	%indentBuff = "";
	for(%i=0;%i<%instSet.size();%i++) {
		%inst = %instSet.at(%i);
		%act  = firstWord(trim(%inst));
		%indS = Scratch::indent(%indentSize);
		switch$(%act) {
			case "{": %indentSize++; %instSet.erase(%i); %i--; continue;
			case "}": %indentSize--; %indS = Scratch::indent(%indentSize); %instSet.erase(%i); %i--; continue;
		}
		%lastAct = %act;
		%instSet.setAt(%i, %indS @ %inst);
	}
	if($Scratch::BuildType $= "DEBUG") %instSet.dumpData();
	%newPosX      = 15;
	%newPosY      = 15;
	%innerConnect = 0;
	ScratchContainer.deleteAll();
	for(%i=0;%i<%instSet.size();%i++) {
		%inst   = %instSet.at(%i);
		%indent = strLen(getSubStr(%inst, 0, striFindFirst_NotOf(%inst, " ")));
		%inst   = trim(%inst);
		%action = firstWord(%inst);
		%type   = getWord(%inst, 1);
		%args   = "";
		if(strIPos(%type, "[") != -1) {
			%args = getSubStr(%type, strIPos(%type, "[")+1, strLen(%type));
			%args = getSubStr(%args, 0, strLen(%args)-1);
			%type = getSubStr(%type, 0, strIPos(%type, "["));
		}
		if(%type == -1) continue;
		switch$(%action) {
			case "RES": // Reset inner connection protocol
				%innerConnect[%indent] = 0;
			case "ADD_DELIM":
				if(!isObject(%lastObj[%indent-1].delimAddObj)) { echo("bad delim find"); continue; }
				%lastObj[%indent-1].delimAddObj.performClick();
			case "NEW":
				if(isObject(%lastObj[%indent])) { Scratch::renderBlock(%lastObj[%indent]); %newPosX += %lastObj[%indent].getRight()+3; }
				%obj = Scratch::createPremadeBlock(%type, %args, removeWord(removeWord(%inst, 0), 0));
				Scratch_Content.add(%obj);
				%obj.resize(%newPosX, %newPosY, %obj.getWidth(), %obj.getHeight());
				if($Scratch::BuildType $= "DEBUG") echo("\c4|=> [" @ %indent @ "] NEW [ID:" @ %obj @ "] New");
				%args = removeWord(removeWord(%inst, 0), 0);
				for(%j=0;%j<getWordCount(%args);%j++) {
					%arg = getWord(%args, %j);
					if(%arg $= "-1") continue;
					if(!isObject(%argObj = %obj.blockArgObject[%j])) break;
					if(!isObject(%txtEd = %argObj.textEdit)) break;
					%txtEd.setValue(%arg);
					Scratch::setTextBoxWidth(%txtEd, %argObj);
				}
				%lastObj[%indent] = %obj;
			case "ADD":
				%obj = Scratch::createPremadeBlock(%type, %args);
				Scratch_Content.add(%obj);
				if($Scratch::BuildType $= "DEBUG") echo("\c4|=> [" @ %indent @ "] ADD [ID:" @ %obj @ "] Add");
				%args = removeWord(removeWord(%inst, 0), 0);
				for(%j=0;%j<getWordCount(%args);%j++) {
					%arg = getWord(%args, %j);
					if(%arg $= "-1") continue;
					if(!isObject(%argObj = %obj.blockArgObject[%j])) break;
					if(!isObject(%txtEd = %argObj.textEdit)) break;
					%txtEd.setValue(%arg);
					Scratch::setTextBoxWidth(%txtEd, %argObj);
				}
				if(%lastObj[%indent-1].container && %innerConnect[%indent-1]) {
					if(!Scratch::attachBlock(%obj, %lastObj[%indent-1], "insidetop")) {
						warn("WARNING | Scratch::readFileToBlock | INSIDETOP_CONNECT :: Could not attach " @ %lastObj[%indent-1] @ " and " @ %obj @ "!");
					} else %lastObj[%indent-1] = %obj;
				} else {
					if(!Scratch::attachBlock(%obj, %lastObj[%indent-1], "bottom")) {
						warn("WARNING | Scratch::readFileToBlock | BOTTOM_CONNECT :: Could not attach " @ %lastObj[%indent-1] @ " and " @ %obj @ "!");
					} else %lastObj[%indent-1] = %obj;
				}
				%innerConnect[%indent] = 1;
				%lastObj[%indent] = %obj;
			case "INS_TEXT":
				if($Scratch::BuildType $= "DEBUG") echo("\c4|=> [" @ %indent @ "] INS [ID:" @ %obj @ "] Insert text");
				%cnt     = 0;
				%obj_tmp = %lastObj[%indent-1].blockArgObject[%cnt];
				%args    = removeWord(%inst, 0);
				%args    = strReplace(%args, "[[COMMA]]", ",");
				%args    = strReplace(%args, "[[QUOTE]]", "\\\"");
				%args    = strReplace(%args, "[[SPC]]", " ");
				while(isObject(%obj_tmp)) {
					if(isObject(%obj_tmp.innerConnection_Child)) { %obj_tmp = %lastObj[%indent-1].blockArgObject[%cnt++]; continue; }
					if(!isObject(%txtEd = %obj_tmp.textEdit)) { %obj_tmp = %lastObj[%indent-1].blockArgObject[%cnt++]; continue; }
					if(%txtEd.getValue() !$= "") { %obj_tmp = %lastObj[%indent-1].blockArgObject[%cnt++]; continue; }
					%txtEd.setValue(%args);
					Scratch::setTextBoxWidth(%txtEd, %obj_tmp);
					break;
				}
			case "INPUT_BLOCK":
				%obj = Scratch::createPremadeBlock(%type, %args, removeWord(removeWord(%inst, 0), 0));
				Scratch_Content.add(%obj);
				if($Scratch::BuildType $= "DEBUG") echo("\c4|=> [" @ %indent @ "] INB [ID:" @ %obj @ "] Input block");
				%args = removeWord(removeWord(%inst, 0), 0);
				for(%j=0;%j<getWordCount(%args);%j++) {
					%arg = getWord(%args, %j);
					if(%arg $= "-1") continue;
					if(!isObject(%argObj = %obj.blockArgObject[%j])) break;
					if(!isObject(%txtEd = %argObj.textEdit)) break;
					%txtEd.setValue(%arg);
					Scratch::setTextBoxWidth(%txtEd, %argObj);
				}
				%obj_cnt = 0;
				%obj_tmp = %lastObj[%indent-1].blockArgObject[%obj_cnt];
				while(isObject(%obj_tmp)) {
					if(%dbg++ >= 500) { echo("broken!"); break; }
					if((isObject(%obj_tmp.textEdit) && %obj_tmp.textEdit.getValue() !$= "") || !Scratch::attachBlock(%obj, %obj_tmp, "inside")) {
						%obj_tmp = %lastObj[%indent-1].blockArgObject[%obj_cnt++];
						continue;
					}
					break;
				}
				%lastObj[%indent] = %obj;
			default: warn("WARNING | Scratch::readFileToBlock | Action \"" @ %action @ "\" not implemented yet");
		}
	}
	%instSet.delete();
	for(%i=0;%i<ScratchContainer.getCount();%i++) Scratch::renderBlock(ScratchContainer.getObject(%i));
	for(%i=0;%i<ScratchContainer.getCount();%i++) Scratch::renderBlock(ScratchContainer.getObject(%i));
	return 1;
}