function Scratch::getEndToken(%this, %type, %end) {
	switch(%type) {
		case 00: return "}";
		case 01: return "";
		case 02: return "";
		case 03: return "";
		case 04: return "";
		case 05: return "";
		case 06: return "";
		case 07: return "";
		case 08: return "";
		case 09: return "";
		case 10: return "";
		case 11: return "";
		case 12: return "}";
		case 13: return "";
		case 14: return ""; // Else if
		case 15: return ""; // Else 
		case 16: return "";
		case 17: return "";
		case 18: return "";
		case 19: return "";
		case 20: return "};";
		case 21: return "}";
		case 22: return "";
		case 23: return "";
		case 24: return "";
		case 25: return "}";
		case 26: return "";
		case 27: return "";
		case 28: return "";
		case 29: return "";
		case 30: return "";
		case 31: return "";
		case 32: return "";
		case 33: 
			%str = %this.endToken;
			%str = strReplace(%str, "[[NL]]", "\r\n");
			return %str;
		case 34: return "[ERROR]";
		case 35: return "";
		case 36: return "";
		default: return "[ERROR_HERE]";
	}
}

function Scratch::safeProofValue(%val) {
	if(%val $= "") return "\"\"";
	if((stripChars(%val, "0123456789.") $= "" || (stripChars(%val, "0123456789.") $= "-" && getSubStr(%val, 0, 1) $= "-")) && %val !$= ".") {
		// Number or float
	} else {
		if(getSubStr(%val, 0, 1) !$= "\"" && getSubStr(%val, strLen(%val)-1, 1) !$= "\"") {
			%val = "\"" @ strReplace(%val, "\"", "\\\"") @ "\"";
		}
	}
	return %val;
}

function Scratch::getValue(%this, %isChild) {
	if(!isObject(%this)) return 0;
	%retStruct = %this.blockReturnFormat;
	%delimCnt  = 0;
	for(%i=0;%i<getFieldCount(%retStruct);%i++) {
		%currType = getField(%retStruct, %i);
		switch$(firstWord(%currType)) {
			case "string":
				%toRet     = %toRet @ strReplace(removeWord(%currType, 0), "[[TAB]]", "\t");
				%retStruct = removeField(%retStruct, %i);
				%delimCnt++;
				%i--;
				continue;
			case "any":
				%child = %this.blockArgObject[-1+%currBlockArgIdx++];
				%type  = %child.argType;
				if(!isObject(%child)) {
					error("ERROR: Scratch::getValue() - Cannot find another argument box for " @ %this);
					return "";
				}
				if(%delimCnt > 0) {
					%delimCnt--;
					%delim = "";
				} else %delim = "\t";
				switch$(%type) {
					case "TEXTINPUT": %toRet = trim(%toRet @ %delim @ Scratch::safeProofValue(%child.textEdit.getValue()));
					case "BLOCKINPUT":
						if(isObject(%child.innerConnection_Child)) {
							%toRet = trim(%toRet @ %delim @ Scratch::getValue(%child.innerConnection_Child, 1));
						} else %toRet = trim(%toRet @ %delim @ "");
					case "ANYINPUT":
						if(isObject(%child.innerConnection_Child)) {
							%toRet = trim(%toRet @ %delim @ Scratch::getValue(%child.innerConnection_Child, 1));
						} else %toRet = trim(%toRet @ %delim @ Scratch::safeProofValue(%child.textEdit.getValue()));
					default:
						error("ERROR: Scratch::getValue() - " @ %child @ " (Child of " @ %this @ ") has an invalid type (\"" @ %type @ "\")"); return "";
				}
			case "any_noFormatting":
				%child = %this.blockArgObject[-1+%currBlockArgIdx++];
				%type  = %child.argType;
				if(!isObject(%child)) {
					error("ERROR: Scratch::getValue() - Cannot find another argument box for " @ %this);
					return "";
				}
				if(%delimCnt > 0) {
					%delimCnt--;
					%delim = "";
				} else %delim = "\t";
				switch$(%type) {
					case "TEXTINPUT": %toRet = trim(%toRet @ %delim @ %child.textEdit.getValue());
					case "BLOCKINPUT":
						if(isObject(%child.innerConnection_Child)) {
							%toRet = trim(%toRet @ %delim @ Scratch::getValue(%child.innerConnection_Child, 1));
						} else %toRet = trim(%toRet @ %delim @ "");
					case "ANYINPUT":
						if(isObject(%child.innerConnection_Child)) {
							%toRet = trim(%toRet @ %delim @ Scratch::getValue(%child.innerConnection_Child, 1));
						} else %toRet = trim(%toRet @ %delim @ %child.textEdit.getValue());
					default:
						error("ERROR: Scratch::getValue() - " @ %child @ " (Child of " @ %this @ ") has an invalid type (\"" @ %type @ "\")"); return "";
				}
			case "delims":
				%table  = %this.delimiterObjectTable;
				%buffer = "";
				for(%j=getWordCount(%table)-1;%j>=0;%j--) {
					%child = getWord(%table, %j);
					if(!isObject(%child)) {
						//%this.delimiterObjectTable = removeWord(%this.delimiterObjectTable, %j);
						%table = removeWord(%table, %j);
						%j--;
						continue;
					}
					%type  = %child.argType;
					if(!isObject(%child)) {
						error("ERROR: Scratch::getValue() - Cannot find another argument box for " @ %this);
						return "";
					}
					if(%delimCnt > 0) {
						%delimCnt--;
						%delim = "";
					} else %delim = "\t";
					switch$(%type) {
						case "TEXTINPUT": %buffer = (%buffer $= "" ? "" : %buffer @ %this.delimiterChar @ " ") @ Scratch::safeProofValue(%child.textEdit.getValue());
						case "BLOCKINPUT":
							if(isObject(%child.innerConnection_Child)) {
								%buffer = (%buffer $= "" ? "" : %buffer @ %this.delimiterChar @ " ") @ Scratch::getValue(%child.innerConnection_Child, 1);
							} else %buffer = (%buffer $= "" ? "" : %buffer @ %this.delimiterChar @ " ") @ "\"\"";
						case "ANYINPUT":
							if(isObject(%child.innerConnection_Child)) {
								%buffer = (%buffer $= "" ? "" : %buffer @ %this.delimiterChar @ " ") @ Scratch::getValue(%child.innerConnection_Child, 1);
							} else %buffer = (%buffer $= "" ? "" : %buffer @ %this.delimiterChar @ " ") @ Scratch::safeProofValue(%child.textEdit.getValue());
						default: error("ERROR: Scratch::getValue() - " @ %child @ " (Child of " @ %this @ ") has an invalid type (\"" @ %type @ "\")"); return "";
					}
				}
				%toRet = trim(%toRet @ %delim @ %buffer);
			case "delims_noFormatting":
				%table  = %this.delimiterObjectTable;
				%buffer = "";
				for(%j=getWordCount(%table)-1;%j>=0;%j--) {
					%child = getWord(%table, %j);
					if(!isObject(%child)) {
						%this.delimiterObjectTable = removeWord(%this.delimiterObjectTable, %j);
						%table = removeWord(%table, %j);
						%j--;
						continue;
					}
					%type  = %child.argType;
					if(!isObject(%child)) {
						error("ERROR: Scratch::getValue() - Cannot find another argument box for " @ %this);
						return "";
					}
					if(%delimCnt > 0) {
						%delimCnt--;
						%delim = "";
					} else %delim = "\t";
					switch$(%type) {
						case "TEXTINPUT": %buffer = (%buffer $= "" ? "" : %buffer @ %this.delimiterChar @ " ") @ %child.textEdit.getValue();
						case "BLOCKINPUT":
							if(isObject(%child.innerConnection_Child)) {
								%buffer = (%buffer $= "" ? "" : %buffer @ %this.delimiterChar @ " ") @ Scratch::getValue(%child.innerConnection_Child, 1);
							} else %buffer = (%buffer $= "" ? "" : %buffer @ %this.delimiterChar @ " ") @ "\"\"";
						case "ANYINPUT":
							if(isObject(%child.innerConnection_Child)) {
								%buffer = (%buffer $= "" ? "" : %buffer @ %this.delimiterChar @ " ") @ Scratch::getValue(%child.innerConnection_Child, 1);
							} else %buffer = (%buffer $= "" ? "" : %buffer @ %this.delimiterChar @ " ") @ %child.textEdit.getValue();
						default: error("ERROR: Scratch::getValue() - " @ %child @ " (Child of " @ %this @ ") has an invalid type (\"" @ %type @ "\")"); return "";
					}
				}
				%toRet = trim(%toRet @ %delim @ %buffer);
			default:
				error("ERROR: Scratch::getValue() - " @ %child @ " (Child of " @ %this @ ") has an invalid return structure pointer (\"" @ %currRet @ "\")");
				return "";
		}
	}
	%toRet = strReplace(%toRet, "(\"\")", "()");
	%toRet = strReplace(%toRet, "[[NL]]", "\r\n");
	//if(!$Pref::Scratch::ExportSystem::Prefs::BracketPlacement) %toRet = strReplace(%toRet, "{", "\r\n{");
	return %toRet;
}

function Scratch::getBlockLinkSize(%this) {
	if(!isObject(%this)) return 0;
	%obj = %this.bottomConnection;
	%cnt = 0;
	while(isObject(%obj)) {
		if(%dbg++ >= 500) { echo("Scratch::getBlockLinkSize() at codeconvert.cs: Broke while loop"); break; }
		%cnt++;
		%obj = %obj.bottomConnection;
	}
	return %cnt;
}

function Scratch::genExportIndent(%size) {
	%size = mClamp(%size, 0, 1000);
	%chr = "   ";
	if($Pref::Scratch::ExportSystem::Prefs::IndentType) %chr = "\t";
	for(%i=0;%i<%size;%i++) %ret = %ret @ %chr;
	return %ret;
}

function Scratch::exportWrite(%this, %stream, %buffer, %indentSize, %realIndentSize, %parent, %ignoreCallbacks, %doNotUseCallbacks, %doNotLog) {
	if(!isObject(%this)) return;
	if(!isObject(%stream)) return;

	// Write callback commands first
	if($CACHE::Scratch::Exporter::WriteCallbacks && !%ignoreCallbacks && !%doNotUseCallbacks) {
		// handle callback writing here
		%lineCount      = $CACHE::Scratch::Exporter::LineCount;
		if(%lineCount == -1) {
			// Increment the total line count
			$CACHE::Scratch::Exporter::LineCount++;
		} else {
			for(%i=0;%i<getWordCount($CACHE::Scratch::Exporter::VarWatch[%parent]);%i++) {
				%name = getWord($CACHE::Scratch::Exporter::VarWatch[%parent], %i);
				if(getSubStr(%name, 0, 1) $= "%") %type = 0; else %type = 1;
				%callBackBuffer = "Scratch::registerWatchVariable(\"" @ getSubStr(%name, 1, strLen(%name)) @ "\", " @ %type @ ", " @ %name @ "); /" @ "/ SCRATCH_DEBUG_LINE";
				Scratch::exportWrite(%this, %stream, %callBackBuffer, %realIndentSize, %realIndentSize, %parent, 0, 1, 1);
			}
			%callBackBuffer = "if(Scratch::ScriptLineNotify(\"" @ $CACHE::Scratch::Exporter::LineCount @ "\", \"" @ %this @ "\")) return; /" @ "/ SCRATCH_DEBUG_LINE";
			Scratch::exportWrite(%this, %stream, %callBackBuffer, %realIndentSize, %realIndentSize, %parent, 0, 1, 1);
			$CACHE::Scratch::Exporter::BlockLine[$CACHE::Scratch::Exporter::LineCount] = %this;
		}
	}
	if(!%doNotLog && !%doNotUseCallbacks) $CACHE::Scratch::Exporter::LineCount++;

	// Write this line
	%indent = Scratch::genExportIndent(%indentSize);
	if(getRecordCount(%buffer) > 1 && 3 == 1) {
		for(%i=0;%i<getRecordCount(%buffer)-1;%i++) { Scratch::exportWrite(%this, %stream, getRecord(%buffer, %i), %indentSize, %realIndentSize, %parent, %ignoreCallbacks, %doNotUseCallbacks, %doNotLog); }
	}
	%stream.writeLine(%indent @ getRecord(%buffer, getRecordCount(%buffer)-1));

	// Log this for debugging
	if($CACHE::Scratch::Exporter::WriteCallbacks && !%doNotLog) {
		%size           = Scratch_Debugger_ScriptList.rowCount();
		%neatLineBuffer = %indent @ %buffer;
		%neatLineBuffer = strReplace(%neatLineBuffer, "\t", "   ");
		%neatLineBuffer = "\c0" TAB getSubStr("000000" @ %size, strLen("000000" @ %size)-6, 6) TAB ":" TAB %neatLineBuffer;
		Scratch_Debugger_ScriptList.addRow(%size, %neatLineBuffer, %size);
	}
}

function Scratch::exportBlock(%stream, %this, %indentSize, %parent) {
	if(!isObject(%stream)) return -1;
	if(!isObject(%this)) return -1;
	if(!ScratchContainer.isMember(%this)) return -1;
	if($CACHE::Scratch::Exporter::Obj[%this]) return -1;
	if(%parent $= "") %parent = %this;

	// Notify the Scratch exporter that we got this object
	$CACHE::Scratch::Exporter::Obj[%this] = 1;

	// Export this object if it is not an input block
	if(%this.blockType !$= "INPUTBLOCK") {
		%buffer = Scratch::getValue(%this);
		// Calculate the line end token
		if(getSubStr(%buffer, strLen(%buffer)-1, 1) !$= "{") %buffer = %buffer @ ";";

		Scratch::exportWrite(%this, %stream, %buffer, %indentSize, %indentSize, %parent, 0, (strIPos(%buffer, "package") == -1 ? 0 : 1), 0);

		// If the last character of %buffer is '{', increase the indent size.
		if(getSubStr(%buffer, strLen(%buffer)-1, 1) $= "{") %indentSize++;

		// Set the end token
		%end = Scratch::getEndToken(%this, %this.blockLayoutType);
	}

	// Register all inner children of this object as 'gotten'
	for(%i=0;%i<%this.blockArgCount;%i++) {
		%child = %this.blockArgObject[%i];
		if(!isObject(%child_child = %child.innerConnection_Child)) continue;
		Scratch::exportBlock(%stream, %child_child, -1, %parent);
	}

	// If we're an input block, do not continue.
	if(%this.blockType $= "INPUTBLOCK") return %indentSize;

	// If we're a container, export all of our child objects before our bottom connections
	if(%this.container) {
		// Containers will ALWAYS have an indentation, because only keywords with brackets will be represented by containers.
		// Example: While loops, for loops, if loops, new object, etc.

		// Export the block connected to us
		if(isObject(%obj = %this.inside_topConnection)) Scratch::exportBlock(%stream, %obj, %indentSize, %parent);

		// End this container correctly
		Scratch::exportWrite(%this, %stream, %end, %indentSize-1, %indentSize, %parent, 0, 1, 0);
		%end = "";
		%indentSize--;
	}

	// However, if we're NOT an input block, export the next connection link we have.
	if(isObject(%obj = %this.bottomConnection)) {
		Scratch::exportBlock(%stream, %obj, %indentSize, %parent);
	}

	// Write the end token
	if(%end !$= "") { %indentSize--; Scratch::exportWrite(%this, %stream, %end, %indentSize-1, %indentSize, %parent, 0, 1, 0); }
	
	// If the indent size equals 0 at this point, then reset the line count
	if(%indentSize == 0) $CACHE::Scratch::Exporter::LineCount = -1;

	return %indentSize;
}


function Scratch::exportScript(%fileName, %writeCallbacks, %confirm) {
	if(fileExt(%fileName) !$= ".cs") {
		messageBoxOk("Error - Scratch Editor", "Cannot save script to '" @ %fileName @ "'. Reason:<br><br>\"File extension must be .cs\"");
		return 0;
	}
	if(isFile(%fileName) && !%confirm) {
		messageBoxYesNo("Confirmation - Scratch Editor", "Are you sure you want to overwrite '" @ %fileName @ "'?", "Scratch::exportScript(\"" @ %fileName @ "\", \"" @ %writeCallbacks @ "\", 1);");
		return 0;
	}
	// Log this action
	Scratch::debugger_echo("Exporting current script...");
	if(!Scratch::checkScriptForErrors()) {
		Scratch::debugger_error("Script contains errors.");
		return;
	}
	$CACHE::Scratch::Benchmarks::Exporter::StartTime = getSimTime();

	// Set the export options
	deleteVariables("$CACHE::Scratch::Exporter::*");
	$CACHE::Scratch::Exporter::WriteCallbacks = mClamp(%writeCallbacks, 0, 1);
	$CACHE::Scratch::Exporter::LineCount      = -1;

	// Clear the debugger
	Scratch::clearDebuggerData();

	// First, let the debugger scan for variables
	Scratch::debugger_calculateWatchVariables();

	// Set variables
	%SO         = new FileObject();
	%this       = ScratchContainer;
	%SO.openForWrite(%fileName);
	for(%i=0;%i<%this.getCount();%i++) {
		%object  = %this.getObject(%i);
		%type    = %object.blockLayoutType;
		%args    = %object.blockCreationArgs;
		// Check if this object has no connections. If so, then it is probably an abandoned block (UNLESS it has no top connector)
		if(%object.top) continue;
		
		// Next, let's check if we've already exported this block.
		if($CACHE::Scratch::Exporter::Obj[%object]) continue;
		
		// If we passed that, then we probably have a block that starts something (like a function declaration block or package block, etc)
		// So, let's export this block.
		if(Scratch::exportBlock(%SO, %object, 0) < 0) {
			warn("WARNING: Scratch::exportScript() - Failed to export object " @ %object.getId() @ ".");
		}
	}
	%SO.close();

	// Log this action
	Scratch::debugger_echo("Successfully exported in " @ (getSimTime()-$CACHE::Scratch::Benchmarks::Exporter::StartTime) @ " ms");

	if(%writeCallbacks) {
		// If we're writing callbacks, then we're probably debugging the script
		if(!isObject(ScratchResultLogger)) {
			new ConsoleLogger(ScratchResultLogger, "config/scratch_temp.out", true);
		} else ScratchResultLogger.attach();
		if(!compile(%fileName)) {
			ScratchResultLogger.detach();
			ScratchResultLogger.delete();
			messageBoxOk("Error - Scratch Editor", "Syntax error; See debugger for details");
			%SO.openForRead("config/scratch_temp.out");
			while(!%SO.isEOF()) {
				%line = stripMLControlChars(%SO.readLine());
				if(%got[getStringCRC(%line)]) continue;
				%got[getStringCRC(%line)] = 1;
				if(%errorLine $= "" && wordPos(%line, "Line:") != -1) {
					%errorLine = wordPos(%line, "Line:")+1;
				}
				if(strIPos(%line, "/" @ "/ SCRATCH_DEBUG_LINE") != -1) continue;
				Scratch::debugger_error(%line);
			}
			%SO.close();
			%SO.delete();
			if(%errorLine !$= "") Scratch::blinkError($CACHE::Scratch::Exporter::BlockLine[%errorLine]); 
			return 0;
		}
		%SO.delete();
		ScratchResultLogger.detach();
		ScratchResultLogger.delete();
		exec(%fileName);
		if(!Scratch_DebugWindow.isVisible()) Scratch::openDebugger();
		for(%i=0;%i<%this.getCount();%i++) {
			%object = %this.getObject(%i);
			Scratch::setGlow(%object, 0);
		}
	}
	return 1;
}