function Scratch::openCollabConnect() {
	if(0 == 1 && $CACHE::Scratch::Net_Server::Hosting) {
		messageBoxYesNo("ERROR - Scratch Editor", "Are you sure you want to stop hosting?", "Scratch::clientDisconnect();Scratch::openCollabConnect();");
		return;
	}
	if(1 == 0 && ScratchClientTCP.connected) {
		messageBoxYesNo("ERROR - Scratch Editor", "Are you sure you want to disconnect from this session?", "Scratch::clientDisconnect();Scratch::openCollabConnect();");
		return;
	}
	%win = Scratch_CollabConnect;
	%win.resize((Canvas.getWidth()/2)-(%win.getWidth()/2), (Canvas.getHeight()/2)-(%win.getHeight()/2), %win.getWidth(), %win.getHeight());
	%win.setVisible(1);
	ScratchGui.pushToBack(%win);
	Scratch_CollabConnect_MaxPlayers.clear();
	for(%i=2;%i<=32;%i++) Scratch_CollabConnect_MaxPlayers.add((%i > 4 ? "[EXPECT LATENCY ISSUES] " : "") @ %i, %i);
	if($CACHE::Scratch::Net_Server::MaxUsers $= "") $CACHE::Scratch::Net_Server::MaxUsers = 2;
	Scratch_CollabConnect_MaxPlayers.setSelected($CACHE::Scratch::Net_Server::MaxUsers);
	if($Pref::Scratch::HostingPort $= "") $Pref::Scratch::HostingPort = "28000";
	Scratch_CollabConnect_HostPort.setValue($Pref::Scratch::HostingPort);
}

function Scratch::collabConn_setTab(%tab) {
	Scratch_CollabConnect_JoinTab.setVisible(0);
	Scratch_CollabConnect_ConnectTab.setVisible(0);
	switch(%tab) {
		case 0: Scratch_CollabConnect_JoinTab.setVisible(1);
		case 1: Scratch_CollabConnect_ConnectTab.setVisible(1);
	}
}

function Scratch_CollabConnect_MaxPlayers::onSelect(%this, %id, %text) {
	$CACHE::Scratch::Net_Server::MaxUsers = %id;
	%this.setText(%id SPC "Users");
}

function Scratch::collabConn_createServer() {
	%port = Scratch_CollabConnect_HostPort.getValue();
	if($CACHE::Scratch::Net_Server::Name $= "") {
		messageBoxOk("ERROR - Scratch Editor", "Please input a session name.");
		return;
	}
	if(stripChars(%port, "0123456789") !$= "" || %port < 1024 || %port >= 49151) {
		messageBoxOk("ERROR - Scratch Editor", "Please provide a valid hosting port.");
		return;
	}
	$Pref::Scratch::HostingPort = %port;
	Scratch_CollabConnect.setVisible(0);
	Scratch::startListenServer(%port);
	ScratchServerTCP.listen(%port);
	$CACHE::Scratch::CollabConnect::StatusMsg = "<just:left>";
	Scratch::collabConnStatus("Starting server...", 0);
}

function isValidIP(%ip) {
	%ip = strReplace(%ip, ".", " ");
	if(getWordCount(%ip) != 4) return 0;
	if(stripChars(%ip, "0123456789 ") !$= "") return 0;
	return 1;
}

function Scratch::collabConn_joinServer() {
	%ip   = Scratch_CollabConnect_Ip.getValue();
	%port = Scratch_CollabConnect_Port.getValue();
	%pass = Scratch_CollabConnect_Pass.getValue();
	if(%ip $= "" || !isValidIP(%ip)) {
		messageBoxOk("ERROR - Scratch Editor", "Please provide a valid IP.");
		return;
	}
	if(%port $= "" || stripChars(%port, "0123456789") !$= "") {
		messageBoxOk("ERROR - Scratch Editor", "Please provide a valid port.");
		return;
	}
	$CACHE::Scratch::Net_Client::JoinPassword = %pass;
	Scratch::connectToServer(%ip, %port);
	$CACHE::Scratch::CollabConnect::StatusMsg = "<just:left>";
	Scratch::collabConnStatus("Connecting to " @ %ip @ ":" @ %port @ "...", 0);
}

function Scratch::collabConnStatus(%msg, %st) {
	$CACHE::Scratch::CollabConnect::StatusMsg = trim($CACHE::Scratch::CollabConnect::StatusMsg NL %msg);
	if(%st) {
		closeMessagePopup();
		messageBoxOk("Scratch Collaboration Status", $CACHE::Scratch::CollabConnect::StatusMsg);
		return;
	}
	messagePopup("Scratch Collaboration Status", $CACHE::Scratch::CollabConnect::StatusMsg);
}