function Scratch::openCollabMenu() {
	if(!ScratchClientTCP.connected) {
		Scratch::openCollabConnect();
		return;
	}
	%win = Scratch_CollabMenu;
	%win.setVisible(1);
	%win.resize((Canvas.getWidth()/2)-(%win.getWidth()/2), (Canvas.getHeight()/2)-(%win.getHeight()/2), %win.getWidth(), %win.getHeight());
	ScratchGui.pushToBack(%win);
}

function Scratch::closeCollabMenu(%confirm) {
	%tcp = ScratchClientTCP;
	if(%tcp.connected) {
		if(!%confirm) { messageBoxYesNo("Confirmation - Scratch Editor", "Are you sure you want to disconnect from this Scratch collaboration session?", "Scratch::closeCollabMenu(1);"); return; }
		else {
			Scratch::clientDisconnect();
		}
	}
	Scratch_CollabMenu.setVisible(0);
}

function Scratch::client_sendMessage() {
	%tcp = ScratchClientTCP;
	if(!%tcp.connected) {
		Scratch::CollabMenu_chatMsg("* You are not connected to a collaborative session");
		return;
	}
	%text = Scratch_CollabMenu_ChatEntry.getValue();

	// If this is true, it's probably a servercmd
	if(getSubStr(%text, 0, 1) $= "/") {
		%cmdName  = firstWord(%text);
		%cmdName  = getSubStr(%cmdName, 1, strLen(%cmdName));
		%argsTemp = restWords(%text);
		%argsTemp = strReplace(%argsTemp, " ", "\t");
		%tcp.sendData("SERVERCMD " @ %cmdName TAB %argsTemp);
		Scratch_CollabMenu_ChatEntry.setValue("");
		return;
	}
	%text = trim(stripMLControlChars(%text));
	if(%text !$= "") %tcp.sendData("CHATMSG " @ %text);
	Scratch_CollabMenu_ChatEntry.setValue("");
}

function Scratch::CollabMenu_clear() {
	Scratch_CollabMenu_PlayerList.clear();
	Scratch_CollabMenu_Chat.setText("");
}

function Scratch::CollabMenu_showAdmin(%bool) {
	%btn = Scratch_CollabMenu_ModeSwitcher;
	%grp = Scratch_PlayerMenu_Scroll;
	if(%bool) {
		%btn.setVisible(1);
		%grp.resize(%grp.getLeft(), %grp.getTop(), %grp.getWidth(), %grp.getGroup().getHeight()-55);
	} else {
		%btn.setVisible(0);
		%grp.resize(%grp.getLeft(), %grp.getTop(), %grp.getWidth(), %grp.getGroup().getHeight()-34);
	}
}

function Scratch::CollabMenu_ToggleWatchOnlyMode() {
	if(!$CACHE::Scratch::Net_Server::Hosting) return;
	if(!$CACHE::Scratch::Net_Server::WatchOnlyModeEnabled) {
		$CACHE::Scratch::Net_Server::WatchOnlyModeEnabled = 1;
		Scratch_CollabMenu_ModeSwitcher.mColor = "255 0 0 255";
		Scratch_CollabMenu_ModeSwitcher.setText("Enable Manipulation");
		ScratchNet::announce("<color:007700>* Server is now in watch-only mode<color:000000>");
	} else {
		$CACHE::Scratch::Net_Server::WatchOnlyModeEnabled = 0;
		Scratch_CollabMenu_ModeSwitcher.mColor = "0 255 0 255";
		Scratch_CollabMenu_ModeSwitcher.setText("Disable Manipulation");
		ScratchNet::announce("<color:007700>* Server is now in freemode<color:000000>");
	}
}

function Scratch::CollabMenu_chatMsg(%msg) {
	%this = Scratch_CollabMenu_Chat;
	%text = %this.getValue();
	%text = trim(%text NL " " @ %msg);
	%this.setText(" " @ %text);
	%this.getGroup().schedule(300, scrollToBottom);
}
