if(!isObject(Scratch_DebugData)) new ScriptObject(Scratch_DebugData) { class = "ArrayObject"; };

function Scratch::ScriptLineNotify(%lineNumber, %blockObject) {
	if(isObject(%oldObj = $CACHE::Scratch::Debugger::LastBlockHighlighted)) {
		Scratch::setGlow(%oldObj, 0);
	}
	Scratch::setGlow(%blockObject, 20);
	%line = Scratch_Debugger_ScriptList.getRowTextById(%lineNumber);
	Scratch_Debugger_ScriptList.setRowById(%lineNumber, setField(%line, 0, "\c4 "));
	if($CACHE::Scratch::Debugger::LastLineNumber !$= "") {
		%line = Scratch_Debugger_ScriptList.getRowTextById($CACHE::Scratch::Debugger::LastLineNumber);
		Scratch_Debugger_ScriptList.setRowById($CACHE::Scratch::Debugger::LastLineNumber, setField(%line, 0, "\c0 "));
	}
	Scratch_Debugger_WatchList.sort(0, 1);
	$CACHE::Scratch::Debugger::LastBlockHighlighted = %blockObject;
	$CACHE::Scratch::Debugger::LastLineNumber       = %lineNumber;
	if($CACHE::Scratch::Debugger::SBS) {
		if(atoi(%lineNumber) >= atoi($CACHE::Scratch::Debugger::SBS::Line)) return 1;
	}
	return 0;
}

function Scratch::debugger_close() {
	Scratch_DebugWindow.setVisible(0);
	%this = ScratchContainer;
	for(%i=0;%i<%this.getCount();%i++) {
		%object = %this.getObject(%i);
		Scratch::setGlow(%object, 0);
	}
}

function Scratch::debugger_searchForVariables(%this, %parent) {
	if(!isObject(%this)) return 0;
	if(%this.blockLayoutType == 3 || %this.blockLayoutType == 4) {
		%name = Scratch::getValue(%this);
		if(wordPos($CACHE::Scratch::Exporter::VarWatch[%parent], %name) != -1) return 1;
		$CACHE::Scratch::Exporter::VarWatch[%parent] = trim($CACHE::Scratch::Exporter::VarWatch[%parent] SPC %name);
		return 1;
	}
	for(%i=0;%i<%this.blockArgCount;%i++) {
		%child = %this.blockArgObject[%i];
		if(!isObject(%child_child = %child.innerConnection_Child)) continue;
		Scratch::debugger_searchForVariables(%child_child, %parent);
	}
	if(%this.container) {
		if(isObject(%link = %this.inside_topConnection)) { Scratch::debugger_searchForVariables(%link, %parent); }
	}
	if(isObject(%link = %this.bottomConnection)) {
		Scratch::debugger_searchForVariables(%link, %parent);
	}
	return 1;
}

function Scratch::debugger_calculateWatchVariables() {
	%this = ScratchContainer;
	for(%i=0;%i<%this.getCount();%i++) {
		%object = %this.getObject(%i);
		Scratch::debugger_searchForVariables(%object, %object);
	}
}

function Scratch::debugger_selectFunction() {
	%win = Scratch_DebugOptions;
	%win.setVisible(1);
	%win.resize((Canvas.getWidth()/2)-(%win.getWidth()/2), (Canvas.getHeight()/2)-(%win.getHeight()/2), %win.getWidth(), %win.getHeight());
	ScratchGui.pushToBack(%win);
	Scratch_DebugOptions_FunctionDropDown.clear();
	%this = ScratchContainer;
	for(%i=0;%i<%this.getCount();%i++) {
		%object = %this.getObject(%i);
		%retVal = Scratch::getValue(%object);
		if(strIPos(%retVal, "function") != 0) continue;
		%funcNm = getWord(%retVal, wordPos(%retVal, "function")+1);
		%funcNm = getSubStr(%funcNm, 0, strIPos(%funcNm, "("));
		Scratch_DebugOptions_FunctionDropDown.add(%funcNm, Scratch_DebugOptions_FunctionDropDown.size());
	}
}

function Scratch::debugger_optionsConfirm() {
	%win      = Scratch_DebugOptions;
	%funcName = Scratch_DebugOptions_FunctionDropDown.getTextById(Scratch_DebugOptions_FunctionDropDown.getSelected());
	if(%funcName $= "") {
		messageBoxOk("Error - Scratch Editor", "Please select a function.");
		return;
	}
	%win.setVisible(0);
	if($CACHE::Scratch::Debugger::SBS) $CACHE::Scratch::Debugger::SBS::Line = -1;
	$CACHE::Scratch::Debugger::FuncName = %funcName;
	$CACHE::Scratch::Debugger::FuncArgs = strReplace(Scratch_Debugger_Arguments.getValue(), ",", "\t");
	Scratch::debugger_Step();
}

function Scratch::debugger_Step() {
	if($CACHE::Scratch::Debugger::FuncName $= "") {
		Scratch::debugger_selectFunction();
		return;
	}
	$CACHE::Scratch::Debugger::SBS::Line++;
	for(%i=0;%i<getFieldCount($CACHE::Scratch::Debugger::FuncArgs);%i++) {
		%field  = getField($CACHE::Scratch::Debugger::FuncArgs, %i);
		%argSet = (%argSet $= "" ? "" : %argSet @ ", ") @ getSafeArgument(%field);
	}
	eval($CACHE::Scratch::Debugger::FuncName @ "(" @ %argSet @ ");");
}

function Scratch::debugger_updateWatchList() {
	%this = Scratch_DebugData;
	for(%i=0;%i<%this.size();%i++) {
		%data = %this.at(%i);
		%name = getField(%data, 0);
		%valu = getField(%data, 1);
		%type = getField(%data, 2);
		Scratch_Debugger_WatchList.setRowById(%i, (%type ? "$" : "%") @ %name @ " = \"" @ %valu @ "\"");
	}
}

function Scratch::setDebuggerView(%idx) {
	Scratch_Debugger_TabScript.setVisible(0);
	Scratch_Debugger_TabWatch.setVisible(0);
	switch(%idx) {
		case 0: Scratch_Debugger_TabScript.setVisible(1);
		case 1: Scratch_Debugger_TabWatch.setVisible(1);
	}
}

function Scratch::openDebugger() {
	Scratch::setDebuggerView(0);
	%win = Scratch_DebugWindow;
	%win.setVisible(1);
	%win.resize((Canvas.getWidth()/2)-(%win.getWidth()/2), (Canvas.getHeight()/2)-(%win.getHeight()/2), %win.getWidth(), %win.getHeight());
	ScratchGui.pushToBack(%win);
}

function Scratch::clearDebuggerData() {
	Scratch_DebugData.empty();
	Scratch_Debugger_WatchList.clear();
	Scratch_Debugger_ScriptList.clear();
	// SBS = Step by step
	$CACHE::Scratch::Debugger::SBS = 0;
	$CACHE::Scratch::Debugger::SBS::Line = 0;
	$CACHE::Scratch::Debugger::FuncName = "";
	$CACHE::Scratch::Debugger::LastLineNumber = "";
}

function Scratch::registerWatchVariable(%name, %type, %value) {
	%type = mClamp(%type, 0, 1);
	%name = trim(getSafeVariableName(%name));
	%this = Scratch_DebugData;
	for(%i=0;%i<%this.size();%i++) {
		%d_data = %this.at(%i);
		%d_name = getField(%d_data, 0);
		%d_type = getField(%d_data, 2);
		if(%d_name !$= %name || %d_type != %type) continue;
		%this.setAt(%i, %d_name TAB %value TAB %type);
		Scratch::debugger_updateWatchList();
		return 1;
	}
	%this.push_back(%name TAB %value TAB %type);
	Scratch_Debugger_WatchList.addRow(%this.size()-1, (%type == 0 ? "%" : "$") @ %name @ " = \"" @ %value @ "\"", %this.size()-1);
	Scratch::debugger_updateWatchList();
	return 1;
}

function Scratch::debugger_echo(%msg) {
	if(trim(Scratch_Debugger_Console.getText()) $= "") {
		Scratch_Debugger_Console.setText("<font:Consolas:14>");
		Scratch_Debugger_Console.setText(getRecords(Scratch_Debugger_Console.getText(), 0, 20) @ %msg);
	} else {
		Scratch_Debugger_Console.setText(getRecords(Scratch_Debugger_Console.getText(), 0, 20) NL %msg);
	}
	Scratch_Debugger_Console.getGroup().schedule(100, scrollToBottom);
}

function Scratch::debugger_error(%msg) {
	if(trim(Scratch_Debugger_Console.getText()) $= "") {
		Scratch_Debugger_Console.setText("<font:Consolas:14>");
		Scratch_Debugger_Console.setText(getRecords(Scratch_Debugger_Console.getText(), 0, 20) @ "<color:FF0000>" @ %msg @ "<color:000000>");
	} else {
		Scratch_Debugger_Console.setText(getRecords(Scratch_Debugger_Console.getText(), 0, 20) NL "<color:FF0000>" @ %msg @ "<color:000000>");
	}
	Scratch_Debugger_Console.getGroup().schedule(100, scrollToBottom);
}