 // Scratch_Selectable -- Stores all selectable blocks
// Scratch_Content    -- Stores the blocks
package ScratchNewScrollPackage {
	function ScratchContainerBlock::resize(%this, %x, %y, %w, %h) {
		Scratch_NewScroll.newScroll_render();
		Parent::resize(%this, %x, %y, %w, %h);
		if(!$Pref::Scratch::NewScroll) deactivatePackage(ScratchNewScrollPackage);
	}
};

if(!isObject(ScratchFileSelectorHistorySO)) new ScriptObject(ScratchFileSelectorHistorySO) { class = "ArrayObject"; };

function ScratchGui::onWake(%this) {
	%window  = Scratch_MainWindow;
	if($Scratch::BuildType !$= "DEBUG") {
		%CenterX = (Canvas.getWidth()/2)-(%window.getWidth()/2);
		%CenterY = (Canvas.getHeight()/2)-(%window.getHeight()/2);
		%window.resize(%CenterX, %CenterY, %window.getWidth(), %window.getHeight());
	}
	%this.populateDropDownList();
	Scratch::renderTree();
	if($Scratch::BuildType $= "DEBUG") {
		Scratch_SelectElement.setVisible(1);
		Scratch_DLLText.setVisible(1);
		Scratch_DLLButton.setVisible(1);
	}
	if($Pref::Scratch::NewScroll) {
		if(!isObject("Scratch_NewScroll")) {
			%newObj = new_GuiNewScrollCtrl("Scratch_NewScroll");
			Scratch_MainWindow.add(%newObj);
			%newObj.getObject(1).setProfile("ScratchNewScrollProfile");
			%newObj.getObject(1).add(Scratch_Content);
			%newObj.horizSizing = "width";
			%newObj.vertSizing  = "height";
			%newPos = Scratch_DefaultContentScroll.getPosition();
			%newExt = Scratch_DefaultContentScroll.getExtent();
			%newObj.resize(getWord(%newPos, 0), getWord(%newPos, 1), getWord(%newExt, 0), getWord(%newExt, 1));
			Scratch_MainWindow.bringToFront(%newObj);
			Scratch_MainWindow.bringToFront(Scratch_DefaultContentScroll);
			Scratch_Content.setProfile(GuiScratchNoModalProfile);
		}
		activatePackage(ScratchNewScrollPackage);
	} else {
		if(isObject("Scratch_NewScroll")) {
			Scratch_Content.setProfile(GuiDefaultProfile);
			Scratch_DefaultContentScroll.add(Scratch_Content);
			Scratch_NewScroll.delete();
		}
	}
	schedule(100, 0, eval, "Scratch::queryTutorial();");
}

function ScratchGui::onSleep(%this) {
	cancel($CACHE::Scratch::RenderSystem::TreeRenderSchedule);
	if($Pref::Scratch::NewScroll) deactivatePackage(ScratchNewScrollPackage);
}

function ScratchGui::populateDropDownList(%this) {
	%dropDown = Scratch_SelectElement;
	%dropDown.clear();
	%dropDown.add("Common Functions...", -2);
	%dropDown.add("--------------------------------------------------------", -1);
	%dropDown.add("   ORANGE - Important Blocks", -1);
	%dropDown.add("--------------------------------------------------------", -1);
	%dropDown.add("01: Declare Function", 0);
	%dropDown.add("02: Call Function (foobar();)", 9190);
	%dropDown.add("04: Call Object Method (%player.kill();)", 92890);
	%dropDown.add("06: Return", 7);
	%dropDown.add("07: Declare Packaged Function", 21);
	%dropDown.add("08: Declare Packaged Function End", 22);
	%dropDown.add("--------------------------------------------------------", -1);
	%dropDown.add("   DARK RED - String Concatenation & Logical Operators", -1);
	%dropDown.add("--------------------------------------------------------", -1);
	%dropDown.add("01: Normal (@)", 5);
	%dropDown.add("02: Space (SPC)", 9);
	%dropDown.add("03: Tab Indent (TAB)", 10);
	%dropDown.add("04: New Line (NL)", 11);
	%dropDown.add("05: Logical AND (&&)", 31);
	%dropDown.add("06: Logical OR  (||)", 30);
	%dropDown.add("--------------------------------------------------------", -1);
	%dropDown.add("   RED & BLUE - Variables", -1);
	%dropDown.add("--------------------------------------------------------", -1);
	%dropDown.add("01: Local Variable (%)", 3);
	%dropDown.add("02: Global Variable ($)", 4);
	%dropDown.add("03: Object Variable (object.varName)", 29);
	%dropDown.add("04: Set Variable (++)", 9290);
	%dropDown.add("05: Set Variable (--)", 9291);
	%dropDown.add("06: Set Variable (+=)", 9292);
	%dropDown.add("07: Set Variable (-=)", 9293);
	%dropDown.add("08: Set Variable (*=)", 9294);
	%dropDown.add("09: Set Variable (/=)", 9295);
	%dropDown.add("10: Set Variable (%=)", 9296);
	%dropDown.add("11: Set Variable ( =)]", 9297);
	%dropDown.add("--------------------------------------------------------", -1);
	%dropDown.add("   BROWN & GREEN - Logical & Objects", -1);
	%dropDown.add("--------------------------------------------------------", -1);
	%dropDown.add("01: If Statement", 12);
	%dropDown.add("02: If Statement End", 13);
	%dropDown.add("03: Else If Statement", 14);
	%dropDown.add("04: Else Statement", 15);
	%dropDown.add("05: For Loop", 23);
	%dropDown.add("06: While Loop", 25);
	%dropDown.add("07: New Object", 17);
	%dropDown.add("08: New Object Declaration End", 19);
	%dropDown.add("09: Logical Comparison (!<var>)", 91698);
	%dropDown.add("10: Logical Comparison (==)", 91690);
	%dropDown.add("11: Logical Comparison (!=)", 91691);
	%dropDown.add("12: Logical Comparison ($=)", 91692);
	%dropDown.add("13: Logical Comparison (!$=)", 91693);
	%dropDown.add("14: Logical Comparison (>=)", 91694);
	%dropDown.add("15: Logical Comparison (<=)", 91695);
	%dropDown.add("16: Logical Comparison (>)", 91696);
	%dropDown.add("17: Logical Comparison (<)", 91697);
	%dropDown.add("--------------------------------------------------------", -1);
	%dropDown.add("   BLACK - Package", -1);
	%dropDown.add("--------------------------------------------------------", -1);
	%dropDown.add("01: Package Declaration", 20);
	%dropDown.add("--------------------------------------------------------", -1);
	%dropDown.add("   PURPLE - Delimiters & Arithmetic", -1);
	%dropDown.add("--------------------------------------------------------", -1);
	%dropDown.add("01: Argument Delimiter (Arg1, Arg2)", 8);
	%dropDown.add("02: Arithmetic Operation (+)", 9690);
	%dropDown.add("03: Arithmetic Operation (-)", 9691);
	%dropDown.add("04: Arithmetic Operation (*)", 9692);
	%dropDown.add("05: Arithmetic Operation (/)", 9693);
	%dropDown.add("06: Arithmetic Operation (%)", 9694);
	%dropDown.setText("New Block");
}

function ScratchGui::onFuncHelpSelect(%this) {
	%selectedID = Scratch_FuncHelp_List.getSelectedID();
	%text       = Scratch_FuncHelp_List.getRowTextByID(%selectedID);
	if(%selectedID < 0) {
		$CACHE::Scratch::CollapsedCategory[getField(%text, 1)] = ($CACHE::Scratch::CollapsedCategory[getField(%text, 1)] ? 0 : 1);
		%this.pushFuncHelp();
		return;
	}
	if($CACHE::Scratch::FuncHelpSystem::LastSelectedID == %selectedID && getSimTime()-$CACHE::Scratch::FuncHelpSystem::LastSelectTime < 2000) {
		%func = getField(%text, 1);
		%argc = getField(%text, 2);
		Scratch_Content.add(Scratch::createPremadeBlock(32, "0" SPC %func SPC %argc));
	}
	$CACHE::Scratch::FuncHelpSystem::LastSelectTime = getSimTime();
	$CACHE::Scratch::FuncHelpSystem::LastSelectedID = %selectedID;
	Scratch_FuncHelp_Desc.setText(Scratch::getFunctionHelpStr(getField(%text, 1)));
}

function Scratch_SelectElement::onSelect(%this, %ID, %text) {
	switch(%ID) {
		case -1: %this.setText("New Block"); return;
		case -2: ScratchGui.pushFuncHelp(); %this.setText("New Block"); return;
	}
	if(%ID >= 9000) {
		%args = getSubStr(%ID, strIPos(%ID, "9", 1)+1, strLen(%ID));
		%ID   = getSubStr(%ID, 1, strIPos(%ID, "9", 1)-1);
	}
	Scratch_Content.add(Scratch::createPremadeBlock(%ID, %args));
	%this.setText("New Block");
}

function Scratch_SaveCodeCallback(%path, %fileName) {
	Scratch::exportScript(%path @ "/" @ %fileName);
}

function ScratchGui::saveCode(%this) {
	%this.openDirectorySelector("Scratch_SaveCodeCallback", "Export", "_.cs_ Torque Script (.cs)");
}

function Scratch_ImportCodeCallback(%path, %fileName) {
	Scratch::readFileToBlock(%path @ "/" @ %fileName);
}

function ScratchGui::importCode(%this) {
	%this.openDirectorySelector("Scratch_ImportCodeCallback", "Open", "_.cs_ Torque Script (.cs)");
}

function Scratch_saveWorkspaceCallback(%path, %file) { Scratch::saveWorkspace(%path @ "/" @ %file); }

function Scratch_loadWorkspaceCallback(%path, %file) { Scratch::loadWorkspace(%path @ "/" @ %file); }

function ScratchGui::loadWorkspace(%this) {
	%this.openDirectorySelector("Scratch_loadWorkspaceCallback");
}

function ScratchGui::saveWorkspace(%this) {
	%this.openDirectorySelector("Scratch_saveWorkspaceCallback");
}

function ScratchGui::searchFuncHelp(%this) {
	%this = Scratch_FuncHelp_Search;
	%query = %this.getValue();
	$CACHE::Scratch::FuncHelp::SearchQuery = %query;
	ScratchGui.pushFunchelp();
	%this.makeFirstResponder(1);
}

function ScratchGui::pushFuncHelp(%this) {
	%win = Scratch_FunctionInfo;
	ScratchGui.pushToBack(%win);
	if(!%win.isVisible()) {
		%win.setVisible(1);
		%win.resize((Canvas.getWidth()/2)-(%win.getWidth()/2), (Canvas.getHeight()/2)-(%win.getHeight()/2), %win.getWidth(), %win.getHeight());
	}
	Scratch_FuncHelp_List.clear();
	for(%i=0;%i<ScratchFuncHelp.catCount;%i++) {
		%cat = ScratchFuncHelp.catTable[%i];
		%got = 0;
		%amt = 0;
		for(%j=1;%j<getWordCount(ScratchFuncHelp.cat[getSafeVariableName(%cat)]);%j++) {
			%c_data = ScratchFuncHelp.at(getWord(ScratchFuncHelp.cat[getSafeVariableName(%cat)], %j));
			%c_name = getField(%c_data, 0);
			%c_args = getField(%c_data, 1);
			%c_cat  = getField(%c_data, 2);
			%c_desc = getField(%c_data, 3);
			%c_argc = getField(%c_data, 4);
			if($CACHE::Scratch::FuncHelp::SearchQuery !$= "" && strIPos(%c_name, $CACHE::Scratch::FuncHelp::SearchQuery) != 0) continue;
			if(!%got) {
				%got = -1-%i;
				if($CACHE::Scratch::CollapsedCategory[%cat]) Scratch_FuncHelp_List.addRow(-1-%i, "+ " @ %cat TAB %cat);
				else Scratch_FuncHelp_List.addRow(-1-%i, "- " @ %cat TAB %cat);
			}
			%amt++;
			if($CACHE::Scratch::CollapsedCategory[%cat]) continue;
			Scratch_FuncHelp_List.addRow(Scratch_FuncHelp_List.rowCount()+1, "     " @ %c_name TAB %c_name TAB %c_argc);
		}
		if(%got && $CACHE::Scratch::FuncHelp::SearchQuery !$= "") {
			Scratch_FuncHelp_List.setRowById(%got, getField(Scratch_FuncHelp_List.getRowTextByID(%got),0) SPC "(" @ %amt @ ")" TAB getField(Scratch_FuncHelp_List.getRowTextByID(%got), 1));
		}
	}
}

function ScratchGui::ClearCode(%this, %confirm) {
	if(!%confirm) {
		messageBoxYesNo("Confirmation - Scratch", "Clear all your code?", "ScratchGui.clearCode(1);");
		return;
	}
	%array = ScratchCode;
	%array.empty();
	ScratchContainer.deleteAll();
}