// Scratch_OptBackgrounds
// Scratch_OptButtonsList
function Scratch::openOptionsMenu() {
	if(!$Scratch::SHOWNOPTIONSMENU) {
		$Scratch::SHOWNOPTIONSMENU = 1;
		messageBoxOk("INFO - Scratch Editor", "The options menu is one of the many currently unfinished features of this add-on. This is not the final design of the options menu.");
	}
	Scratch_OptionsMenu.resize((getWord(Canvas.getExtent(), 0)/2) - 300, (getWord(Canvas.getExtent(), 1)/2) - 220, 600, 440);
	Scratch_OptionsMenu.setVisible(1);
	ScratchGui.pushToBack(Scratch_OptionsMenu);
	// Scratch::renderOptionsMenu();
	ScratchTemp_BracketPlacement.clear();
	ScratchTemp_BracketPlacement.setText("--wip--");
}

function isEven(%num) {
	return (%num % 2 ? 0 : 1);
}

function Scratch::NumbersToLetters(%text) {
	%tbl  = "ABCDEFGHIJK";
	if(getSubStr(%text, 0, 1) $= "-") %text = getSubStr(%text, 1, strLen(%text));
	for(%i=0;%i<strLen(%tbl);%i++) %text = strReplace(%text, %i, getSubStr(%tbl, %i, 1));
	return %text;
}

if(!isObject(ScratchPrefsSO)) new ScriptObject(ScratchPrefsSO) { class = "ArrayObject"; };

/// %category - Category name. Identifies where the preference will be stored on the GUI. Required.
///
/// %name     - Internal name. Used in Scratch_OptionsMenu::getPref(%this, %name) . Required.
///
/// %text     - Text that displays in the options. Required.
///
/// %type     - Type of preference. Required.
///
/// %callBack - The function called when the preference is changed.
///		This can be set to "echo("test");" or "echo". If it is something like "echo("test");",
///		then all arguments specified in the callback will be passed on, along with the changed variable value.
///		e.g. "echo("test", <new value>);"
///		Required if %prefName is blank.
///
/// %prefName - Global variable name. Do not prefix this with a '$'. Required if %callBack is blank.
///
/// Returns 0 if the preference failed to register, 1 otherwise.
/// Types:
///	"bool"   - Boolean. Displayed as a GuiCheckBoxCtrl.
///	"string" - String.  Displayed as a GuiTextEditCtrl.
///	"list"   - List.    Displayed as a GuiPopupMenuCtrl. Can be used as: "list\t<text> <id>\t<text> <id>\t<text> <id>" etc
///	"int"    - Integer. Displayed as a GuiTextEditCtrl.
///	"float"  - Float.   Displayed as a GuiTextEditCtrl.
function Scratch::registerPref(%category, %name, %text, %type, %callBack, %prefName) {
	%category = trim(%category);
	%name     = trim(%name);
	%text     = trim(%text);
	%type     = trim(%type);
	%callBack = trim(%callBack);
	%prefName = trim(getSafeVariableName(%prefName));
	if(%category $= "" || %name $= "" || %text $= "" || %type $= "" || (%callBack $= "" && %prefName $= "") || strIPos("_bool_string_list_int_float_", getField(%type, 0)) == -1) {
		echo("\c2ERROR: Scratch::registerPref() - Incorrect arguments");
		echo("\c2ERROR: Scratch::registerPref() - Usage: (%category, %name, %text, %type[, %callBack[, %prefName]])");
		backTrace();
		return 0;
	}
	for(%i=0;%i<ScratchPrefsSO.size();%i++) {
		%pref   = ScratchPrefsSO.at(%i);
		%catName  = getRecord(%pref, 0);
		%name     = getRecord(%pref, 1);
		%text     = getRecord(%pref, 2);
		%type     = getRecord(%pref, 3);
		%callBack = getRecord(%pref, 4);
		%varName  = getRecord(%pref, 5);
		if(%p_name !$= %name || %p_catN !$= %category) continue;
		ScratchPrefsSO.setAt(%i, %category NL %name NL %text NL %type NL %callBack NL %prefName);
		return 1;
	}
	ScratchPrefsSO.pushBack(%category NL %name NL %text NL %type NL %callBack NL %prefName);
	return 1;
}

function Scratch::renderOptionsMenu() {
	for(%i=0;%i<ScratchPrefsSO.size();%i++) {
		%pref     = ScratchPrefsSO.at(%i);
		%catName  = getRecord(%pref, 0);
		%name     = getRecord(%pref, 1);
		%text     = getRecord(%pref, 2);
		%type     = getRecord(%pref, 3);
		%callBack = getRecord(%pref, 4);
		%varName  = getRecord(%pref, 5);
		%p_cObj   = Scratch::options_getCategoryContainer(%catName);
		
		if(!isObject(%obj = Scratch::options_getPrefContainer(%i))) {
			warn("WARNING: Scratch::renderOptionsMenu() - Unable to draw preference " @ %varName);
			continue;
		}
		
		%y = %obj.getHeight()*%p_cObj.getCount();
		%obj.resize(0, %y, %p_cObj.getWidth(), 28);
	}
	for(%i=0;%i<Scratch_OptButtonsList.getCount();%i++) {
		%obj = Scratch_OptButtonsList.getObject(%i);
		%y   = %i*%obj.getHeight();
		%obj.resize(0, %y, Scratch_OptButtonsList.getWidth(), 18);
	}
}

function Scratch::options_getPrefContainer(%index) {
	%pref     = ScratchPrefsSO.at(%index);
	if(%pref $= "") return 0;
	%catName  = getRecord(%pref, 0);
	%name     = getRecord(%pref, 1);
	%text     = getRecord(%pref, 2);
	%type     = getRecord(%pref, 3);
	%callBack = getRecord(%pref, 4);
	%varName  = getRecord(%pref, 5);
	%objName  = "Scratch_OptPrefContainer_" @ Scratch::NumbersToLetters(getStringCRC(%name @ %catName));
	%catObj   = Scratch::options_getCategoryContainer(%catName);
	if(!isObject(%catObj)) return 0;
	if(!isObject(%obj = %objName)) {
		%newObj = new GuiSwatchCtrl(%objName) {
			position    = "0 0";
			extent      = Scratch_OptBackgrounds.getWidth() SPC "28";
			horizSizing = "width";
			color       = (isEven(%catObj.getCount()) ? "0 92 160 10" : "255 255 255 255");

			new GuiMLTextCtrl() {
				vertSizing  = "center";
				position    = "5 6";
				extent      = (strLen(stripMLControlChars(%text))*(14/2)) SPC "14";
				text        = "<font:Consolas:14>" @ %text;
			};
		};
		%catObj.add(%newObj);
		switch$(getField(%type, 0)) {
			case "bool":
				%prefObj = new GuiCheckBoxCtrl() {
					extent      = "12 12";
					horizSizing = "left";
					vertSizing  = "center";
				};
				%newObj.add(%prefObj);
				%mainCommand = 1;
			case "string":  
				%prefObj = new GuiTextEditCtrl() {
					position    = %newObj.getWidth()-5 SPC (%newObj.getHeight()/2)-(12/2);
					extent      = "140 16";
					horizSizing = "left";
					vertSizing  = "center";
					accelerator = "enter";
				};
				%newObj.add(%prefObj);
			case "list":
				%prefObj = new GuiPopUpMenuCtrl("ScratchOptionsPopup") {
					position    = %newObj.getWidth()-5 SPC (%newObj.getHeight()/2)-(12/2);
					extent      = %newObj.getWidth()/2 SPC "16";
					horizSizing = "left";
					vertSizing  = "center";
					varName     = %varName;
					callBack    = %callBack;
				};
				%newObj.add(%prefObj);
				%prefObj.clear();
				for(%i=1;%i<getFieldCount(%type);%i++) {
					%val = getField(%type, %i);
					%prefObj.add(%val, %i-1);
				}
				%default = (%varName $= "" ? 0 : eval("return $" @ %varName @ ";"));
				%prefObj.setText(getField(%type, %default+1));
				%dontSetCommand = 1;
			case "int":
				%prefObj = new GuiTextEditCtrl() {
					position    = %newObj.getWidth()-5 SPC (%newObj.getHeight()/2)-(12/2);
					extent      = "140 16";
					horizSizing = "left";
					vertSizing  = "center";
					accelerator = "enter";
				};
				%newObj.add(%prefObj);
			case "float":
				%prefObj = new GuiTextEditCtrl() {
					position    = %newObj.getWidth()-5 SPC (%newObj.getHeight()/2)-(12/2);
					extent      = "140 16";
					horizSizing = "left";
					vertSizing  = "center";
					accelerator = "enter";
				};
				%newObj.add(%prefObj);
		}
		if(isObject(%prefObj)) {
			%prefObj.resize(%newObj.getWidth()-%obj.getWidth()-5, (%newObj.getHeight()/2)-(%obj.getHeight()/2), %obj.getWidth(), %obj.getHeight());
			%newObj.prefObj = %prefObj;
			if(!%dontSetCommand) {
				if((%info = Struct_funcCall(%callBack)) !$= "") {
					%args    = (getFieldCount(getRecord(%info, 2)) == 0 ? "" : strReplace(getRecord(%info, 2), "\t", ",") @ ", ") @ %prefObj.getId() @ ".getValue()";
					%command = ((%nameSpace = getRecord(%info, 0)) $= "" ? "" : %nameSpace @ ".") @ getRecord(%info, 1) @ "(" @ %args @ ");";
				}
				%cmd = (%varName $= "" ? "" : "$" @ %varName @ " = " @ %prefObj.getId() @ ".getValue();") @ %command;
				if(%mainCommand) %prefObj.command = %cmd;
				else %prefObj.altCommand = %cmd;
			}
			if(%valName !$= "") %prefObj.setValue(eval("return $" @ %valName @ ";"));
		}
		return %newObj;
	}
	return %obj;
}

function Scratch::options_getCategoryContainer(%text) {
	if(%text $= "") return 0;
	%objName = "Scratch_OptCatContainer_" @ Scratch::NumbersToLetters(getStringCRC(%text));
	if(!isObject(%obj = %objName)) {
		%newObj = new GuiSwatchCtrl(%objName) {
			position    = "0 0";
			horizSizing = "width";
			vertSizing  = "height";
			extent      = Scratch_OptBackgrounds.getExtent();
			color       = "255 255 255 255";
			name        = %text;
		};
		Scratch::options_drawCategoryButton(%text);
		Scratch_OptBackgrounds.add(%newObj);
		return %newObj.getId();
	}
	return %obj.getId();
}

function Scratch::options_drawCategoryButton(%text) {
	if(%text $= "") return 0;
	%objName = "Scratch_OptButton_" @ Scratch::NumbersToLetters(getStringCRC(%text));
	if(!isObject(%obj = %objName)) {
		%newObj = new GuiButtonCtrl(%objName) {
			position    = "0 0";
			horizSizing = "width";
			extent      = getWord(Scratch_OptButtonsList.getExtent(), 0) SPC "18";
			color       = "255 255 255 255";
			text        = %text;
			command     = "Scratch::options_setCategory(\"" @ %text @ "\");";
		};
		Scratch_OptButtonsList.add(%newObj);
	}
	return 1;
}

function Scratch::options_setCategory(%text) {
	%objName = "Scratch_OptCatContainer_" @ Scratch::NumbersToLetters(getStringCRC(%text));
	if(!isObject(%objName)) {
		error("ERROR: Scratch::options_setCategory() - Unable to find category " @ %text);
		return;
	}
	for(%i=0;%i<Scratch_OptBackgrounds.getCount();%i++) {
		%obj = Scratch_OptBackgrounds.getObject(%i);
		%obj.setVisible(0);
	}
	%objName.setVisible(1);
}

function ScratchOptionsPopup::onSelect(%this, %Id, %text) {
	%callBack = %this.callBack;
	%varName  = %this.varName;
	if((%info = Struct_funcCall(%callBack)) !$= "") {
		%args    = (getFieldCount(getRecord(%info, 2)) == 0 ? "" : strReplace(getRecord(%info, 2), "\t", ",") @ ", ") @ %Id;
		%command = ((%nameSpace = getRecord(%info, 0)) $= "" ? "" : %nameSpace @ ".") @ getRecord(%info, 1) @ "(" @ %args @ ");";
	}
	%cmd = (%varName $= "" ? "" : "$" @ %varName @ " = \"" @ %Id @ "\"") @ %command;
	eval(%cmd);
}

// Default options

Scratch::registerPref("Test", "t0", "t0", "bool", "echo(\"test\");", "");
Scratch::registerPref("Test", "t1", "t1", "string", "echo(\"test\");", "$testpef");
Scratch::registerPref("Test", "t2", "t2", "list\tone\ttwo\tthree", "", "$testpef2");
Scratch::registerPref("Test", "t3", "t3", "int", "", "$testpef3");
Scratch::registerPref("Test", "t4", "t4", "float", "", "$testpef4");

Scratch::registerPref("Display Settings", "block_outlines", "Enable block connection outlines", "bool", "", "Pref::Scratch::DisplayPrefs::EnableOutlines");

Scratch::registerPref("Export Options", "indent_type", "Indentation Type", "list\tTab\tThree Spaces", "", "Pref::Scratch::ExportSystem::Prefs::IndentType");
Scratch::registerPref("Export Options", "bracket_placement", "Bracket Placement", "list\tOn same line\tOn next line", "", "Pref::Scratch::ExportSystem::Prefs::BracketPlacement");