function Scratch_PlrCreator::registerAbility(%label, %type, %varName, %default) {
	%validTypes = "_bool_text_int_";
	%label      = trim(stripMLControlChars(%label));
	%varName    = getSafeVariableName(trim(%varName));
	if(strIPos(%validTypes, "_" @ %type @ "_") == -1 || %varName $= "" || %label $= "") {
		error("ERROR: Scratch_PlrCreator::regiterAbility() - Unable to register ability \"" @ %label @ "\" -- " @ (%varName $= "" ? "Variable name" : (%label $= "" ? "Label" : "Type")) @ " is invalid.");
		return 0;
	}
	%group  = Scratch_PlrCreator_AbilityList;
	%newObj = new GuiSwatchCtrl() {
		profile = "GuiDefaultProfile";
		horizSizing = "width";
		vertSizing = "bottom";
		position = "0" SPC (28*%group.getCount());
		extent = %group.getWidth() SPC "28";
		minExtent = "8 2";
		visible = "1";
		color = (isEven(%group.getCount()) ? "0 100 176 50" : "255 255 255 255");
		varName = %varName;
		varValue = %default;
		varType  = %type;
			
		new GuiMLTextCtrl() {
			profile = "GuiMLTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "4 5";
			extent = %group.getWidth()/2 SPC "15";
			minExtent = "8 2";
			visible = "1";
			lineSpacing = "2";
			allowColorChars = "0";
			maxChars = "-1";
			text = "<font:Franklin Gothic Demi:15>" @ %label;
			maxBitmapHeight = "-1";
			selectable = "1";
		};
	};
	switch$(%type) {
		case "bool":
			%obj = new GuiCheckBoxCtrl() {
				profile = "GuiCheckBoxProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = %group.getWidth()-22 SPC "0";
				extent = "15 28";
				minExtent = "8 2";
				visible = "1";
				text = " ";
				groupNum = "-1";
				buttonType = "ToggleButton";
			};
			%obj.command = %newObj @ ".varValue = " @ %obj @ ".getValue();";
			%newObj.add(%obj);
			%obj.setValue(mClamp(%default, 0, 1));
		case "text":
			%width  = (%group.getWidth()/2)-3;
			%height = (%group.getHeight()/2)-(16/2);
			%obj    = new GuiTextEditCtrl() {
				profile = "GuiTextEditProfile";
				horizSizing = "left";
				vertSizing = "center";
				position = mAbs(%group.getWidth()-%width) SPC %height;
				extent = %width SPC "16";
				minExtent = "8 2";
				visible = "1";
			};
			%obj.command = %newObj @ ".varValue = " @ %obj @ ".getValue();";
			%newObj.add(%obj);
			%obj.setValue(%default);
		case "int":
			%width  = (%group.getWidth()/2);
			%height = (%group.getHeight()/2)-(16/2);
			%obj    = new GuiTextEditCtrl() {
				profile = "ScratchPlrCreator_NumberOnlyTextEditProfile";
				horizSizing = "left";
				vertSizing = "center";
				position = mAbs(%group.getWidth()-%width) SPC %height;
				extent = %width SPC "16";
				minExtent = "8 2";
				visible = "1";
			};
			%obj.command = %newObj @ ".varValue = atof(" @ %obj @ ".getValue());";
			%newObj.add(%obj);
			%obj.setValue(atof(%default));
	}
	%group.add(%newObj);
	%group.resize(1, 1, %group.getWidth(), 28*%group.getCount());
	return 1;
}

function initScratchPlrCreatorAbilities() {
	Scratch_PlrCreator::registerAbility("Can use jets", "bool", "canJet", "1");
	Scratch_PlrCreator::registerAbility("Rideable", "bool", "canRide", "0");
	Scratch_PlrCreator::registerAbility("Show energy bar", "bool", "showEnergyBar", "0");
	Scratch_PlrCreator::registerAbility("Display first person?", "bool", "renderFirstPerson", "0");
	Scratch_PlrCreator::registerAbility("Jump delay (ms x32)", "int", "jumpDelay", "3");
	Scratch_PlrCreator::registerAbility("Max tools", "int", "maxTools", "5");
	Scratch_PlrCreator::registerAbility("Max weapons", "int", "maxWeapons", "5");
	Scratch_PlrCreator::registerAbility("mass", "int", "mass", "90");
}

if(Scratch_PlrCreator_AbilityList.getCount() == 0) initScratchPlrCreatorAbilities();