function Scratch_PlrCreator::registerAnimation(%dsqFile) {
	%label = trim(stripMLControlChars(%label));
	if(!isFile(%dsqFile)) {
		error("ERROR: Scratch_PlrCreator::regiterAnimation() - Unable to register animation \"" @ %label @ "\" -- Animation file \"" @ %dsqFile @ "\" does not exist.");
		return 0;
	}
	if(fileExt(%dsqFile) !$= ".dsq") {
		error("ERROR: Scratch_PlrCreator::regiterAnimation() - Unable to register animation \"" @ %label @ "\" -- Animation file has invalid extension (got \"" @ fileExt(%dsqFile) @ "\", expected \".dsq\")");
		return 0;
	}
	if(strIPos(%dsqFile, "_") == -1) {
		error("ERROR: Scratch_PlrCreator::regiterAnimation() - Unable to register animation \"" @ %label @ "\" -- Animation file not prefixed (instead of 'run.dsq' it should be '<anyprefix>_run.dsq', for example 'm_run.dsq')");
		return 0;
	}
	%group   = Scratch_PlrCreator_AnimList;
	%dsqName = fileBase(%dsqFile);
	%dsqName = getSubStr(%dsqName, strIPos(%dsqName, "_")+1, strLen(%dsqName));
	%newObj  = new GuiSwatchCtrl() {
		profile = "GuiDefaultProfile";
		horizSizing = "width";
		vertSizing = "bottom";
		position = "0" SPC (28*%group.getCount());
		extent = %group.getWidth() SPC "28";
		minExtent = "8 2";
		visible = "1";
		color = (isEven(%group.getCount()) ? "0 100 176 50" : "255 255 255 255");
		defColor = (isEven(%group.getCount()) ? "0 100 176 50" : "255 255 255 255");
		dsqName = %dsqName;
		dsqFile = %dsqFile;
		
		new GuiMLTextCtrl() {
			profile = "GuiMLTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "4 5";
			extent = %group.getWidth()/2 SPC "15";
			minExtent = "8 2";
			visible = "1";
			lineSpacing = "2";
			allowColorChars = "0";
			maxChars = "-1";
			text = "<font:Franklin Gothic Demi:15>" @ fileBase(%dsqFile);
			maxBitmapHeight = "-1";
			selectable = "1";
		};
		new GuiButtonBaseCtrl() {
			horizSizing = "width";
			vertSizing = "height";
			position = "0 0";
			extent = %group.getWidth() SPC "28";
			minExtent = "8 2";
			visible = "1";
			lineSpacing = "2";
			allowColorChars = "0";
			maxChars = "-1";
			text = " ";
			maxBitmapHeight = "-1";
			selectable = "1";
		};
		new GuiTextEditCtrl() {
			profile = "GuiTextEditProfile";
			horizSizing = "left";
			vertSizing = "center";
			position = mAbs(%group.getWidth()-((%group.getWidth()/2)-3)) SPC (%group.getHeight()/2)-(16/2);
			extent = (%group.getWidth()/2)-3 SPC "16";
			minExtent = "8 2";
			visible = "1";
		};
	};
	%newObj.getObject(2).setValue(%dsqName);
	%newObj.getObject(1).command = "Scratch_PlrCreator::selectAnim(" @ %newObj.getId() @ ");";
	%group.add(%newObj);
	%group.resize(1, 1, %group.getWidth(), 28*%group.getCount());
	return 1;
}

function Scratch_PlrCreator::selectAnim(%this) {
	if(isObject($CACHE::Scratch::PlayerCreator::SelectedObject)) {
		$CACHE::Scratch::PlayerCreator::SelectedObject.color = $CACHE::Scratch::PlayerCreator::SelectedObject.defColor;
	}
	$CACHE::Scratch::PlayerCreator::SelectedObject = %this;
	%color = vectorScale(%this.defColor, 1.3);
	if(%this.defColor $= "255 255 255 255") %color = "200 200 200 255";
	%this.color = %color;

	// Play the animation
	Scratch_PlrCreator_Preview.setSequence("player", "0", %this.getObject(2).getValue(), 0.8);
}