function Scratch::toggleProjectManager() {
	if(!$Pref::Scratch::DoneWithTutorial && $CACHE::Scratch::Tutorial::Stage == 1) {
		$CACHE::Scratch::Tutorial::Stage++;
		Scratch::stepTutorial();
		%doNotDisable = 1;
	}
	if(Scratch_ProjectManager.isVisible()) {
		Scratch_ProjectManager.setVisible(0);
		Scratch_ProjManagerButton.setText("VV");
		cancel($CACHE::Scratch::ProjectManager::HandleResizeSchedule);
		Scratch::renderTree(); // Start this back up
		Scratch_MainWindow.canClose = 1;
	} else {
		Scratch_MainWindow.canClose = 0;
		if(!%doNotDisable) cancel($CACHE::Scratch::RenderSystem::TreeRenderSchedule); // Cancel Scratch::renderTree() - Less lag!
		Scratch_ProjectManager.setVisible(1);
		Scratch_ProjManagerButton.setText("^^");
		if(!isObject($CACHE::Scratch::ProjectManager::CurrentTab)) Scratch::projMan_setTab(0);
		Scratch::projMan_sortTabs();
		Scratch::projMan_handleResizing();
	}
}

function Scratch::projMan_fetchTabs() {
	return "SpawnMenuContent Workspaces";
}

function Scratch::projMan_renderTab() {
	%idx = $CACHE::Scratch::ProjectManager::CurrentTabID;
	switch(%idx) {
		case 0: Scratch::spawnMenu_sortItems();
		case 1: Scratch::workSpaces_sortItems();
	}
}

function Scratch::projMan_handleResizing() {
	%this = Scratch_ProjectManager;
	if(%this.getExtent() !$= $CACHE::Scratch::ProjectManager::HandleResizing::CachedSize) {
		$CACHE::Scratch::ProjectManager::HandleResizing::CachedSize = %this.getExtent();
		if(!isObject(%obj = $CACHE::Scratch::ProjectManager::CurrentTab)) {
			error("ERROR: Scratch::projMan_handleResizing() - No tab is currently set!");
			return;
		}
		Scratch::projMan_sortTabs();
		Scratch::projMan_renderTab();
	}
	cancel($CACHE::Scratch::ProjectManager::HandleResizeSchedule);
	$CACHE::Scratch::ProjectManager::HandleResizeSchedule = schedule(1000, 0, eval, "Scratch::projMan_handleResizing();");
}

function Scratch::projMan_setScrollSize(%amt) {
	%amt    = mClamp(%amt, 0, 10000)-3;
	Scratch_ProjectManager_scrollManager.resize(1, 1, 8, %amt);
	Scratch_ProjectManager_Menu.resize(0, 0, Scratch_ProjectManager_Menu.getWidth(), Scratch_ProjectManager_Menu.getHeight());
	%this   = Scratch_ProjectManager_RightMenu;
	%XPos   = Scratch_ProjectManager.getWidth()-%this.getWidth()-15;
	%YPos   = Scratch_ProjectManager_Menu.getBottom()+1;
	%width  = %this.getWidth();
	%height = mAbs(%amt-%YPos);
	%this.resize(%XPos, %YPos-1, %width, %height);
}

function Scratch::projMan_setTab(%id) {
	%table = Scratch::projMan_fetchTabs();
	if(%id >= getWordCount(%table) || %id < 0) {
		error("ERROR: Scratch_projMan_setTab() - Invalid ID " @ %id @ " (out of range)");
		return 0;
	}
	for(%i=0;%i<getWordCount(%table);%i++) {
		%object = ("Scratch_ProjectManager_" @ getWord(%table, %i));
		if(!isObject(%object)) continue;
		%object.setVisible(0);
	}
	%object = ("Scratch_ProjectManager_" @ getWord(%table, %id));
	if(!isObject(%object)) {
		error("ERROR: Scratch_projMan_setTab() - Tab at ID " @ %id @ " does not exist");
		return 0;
	}
	%object.setVisible(1);
	$CACHE::Scratch::ProjectManager::CurrentTab   = %object;
	$CACHE::Scratch::ProjectManager::CurrentTabID = %id;
	Scratch::projMan_renderTab();
	return 1;
}

function Scratch::projMan_sortTabs() {
	%table = Scratch::projMan_fetchTabs();
	%YPos  = Scratch_ProjectManager_Menu.getBottom();
	%width = Scratch_ProjectManager_RightMenu.getLeft();
	for(%i=0;%i<getWordCount(%table);%i++) {
		%object = ("Scratch_ProjectManager_" @ getWord(%table, %i));
		if(!isObject(%object)) continue;
		%object.resize(0, %YPos, %width, %object.getHeight());
	}
	return 1;
}

function Scratch::projMan_processSizes() {
	%table = Scratch::projMan_fetchTabs();
	%YPos  = Scratch_ProjectManager_Menu.getBottom();
	%width = Scratch_ProjectManager_RightMenu.getLeft();
	%bigH  = Scratch_ProjectManager.getHeight();
	for(%i=0;%i<getWordCount(%table);%i++) {
		%object = ("Scratch_ProjectManager_" @ getWord(%table, %i));
		if(!isObject(%object)) continue;
		if(!%object.isVisible()) continue;
		if(%object.getBottom() >= %bigH) %bigH = %object.getBottom();
	}
	Scratch::projMan_setScrollSize(%bigH);
}