function Scratch::xmlParser_fixRetardedElementEnd(%str) {
	if(strLen(%str) < 2) return %str;
	if(getSubStr(%str, strLen(%str)-2, 2) !$= "/>") return %str;
	if(strLen(%str) < 3) return %str;
	if(getSubStr(%str, strLen(%str)-3, 3) $= " />") return %str;
	%str = getSubStr(%str, 0, strLen(%str)-2) @ " />";
	return %str;
}

function Scratch::xmlParser_removeQuotedText(%str) {
	%str = Scratch::xmlParser_fixRetardedElementEnd(%str);
	%str = strReplace(%str, "\\\"", "  ");
	while(true) {
		if(%debug++ >= 1000) { echo("broke remove quoted text"); break; }
		if((%fPos = strPos(%str, "\"")) == -1) break;
		if((%sPos = strPos(%str, "\"", %fPos+1)) == -1) break;
		%inb = getSubStr(%str, %fPos, %sPos-(%fPos-1));
		%ws  = "";
		for(%i=0;%i<strLen(%inb);%i++) {
			if(getSubStr(%inb, %i, 1) $= " ") { %ws = %ws @ " "; continue; }
			%ws = %ws @ "_";
		}
		%str = getSubStr(%str, 0, %fPos) @ %ws @ getSubStr(%str, %sPos+1, strLen(%str));
	}
	return %str;
}

function Scratch::xmlParser_getElementName(%str) {
	%str = Scratch::xmlParser_fixRetardedElementEnd(%str);
	%name = getWord(%str, 0);
	if(getSubStr(%name, 0, 2) $= "</") %name = getSubStr(%name, 2, strLen(%name));
	if(getSubStr(%name, 0, 1) $= "<") %name = getSubStr(%name, 1, strLen(%name));
	if(getSubStr(%name, strLen(%name)-1, 1) $= ">") %name = getSubStr(%name, 0, strLen(%name)-1);
	return %name;
}

function Scratch::xmlParser_isClosingElement(%str) {
	%str = Scratch::xmlParser_fixRetardedElementEnd(%str);
	%name = getWord(%str, 0);
	if(getSubStr(%str, strLen(%str)-2, 2) $= "/>") return 2;
	if(getSubStr(%name, 0, 2) $= "</") return 1;
	return 0;
}

function Scratch::xmlParser_getElementTag(%str, %tagName) {
	%str = Scratch::xmlParser_fixRetardedElementEnd(%str);
	%str = removeWord(%str, 0);
	if(%str $= "") return "";
	%str = getSubStr(%str, 0, strLen(%str)-1);
	%tmp = Scratch::xmlParser_removeQuotedText(%str);
	for(%i=0;%i<getWordCount(%str);%i++) {
		%word = getWord(%str, %i);
		if(strPos(getWord(%tmp, %i), "=") == -1) continue;
		%name = getSubStr(%word, 0, strPos(%word, "="));
		if(%name !$= %tagName) continue;
		%val = getSubStr(%word, strLen(%name)+1, strLen(%word));
		if(getSubStr(%val, 0, 1) $= "\"" && getSubStr(%val, strLen(%val)-1, 1) !$= "\"") {
			for(%j=%i+1;%j<getWordCount(%str);%j++) {
				if(getSubStr(getWord(%str, %j), strLen(getWord(%str, %j))-1, 1) $= "\"") { %val = %val SPC getWord(%str, %j); break; }
				%val = %val SPC getWord(%str, %j);
			}
			%val = trim(%val);
		}
		if(getSubStr(%val, 0, 1) $= "\"" && getSubStr(%val, strLen(%val)-1, 1) $= "\"") %val = getSubStr(%val, 1, strLen(%val)-2);
		return %val;
	}
	return "";
}

function Scratch::saveBlockData(%stream, %this, %indentSize) {
	if(!isObject(%this)) return;
	if(!isObject(%stream)) return;
	$CACHE::Scratch::WorkspaceSave::Block[%this] = 1;
	
	%stream.writeLine(Scratch::indent(%indentSize) @ "<!-- " @ Scratch::getBlockName(%this.blockLayoutType) @ " -->");
	// Write the block element
	%stream.writeLine(Scratch::indent(%indentSize) @ "<block typeid=\"" @ %this.blockLayoutType @ "\" args=\"" @ %this.blockCreationArgs @ "\">");
	%indentSize++;
	
	// Write block arguments
	for(%j=0;%j<%this.blockArgCount;%j++) {
		%child = %this.blockArgObject[%j];
		if(isObject(%obj = %child.innerConnection_Child)) {
			%inner[-1+%innerCount++] = %obj SPC %j;
		} else if(isObject(%obj = %child.textEdit)) {
			%stream.writeLine(Scratch::indent(%indentSize) @ "<arg index=\"" @ %j @ "\" type=\"string\" value=\"" @ %obj.getValue() @ "\"/>");
		}
	}
	
	// Write all blocks that are inside the argument boxes on this block
	for(%i=0;%i<%innerCount;%i++) {
		%object = getWord(%inner[%i], 0);
		
		%stream.writeLine(Scratch::indent(%indentSize) @ "<arg index=\"" @ getWord(%inner[%i], 1) @ "\" type=\"block\">");
		Scratch::saveBlockData(%stream, %object, %indentSize + 1);
		%stream.writeLine(Scratch::indent(%indentSize) @ "</arg>");
	}
	
	// Write all things inside this container
	if(%this.container) {
		if(isObject(%obj = %this.inside_topConnection)) {
			%stream.writeLine(Scratch::indent(%indentSize) @ "<inner>");
				Scratch::saveBlockData(%stream, %obj, %indentSize+1);
			%stream.writeLine(Scratch::indent(%indentSize) @ "</inner>");
		}
	}
	
	// Write off this block
	%indentSize--;
	%stream.writeLine(Scratch::indent(%indentSize) @ "</block>");
	%stream.writeLine(Scratch::indent(%indentSize));
	
	// Write next connection
	if(isObject(%obj = %this.bottomConnection)) Scratch::saveBlockData(%stream, %obj, %indentSize);
}

function Scratch::saveWorkspace(%file, %name) {
	if(fileExt(%file) !$= ".sws") {
		error("ERROR: Scratch::saveWorkspace() - Failed to save workspace [\"File extension is invalid -- Must be .sws\"]");
		messageBoxOK("ERROR - Scratch", "File extension must be '.sws'.");
		return 0;
	}
	
	echo("Saving Scratch workspace to file \"" @ %file @ "\"...");
	
	// Init vars
	deleteVariables("$CACHE::Scratch::WorkspaceSave::Block*");
	%this = ScratchContainer;
	if(%name $= "") %name = fileBase(%file);

	// Take a screenshot
	%object = Scratch_Content.getGroup();
	%oldPos = %object.getPosition();
	%oldExt = %object.getExtent();
	Canvas.setContent(%object);
	Canvas.hideCursor();
	schedule(100, 0, screenShot, filePath(%file) @ "/" @ %name @ ".png", "PNG", 1);
	Canvas.schedule(230, setContent, ScratchGui);
	%object.schedule(240, resize, getWord(%oldPos, 0), getWord(%oldPos, 1), getWord(%oldExt, 0), getWord(%oldExt, 1));
	Canvas.schedule(230, showCursor);
	Scratch_MainWindow.schedule(200, add, %object);
	Scratch_MainWindow.schedule(210, bringToFront, %object);

	// Open the save file for writing
	%SO   = new FileObject();
	%SO.openForWrite(%file);
	
	// Write XML header
	%SO.writeLine("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
	
	// Write block data
	for(%i=0;%i<%this.getCount();%i++) {
		%object = %this.getObject(%i);

		// Validate that this is not an abandoned block
		if(%object.top || !isObject(%object.bottomConnection)) continue;
		
		// Check if this block was already saved
		if($CACHE::Scratch::WorkspaceSave::Block[%object]) continue;
		
		// Save the block
		%SO.writeLine("<connectionchain position=\"" @ %object.getPosition() @ "\">");
		Scratch::saveBlockData(%SO, %object, 1);
		%SO.writeLine("</connectionchain>\r\n");
	}
	
	// Clean up file SO
	%SO.close();
	%SO.delete();
	
	return 1;
}

function Scratch::loadWorkspace(%file) {
	if(fileExt(%file) !$= ".sws") {
		error("ERROR   | Scratch::loadWorkspace | Failed to save workspace [\"File extension is invalid -- Must be .sws\"]");
		messageBoxOK("ERROR - Scratch", "File extension must be '.sws'.");
		return 0;
	}
	if(!isFile(%file)) {
		error("ERROR   | Scratch::loadWorkspace | Failed to load workspace [\"File does not exist\"]");
		return 0;
	}
	
	echo("Loading Scratch workspace from file \"" @ %file @ "\"...");

	// Clear all existing blocks
	ScratchContainer.deleteAll();
	
	// Init vars
	%STAGE = "";
	%LINEC = -1;
	%SO    = new FileObject();
	%SO.openForRead(%file);
	
	// Read file
	while(!%SO.isEOF()) {
		%LINEC++;
		%line = trim(%SO.readLine());
		if(%line $= "") continue;
		
		%fTxt = Scratch::xmlParser_removeQuotedText(%line);
		
		while(%fTxt !$= "") {
			if((%start = strIPos(%fTxt, "<")) != -1 && (%end = strIPos(%fTxt, ">")) != -1) {
				%element = getSubStr(%line, %start, %end + 1);
				%line    = getSubStr(%line, %end + 1, strLen(%line));
				%fTxt    = getSubStr(%fTxt, %end + 1, strLen(%fTxt));
				
				if(getSubStr(%element, 0, 4) $= "<!--") continue; // Ignore comment lines
				
				%element[-1 + %elementCount++] = %element NL %LINEC;
			} else break;
		}
	}
	
	// Clean up
	%SO.close();
	%SO.delete();
	
	// Parse XML elements
	for(%i=0;%i<%elementCount;%i++) {
		%line   = getRecord(%element[%i], 0);
		%lineNo = getRecord(%element[%i], 1);
		
		%eleName   = Scratch::xmlParser_getElementName(%line);
		%isClosing = Scratch::xmlParser_isClosingElement(%line);
		
		if(%STAGE !$= "") {
			%currStage = getWord(%STAGE, getWordCount(%STAGE) - 1);
			switch(%currStage) {
				case 1: // <connectionchain>
					switch$(%eleName) {
						case "connectionchain":
							if(!%isClosing) continue;
							%STAGE = trim(removeWord(%STAGE, getWordCount(%STAGE) - 1));
							
							// Apply the connection chain position
							if(isObject(%topConnection = getWord(%connTbl, 0))) {
								%topConnection.resize(getWord(%connectionPosition, 0), getWord(%connectionPosition, 1), getWord(%topConnection.getExtent(), 0), getWord(%topConnection.getExtent(), 1));
							}
							
							// Do chain connection
							for(%j=1;%j<getWordCount(%connTbl);%j++) {
								%object  = getWord(%connTbl, %j);
								%lastObj = getWord(%connTbl, %j - 1);
								
								Scratch::attachBlock(%object, %lastObj, "bottom");
							}
							
							// Clear connection info
							%connTbl  = "";
						case "block":
							%typeid   = Scratch::xmlParser_getElementTag(%line, "typeid");
							%args     = Scratch::xmlParser_getElementTag(%line, "args");
							%newObj   = Scratch::createPremadeBlock(%typeid, %args);
							
							Scratch_Content.add(%newObj);
							
							if(!isObject(%newObj)) {
								error("ERROR   |  Scratch::loadWorkspace  | " @ %file @ " Line: " @ %lineNo @ " - Could not create block with ID " @ %typeID);
								return 0;
							}
							%blockTbl = trim(%blockTbl SPC %newObj);
							%connTbl  = trim(%connTbl SPC %newObj);
							%STAGE    = trim(%STAGE SPC "2");
					}
				case 2: // <block typeid="" args="">
					switch$(%eleName) {
						case "block":
							if(!%isClosing) continue;
							%blockTbl = removeWord(%blockTbl, getWordCount(%blockTbl) - 1);
							%STAGE    = trim(removeWord(%STAGE, getWordCount(%STAGE) - 1));
						case "arg":
							%argIndex = Scratch::xmlParser_getElementTag(%line, "index");
							%argType  = Scratch::xmlParser_getElementTag(%line, "type");
							%argValue = Scratch::xmlParser_getElementTag(%line, "value");
							%blockObj = getWord(%blockTbl, getWordCount(%blockTbl) - 1);
							
							if(%argType $= "string" && %isClosing) {
								if(!Scratch::setValue(%blockObj, %argIndex, %argValue, 1)) {
									warn("WARNING |  Scratch::loadWorkspace  | " @ %file @ " Line: " @ %lineNo @ " - Connection error occurred");
								}
							} else if(%argType $= "block" && !%isClosing) {
								%STAGE = trim(%STAGE SPC "3");
							}
						case "inner":
							if(!%isClosing) %STAGE = trim(%STAGE SPC "4");
					}
				case 3: // <arg index="0" type="block">
					switch$(%eleName) {
						case "arg":
							if(!%isClosing) continue;
							%STAGE = trim(removeWord(%STAGE, getWordCount(%STAGE) - 1));
						case "block":
							%typeid   = Scratch::xmlParser_getElementTag(%line, "typeid");
							%args     = Scratch::xmlParser_getElementTag(%line, "args");
							%newObj   = Scratch::createPremadeBlock(%typeid, %args);
							%blockObj = getWord(%blockTbl, getWordCount(%blockTbl) - 1);
							
							Scratch_Content.add(%newObj);
							
							if(!isObject(%newObj)) {
								error("ERROR   |  Scratch::loadWorkspace  | " @ %file @ " Line: " @ %lineNo @ " - Could not create block with ID " @ %typeID);
								return 0;
							}
							
							if(!Scratch::setValue(%blockObj, %argIndex, %newObj, 1)) {
								warn("WARNING |  Scratch::loadWorkspace  | " @ %file @ " Line: " @ %lineNo @ " - Connection error occurred");
							}
							
							%blockTbl     = trim(%blockTbl SPC %newObj);
							%STAGE        = trim(%STAGE SPC "2");
					}
				case 4: // <inner>
					switch$(%eleName) {
						case "inner": if(!%isClosing) continue; %STAGE = trim(removeWord(%STAGE, getWordCount(%STAGE) - 1));
						case "block":
							%typeid   = Scratch::xmlParser_getElementTag(%line, "typeid");
							%args     = Scratch::xmlParser_getElementTag(%line, "args");
							%newObj   = Scratch::createPremadeBlock(%typeid, %args);
							%blockObj = getWord(%blockTbl, getWordCount(%blockTbl) - 1);
							
							Scratch_Content.add(%newObj);
							
							if(!isObject(%newObj)) {
								error("ERROR   |  Scratch::loadWorkspace  | " @ %file @ " Line: " @ %lineNo @ " - Could not create block with ID " @ %typeID);
								return 0;
							}
							
							Scratch::attachBlock(%newObj, %blockObj, "insidetop");
							%blockTbl = trim(%blockTbl SPC %newObj);
							%STAGE    = trim(%STAGE SPC "2");
					}
			}
			continue;
		}
		
		switch$(%eleName) {
			case "connectionchain":
				%connectionPosition = Scratch::xmlParser_getElementTag(%line, "position");
				if(!%isClosing) %STAGE = 1;
		}
	}
	
	return 1;
}

function Scratch::getWorkspaceBlockCount(%file) {
	if(fileExt(%file) !$= ".sws") {
		error("ERROR   | Scratch::getWorkspaceB | Failed to save workspace [\"File extension is invalid -- Must be .sws\"]");
		messageBoxOK("ERROR - Scratch", "File extension must be '.sws'.");
		return 0;
	}
	if(!isFile(%file)) {
		error("ERROR   | Scratch::getWorkspaceB | Failed to load workspace [\"File does not exist\"]");
		return 0;
	}
	
	// Init vars
	%blockCount = 0;
	%SO         = new FileObject();
	%SO.openForRead(%file);
	
	// Read file
	while(!%SO.isEOF()) {
		%line = trim(%SO.readLine());
		if(%line $= "") continue;
		
		%fTxt = Scratch::xmlParser_removeQuotedText(%line);
		
		while(%fTxt !$= "") {
			if((%start = strIPos(%fTxt, "<")) != -1 && (%end = strIPos(%fTxt, ">")) != -1) {
				%element = getSubStr(%line, %start, %end + 1);
				%line    = getSubStr(%line, %end + 1, strLen(%line));
				%fTxt    = getSubStr(%fTxt, %end + 1, strLen(%fTxt));
				
				if(getSubStr(%element, 0, 4) $= "<!--") continue; // Ignore comment lines
				
				%element[-1 + %elementCount++] = %element;
			} else break;
		}
	}
	
	// Clean up
	%SO.close();
	%SO.delete();
	
	// Parse XML elements
	for(%i=0;%i<%elementCount;%i++) {
		%line   = %element[%i];
		
		%eleName   = Scratch::xmlParser_getElementName(%line);
		%isClosing = Scratch::xmlParser_isClosingElement(%line);
		
		if(%isClosing && %eleName $= "block") %blockCount++;
	}
	
	return %blockCount;
}