$Scratch::TooltipSystem::FontType = "Consolas";
$Scratch::TooltipSystem::FontSize = "14";
$Scratch::TooltipSystem::CurrText = "";
$Scratch::TooltipSystem::isActive = 0;
$Scratch::TooltipSystem::PushTime = 0;
$Scratch::TooltipSystem::MaxWidth = 300;
$Scratch::TooltipSystem::closeReq = 0;
$Scratch::TooltipSystem::mouseMov = 0;
$Scratch::TooltipSystem::mouseCac = "";
$Scratch::TooltipSystem::currObjc = -1;

function Scratch::getFormattedTooltip(%object) {
	if(!isObject(%object)) return "";
	if(!ScratchContainer.isMember(%object)) return "";
	if((%str = %object.toolTipHelp) $= "") return "";
	for(%i=0;%i<%object.blockArgCount;%i++) {
		%child = %object.blockArgObject[%i];
		if(isObject(%child_child = %child.innerConnection_Child))
			%str = strReplace(%str, "%" @ %i+1, "<color:DD0000>" @ Scratch::getValue(%child_child) @ "<color:000000>");
		else if(isObject(%txtEd = %child.textEdit))
			%str = strReplace(%str, "%" @ %i+1, "<color:DD0000>" @ %txtEd.getValue() @ "<color:000000>");
	}
	%table = %object.delimiterObjectTable;
	if(strIPos(%str, "%@") != -1) { // Get all delimiters and replace %@ with their values
		for(%i=getWordCount(%table)-1;%i>=0;%i--) {
			%child = getWord(%table, %i);
			if(!isObject(%child)) {
				%object.delimiterObjectTable = removeWord(%object.delimiterObjectTable, %i);
				%table = removeWord(%table, %i);
				%i--;
				continue;
			}
			if(isObject(%child_child = %child.innerConnection_Child))
				%buffer = (%buffer $= "" ? "" : %buffer @ %object.delimiterChar @ " ") @ Scratch::getValue(%child_child);
			else if(isObject(%txtEd = %child.textEdit))
				%buffer = (%buffer $= "" ? "" : %buffer @ %object.delimiterChar @ " ") @ %txtEd.getValue();
		}
		%str = strReplace(%str, "%@", "<color:DD0000>" @ %buffer @ "<color:000000>");
	}
	if(%object.createdBy !$= "") %str = %str @ "<br><br>Created by <color:DD0000>" @ %object.createdBy @ "<color:000000>";
	%str = %str @ "<br><br>Exports to \"<color:DD0000>" @ Scratch::getValue(%object) @ "<color:000000>\"";
	return %str;
}

function Scratch::pushTooltip(%text, %flag, %x, %y, %callBack) {
	$Scratch::TooltipSystem::CurrText = %text;
	if($Scratch::TooltipSystem::isActive && $Scratch::TooltipSystem::DoNotClose) { $Scratch::TooltipSystem::DoNotFadeIn = 1; $Scratch::TooltipSystem::isActive = 0; }
	$Scratch::TooltipSystem::OnlyTimeout = 0;
	$Scratch::TooltipSystem::DoNotClose  = 0;
	$Scratch::TooltipSystem::OnlyClick   = 0;
	$Scratch::TooltipSystem::CallBack    = %callBack;
	switch(%flag) {
		case 1: $Scratch::TooltipSystem::OnlyTimeout = 1; // Dont dissapear until timeout is reached
		case 2: $Scratch::TooltipSystem::DoNotClose  = 1; // Do not close until a new tooltip is pushed
		case 3: $Scratch::TooltipSystem::OnlyClick   = 1; // Do not close until the user clicks on the tooltip
	}
	if(%x !$= "" && %y !$= "") $Scratch::TooltipSystem::Position = %x SPC %y;
}

function Scratch::getStringWidth(%str) {
	%w = ($Scratch::ToolTipSystem::FontSize/2);
	return strLen(%str)*%w;
}

function Scratch_playTooltipAnimation(%type) {
	if(isEventPending($CACHE::Scratch::TooltipSystem::TooltipAnimationSchedule)) return;
	%this  = Scratch_ToolTip;
	%speed = 20;
	switch(%type) {
		case 0: // Fade in
			if(getWord(%this.color, 3) >= 255-(%speed*2) || $Scratch::TooltipSystem::DoNotFadeIn) {
				$Scratch::TooltipSystem::DoNotFadeIn = 0;
				%this.color              = "225 213 123 255";
				%this.getObject(0).color = "255 243 153 255";
				return;
			}
			%this.color              = setWord(%this.color, 3, getWord(%this.color, 3)+%speed);
			%this.getObject(0).color = setWord(%this.getObject(0).color, 3, getWord(%this.getObject(0).color, 3)+%speed);
		case 1: // Fade out
			if(getWord(%this.color, 3) <= %speed*2) {
				%this.setVisible(0);
				%this.color              = "225 213 123 255";
				%this.getObject(0).color = "255 243 153 255";
				if((%info = Struct_funcCall($Scratch::TooltipSystem::CallBack)) !$= "") {
					%nameSpace = getRecord(%info, 0);
					%funcName  = getRecord(%info, 1);
					%funcArgs  = getRecord(%info, 2);
					if(!isFunction(%funcName)) if(!isFunction(%nameSpace, %funcName)) return;
					eval((%nameSpace !$= "" ? %nameSpace @ "::" : "") @ %funcName @ "(" @ strReplace(%funcArgs, "\t", ",") @ ");");
				}
				return;
			}
			%this.color              = setWord(%this.color, 3, getWord(%this.color, 3)-%speed);
			%this.getObject(0).color = setWord(%this.getObject(0).color, 3, getWord(%this.getObject(0).color, 3)-%speed);
		default: error("ERROR: Scratch::playTooltipAnimation() - Invalid animation type " @ %type); return;
	}
	cancel($CACHE::Scratch::TooltipSystem::TooltipAnimationSchedule);
	$CACHE::Scratch::TooltipSystem::TooltipAnimationSchedule = schedule(15, 0, Scratch_playTooltipAnimation, %type);
}

function Scratch::closeToolTip() {
	if(!$Scratch::TooltipSystem::isActive) return;
	$Scratch::TooltipSystem::closeReq = 1;
}

function Scratch::renderTooltip(%bypassRestrictions) {
	if(Canvas.getObject(Canvas.getCount()-1).getName() !$= "ScratchGui" && !%bypassRestrictions) return;
	if(Scratch_RightClickMenu.isVisible() && !%bypassRestrictions) return;
	if(!$Scratch::TooltipSystem::isActive && $Scratch::TooltipSystem::CurrText $= "") {
		%curPos = Canvas.getCursorPos();
		%curX   = getWord(%curPos, 0);
		%curY   = getWord(%curPos, 1);
		for(%i=0;%i<ScratchGui.getCount();%i++) {
			%object = ScratchGui.getObject(%i);
			if(%object.getName() $= "Scratch_MainWindow") { %canBlock = 1; continue; }
			if(!%canBlock) continue;
			if(%curX >= %object.getLeft() && %curX <= %object.getRight() && %curY >= %object.getTop() && %curY <= %object.getBottom()) return;
		}
		if(Scratch_ProjectManager.isVisible()) return;
		if(vectorDist($Scratch::TooltipSystem::mouseCac, %curPos) >= 2) {
			$Scratch::TooltipSystem::mouseCac = %curPos;
			$Scratch::TooltipSystem::mouseMov = getSimTime();
		}
		if(getSimTime()-$Scratch::TooltipSystem::mouseMov >= 600) {
			%this = ScratchContainer;
			%offX = Scratch_Content.getGroup().getLeft()+Scratch_Content.getGroup().getGroup().getLeft();
			%offY = Scratch_Content.getGroup().getTop()+Scratch_Content.getGroup().getGroup().getTop();
			for(%i=0;%i<=%this.getCount();%i++) {
				if(%i == %this.getCount()) { %object = 0; break; }
				%object = %this.getObject(%i);
				if(%object.status $= "DRAG") { %object = 0; break; } // The user is dragging a block; don't interrupt them.
				%objX   = %object.getLeft()+%offX;
				%objY   = %object.getTop()+%offY;
				%objR   = %objX+%object.getWidth();
				%objB   = %objY+%object.getHeight();
				if(%curX >= %objX && %curX <= %objR && %curY >= %objY && %curY <= %objB) break;
			}
			if(isObject(%object)) {
				%text = Scratch::getFormattedTooltip(%object);
				Scratch::pushTooltip(%text, 0);
				$Scratch::TooltipSystem::currObjc = %object;
			}
		}
	}
	if((%text = $Scratch::TooltipSystem::CurrText) $= "") return;
	ScratchGui.pushToBack(Scratch_ToolTip);
	if(isObject(Scratch_ToolTip_Indicator)) ScratchGui.pushToBack(Scratch_ToolTip_Indicator);
	if(!$Scratch::TooltipSystem::isActive) {
		$Scratch::TooltipSystem::isActive  = 1;
		$Scratch::TooltipSystem::PushTime  = getSimTime();
		Scratch_ToolTip.color              = "225 213 123 0";
		Scratch_ToolTip.getObject(0).color = "225 213 123 0";
		Scratch_ToolTip.getObject(0).text  = "";
		Scratch_ToolTip.setVisible(1);
		ScratchGui.pushToBack(Scratch_ToolTip);
		// Calculate the width and height of the text box
		%textTmp  = $Scratch::TooltipSystem::CurrText;
		%textTmp  = strReplace(%textTmp, "<br>", "\n");
		%biggestW = 0;
		%biggestH = 0;
		%textFmt  = "";
		for(%i=0;%i<getRecordCount(%textTmp);%i++) {
			%txt   = stripMLControlChars(getRecord(%textTmp, %i));
			%width = Scratch::getStringWidth(%txt);
			%x     = 0;
			for(%j=0;%j<getWordCount(%txt);%j++) {
				%word  = getWord(%txt, %j);
				%width = Scratch::getStringWidth(%word);
				if(%x+%width >= $Scratch::TooltipSystem::MaxWidth) {
					%x = %width;
					%textFmt = %textFmt @ "\n" @ %word;
					continue;
				}
				%x      += %width;
				%textFmt = %textFmt SPC %word;
			}
			%textFmt = %textFmt @ "\n";
		}
		%textFmt = trim(%textFmt);
		for(%i=0;%i<getRecordCount(%textFmt);%i++) {
			%txt     = stripMLControlChars(getRecord(%textFmt, %i));
			%width   = Scratch::getStringWidth(%txt);
			if(%width >= %biggestW) %biggestW = %width;
			%biggestH += $Scratch::TooltipSystem::FontSize;
		}
		%width  = %biggestW+6;
		%height = %biggestH+6;
		Scratch_ToolTip.getObject(0).getObject(0).setText("<font:" @ $Scratch::TooltipSystem::FontType @ ":" @ $Scratch::TooltipSystem::FontSize @ "><color:000000>" @ $Scratch::TooltipSystem::CurrText);
		Scratch_ToolTip.resize(getWord(Canvas.getCursorPos(), 0), getWord(Canvas.getCursorPos(), 1), %width, %height);
		Scratch_ToolTip.getObject(0).getObject(0).resize(3, 3, %width, %height);
		if($Scratch::TooltipSystem::Position !$= "") {
			%absPos = $Scratch::TooltipSystem::Position;
			%xPos   = getWord(%absPos, 0);
			%yPos   = getWord(%absPos, 1);
			if(!isObject(Scratch_ToolTip_Indicator)) {
				%newObj = new GuiBitmapCtrl(Scratch_ToolTip_Indicator) {
					position    = "0 0";
					extent      = "12 12";
					minExtent   = "12 12";
					bitmap      = "Add-Ons/Client_Scratch/img/tutBoxBtm_Left";
				};
				ScratchGui.add(%newObj);
			}
			Scratch_ToolTip_Indicator.setBitmap("Add-Ons/Client_Scratch/img/tutBoxBtm_Left");
			Scratch_ToolTip_Indicator.setVisible(1);
			if(Scratch_Tooltip.getTop() < 0) {
				// tooltip box will not be seen (it will be higher than ScratchGui)
				Scratch_ToolTip.resize(%xPos-2, %yPos+11, Scratch_ToolTip.getWidth(), Scratch_ToolTip.getHeight());
				Scratch_ToolTip_Indicator.resize(Scratch_ToolTip.getLeft()+3, Scratch_ToolTip.getTop()-11, 12, 12);
				Scratch_ToolTip_Indicator.setBitmap("Add-Ons/Client_Scratch/img/tutBoxBtm_topLeft");
				%top = 1;
			} else {
				Scratch_ToolTip.resize(%xPos-2, %yPos-Scratch_ToolTip.getHeight()-11, Scratch_ToolTip.getWidth(), Scratch_ToolTip.getHeight());
				Scratch_ToolTip_Indicator.resize(Scratch_ToolTip.getLeft()+3, Scratch_ToolTip.getBottom()-1, 12, 12);
			}
			if(Scratch_ToolTip.getRight() >= Canvas.getWidth()) {
				// Cuts off by the right of the screen
				Scratch_Tooltip.resize(Scratch_Tooltip_Indicator.getRight()-(Scratch_Tooltip.getWidth()-3), Scratch_Tooltip.getTop(), Scratch_Tooltip.getWidth(), Scratch_Tooltip.getHeight());
				if(Scratch_ToolTip_Indicator.getLeft() >= Scratch_Tooltip.getLeft()+(Scratch_Tooltip.getWidth()/2)) {
					Scratch_Tooltip_Indicator.setBitmap("Add-Ons/Client_Scratch/img/" @ (!%top ? "tutBoxBtm_Right" : "tutBoxBtm_TopRight"));
				}
			}
		}
		$Scratch::TooltipSystem::Position = "";
		Scratch_playTooltipAnimation(0);
	}
	if(isObject(%object = $Scratch::TooltipSystem::currObjc)) {
		%curPos  = Canvas.getCursorPos();
		%curX    = getWord(%curPos, 0);
		%curY    = getWord(%curPos, 1);
		%offX    = Scratch_Content.getGroup().getLeft()+Scratch_Content.getGroup().getGroup().getLeft();
		%offY    = Scratch_Content.getGroup().getTop()+Scratch_Content.getGroup().getGroup().getTop();
		%objX    = %object.getLeft()+%offX;
		%objY    = %object.getTop()+%offY;
		%objR    = %objX+%object.getWidth();
		%objB    = %objY+%object.getHeight();
		%isValid = ((%curX >= %objX && %curX <= %objR && %curY >= %objY && %curY <= %objB) ? 1 : 0);
		if(!%isValid) {
			%object  = Scratch_ToolTip;
			%objX    = %object.getLeft();
			%objY    = %object.getTop();
			%objR    = %objX+%object.getWidth();
			%objB    = %objY+%object.getHeight();
			%isValid = ((%curX >= %objX && %curX <= %objR && %curY >= %objY && %curY <= %objB) ? 1 : 0);
		}
	} else %isValid = 1;
	if(!$Scratch::TooltipSystem::DoNotClose) {
		if(!$Scratch::TooltipSystem::OnlyClick && getSimTime()-$Scratch::TooltipSystem::PushTime >= 5000) %close = 1;
		if(!$Scratch::TooltipSystem::OnlyTimeout && $Scratch::TooltipSystem::closeReq) %close = 1;
		if(!$Scratch::TooltipSystem::OnlyTimeout && !$Scratch::TooltipSystem::OnlyClick && !%isValid) %close = 1;
	}
	if(%close) {
		$Scratch::TooltipSystem::closeReq = 0;
		$Scratch::TooltipSystem::CurrText = "";
		$Scratch::TooltipSystem::isActive = 0;
		$Scratch::TooltipSystem::currObjc = "";
		Scratch_ToolTip.getObject(0).text = "";
		if(isObject(Scratch_ToolTip_Indicator)) Scratch_ToolTip_Indicator.setVisible(0);
		Scratch_playTooltipAnimation(1);
	}
		
}