function Scratch::queryTutorial() {
	if($Pref::Scratch::DoneWithTutorial) return;
	$CACHE::Scratch::Tutorial::Stage = "";
	messageBoxYesNo("Tutorial - Scratch Editor", "It seems like you are new here. Do you want to take a tutorial to help get familiar with this add-on?", "Scratch::stepTutorial();", "$Pref::Scratch::DoneWithTutorial=1;");
}

function Scratch::tut_getAbsolutePosition(%this) {
	if(!isObject(%this)) return;
	%object = %this;
	%absPos = "0 0";
	while(isObject(%object) && %object.getName() !$= "ScratchGui") {
		if(%dbg++ >= 100) { echo("Broke tut_getAbsolutePosition"); break; }
		%absPos = vectorAdd(%absPos, %object.getPosition());
		%object = %object.getGroup();
	}
	return getWords(%absPos, 0, 1);
}

function Scratch::stepTutorial() {
	if($CACHE::Scratch::Tutorial::Stage $= "") $CACHE::Scratch::Tutorial::Stage = 0;
	switch($CACHE::Scratch::Tutorial::Stage) {
		case 0:
			messageBoxOK("Tutorial - Scratch Editor", "Welcome to Scratch for Blockland!<br>Here, you can create & edit script files for Blockland easily.", "Scratch::stepTutorial();");
			$CACHE::Scratch::Tutorial::Stage++;
			return;
		case 1:
			%focusObj = Scratch_ProjManagerButton;
			%absPos   = Scratch::tut_getAbsolutePosition(%focusObj);
			%absPos   = vectorAdd(%absPos, %focusObj.getWidth());
			Scratch::pushTooltip("Click here to open the spawn menu.", 2, getWord(%absPos, 0), getWord(%absPos, 1));
			return;
		case 2:
			%focusObj = Scratch::spawnMenu_getSearchBar();
			%absPos   = Scratch::tut_getAbsolutePosition(%focusObj);
			%absPos   = vectorAdd(%absPos, %focusObj.getWidth()/2 SPC %focusObj.getHeight()/2);
			Scratch::pushTooltip("This is the search bar. You can quickly find any block you need with this.\n\nClick on this tooltip to continue.", 3, getWord(%absPos, 0), getWord(%absPos, 1), "Scratch::stepTutorial();");
			$CACHE::Scratch::Tutorial::Stage++;
			return;
		case 3:
			%focusObj = Scratch_ProjectManager_RightMenu.getObject(0);
			%absPos   = Scratch::tut_getAbsolutePosition(%focusObj);
			%absPos   = vectorAdd(%absPos, %focusObj.getWidth()/2 SPC %focusObj.getHeight()/2);
			Scratch::pushTooltip("This button allows you to convert your blocks into scripts that Blockland can run!\n\nClick on this tooltip to continue.", 3, getWord(%absPos, 0), getWord(%absPos, 1), "Scratch::stepTutorial();");
			$CACHE::Scratch::Tutorial::Stage++;
			return;
		case 4:
			%focusObj = Scratch_ProjectManager_RightMenu.getObject(1);
			%absPos   = Scratch::tut_getAbsolutePosition(%focusObj);
			%absPos   = vectorAdd(%absPos, %focusObj.getWidth()/2 SPC %focusObj.getHeight()/2);
			Scratch::pushTooltip("This button allows you to clear the workspace.\n\nClick on this tooltip to continue.", 3, getWord(%absPos, 0), getWord(%absPos, 1), "Scratch::stepTutorial();");
			$CACHE::Scratch::Tutorial::Stage++;
			return;
		case 5:
			%focusObj = Scratch_ProjectManager_RightMenu.getObject(2);
			%absPos   = Scratch::tut_getAbsolutePosition(%focusObj);
			%absPos   = vectorAdd(%absPos, %focusObj.getWidth()/2 SPC %focusObj.getHeight()/2);
			Scratch::pushTooltip("This button allows you to import script files into your workspace.\n\nClick on this tooltip to continue.", 3, getWord(%absPos, 0), getWord(%absPos, 1), "Scratch::stepTutorial();");
			$CACHE::Scratch::Tutorial::Stage++;
			return;
		case 6:
			%focusObj = Scratch_ProjectManager_RightMenu.getObject(4);
			%absPos   = Scratch::tut_getAbsolutePosition(%focusObj);
			%absPos   = vectorAdd(%absPos, %focusObj.getWidth()/2 SPC %focusObj.getHeight()/2);
			Scratch::pushTooltip("This button opens a menu in which you can debug your scripts so that they work just right.\n\nClick on this tooltip to continue.", 3, getWord(%absPos, 0), getWord(%absPos, 1), "Scratch::stepTutorial();");
			$CACHE::Scratch::Tutorial::Stage++;
			return;
		case 7:
			%focusObj = Scratch_ProjectManager_RightMenu.getObject(5);
			%absPos   = Scratch::tut_getAbsolutePosition(%focusObj);
			%absPos   = vectorAdd(%absPos, %focusObj.getWidth()/2 SPC %focusObj.getHeight()/2);
			Scratch::pushTooltip("Want a coder to help you out? Join / create a collaboration session with them so that they can help you in real time!\n\nClick on this tooltip to continue.", 3, getWord(%absPos, 0), getWord(%absPos, 1), "Scratch::stepTutorial();");
			$CACHE::Scratch::Tutorial::Stage++;
			return;
		case 8:
			%focusObj = Scratch_ProjectManager_RightMenu.getObject(6);
			%absPos   = Scratch::tut_getAbsolutePosition(%focusObj);
			%absPos   = vectorAdd(%absPos, %focusObj.getWidth()/2 SPC %focusObj.getHeight()/2);
			Scratch::pushTooltip("If you are having a hard time finding what functions to use, then this menu is for you! It lists all common functions in Blockland with a description and category.\n\nClick on this tooltip to continue.", 3, getWord(%absPos, 0), getWord(%absPos, 1), "Scratch::stepTutorial();");
			$CACHE::Scratch::Tutorial::Stage++;
			return;
		case 9:
			if(Scratch_ProjectManager_SpawnMenuContent.getCount() < 2) {
				messageBoxOK("Error - Scratch Editor", "Failed to find any spawn menu items to focus on.");
				return;
			}
			%focusObj = Scratch_ProjectManager_SpawnMenuContent.getObject(2);
			%absPos   = Scratch::tut_getAbsolutePosition(%focusObj);
			%absPos   = vectorAdd(%absPos, %focusObj.getWidth());
			Scratch::pushTooltip("Hover over these buttons to see the description\nof the block, and click on them to spawn it. Try spawning this block!", 2, getWord(%absPos, 0), getWord(%absPos, 1));
			return;
		case 10:
			%focusObj = ScratchContainer.getObject(0);
			%absPos   = Scratch::tut_getAbsolutePosition(%focusObj);
			%absPos   = vectorAdd(%absPos, %focusObj.getWidth() SPC "0 0");
			Scratch::pushTooltip("You can manipulate these blocks in many different ways!\n\nYou can drag them around, right click on them for a menu, and connect them to other blocks.\n\nClick on this tooltip box to continue.", 3, getWord(%absPos, 0), getWord(%absPos, 1), "Scratch::stepTutorial();");
			$CACHE::Scratch::Tutorial::Stage++;
			return;
		case 11:
			%focusObj = ScratchContainer.getObject(0).blockArgObject[0];
			%absPos   = Scratch::tut_getAbsolutePosition(%focusObj);
			%absPos   = vectorAdd(%absPos, %focusObj.getWidth()/2 SPC %focusObj.getHeight()/2 SPC "0");
			Scratch::pushTooltip("This is an argument box. You can place blocks inside of them, and even type in them.\n\nNot all blocks have argument boxes that you can both put blocks and text in; Sometimes, a\nblock will have an argument box exclusive to one action, be it blocks or text. Look out for those; they're exclusive for a reason.\n\nClick on this tooltip box to continue.", 3, getWord(%absPos, 0), getWord(%absPos, 1), "Scratch::stepTutorial();");
			$CACHE::Scratch::Tutorial::Stage++;
			return;
		case 12:
			$Pref::Scratch::DoneWithTutorial = 1;
			messageBoxOK("Tutorial - Scratch Editor", "That's all I can think of for the tutorial at this moment. I would love suggestions on what to include in this, to help users get familiar with the system.\n\n- Clay Hanson");
			return;
	}
}